
-- EU_ENGIN.E
--
-- Author - Bernard W. Ryan
-- Copyright (c) December 2000 Xotron
-- Verison 1.05
--
-- Last Revision Date December 2000
--
-- References and Credits:
--
--    RDS
--    Jack E. Bresenham's algorithms
--    UCR's Assembler Library
--    Tran's PCM
--    Jiri Babor
--    Pete Eberlein
--    David Cuny
--    Carl White
--    Joseph (Yossi) Gil - fonts
--    VGAlib version 1.2 - (c) 1993 Tommy Frandsen
--    Extended for svgalib by Harm Hanemaayer and Hartmut Schirmer
--    Daniel Engstrm -- VGAJOYSTICK code
--    Author C. Smith -- VGAJOYSTICK code
--    Vojtech Pavlik  -- VGAJOYSTICK code
--    Michael Weller  -- VGAJOYSTICK code
--    VGA, VGAJOYSTICK, VGAKEYBOARD, VGAMOUSE header files
--    And anyone else I missed, because the origin of some reference
--    may not be clear or I just forgot to mention your name.
--
-- This program code is distributed to help you acquire the skills needed
-- to do Euphoria Graphics programming in the Linux enviorment.
-- It is intended for educationl purposes only, WITHOUT ANY WARRANTY;
-- without even the implied warranty of MERCHANTABILITY or FITNESS FOR
-- A OR ANY PARTICULAR PURPOSE.
--
-- You have permission to use this code to learn Euphoria programming
-- provided that you AGREE THAT THE AUTHOR or any other sources of origin or
-- derivations have no warranty, obligation or liability for its contents
-- or use.
--
-- USE AT YOUR OWN RISK !
--
-- ANY USE OF ANY PORTION OF THIS CODE IN ANY COMMERCIAL PRODUCT IS
-- SUBJECT TO PERMISSION FROM ALL COPYRIGHT OWNERS AND LICENSES.
--
-- ==========================================================================
-- ==========================================================================
-- EU_ENGIN.E
-- ==========================================================================
-- ==========================================================================
--
global constant
copyright = "\n"&
" Author - Bernard W. Ryan - Xotron                                       \n"&
" Copyright (c) December 2000                                             \n"&
" Verison 1.00                           Last Revision Date December 2000 \n"
--
-- ==========================================================================
-- ==========================================================================
-- EU_ENGIN.E
-- ==========================================================================
-- ==========================================================================

include wildcard.e  -- RDS include file
include machine.e   -- RDS include file
include sort.e      -- RDS include file
include misc.e      -- RDS include file
include get.e       -- RDS include file
include dll.e       -- RDS include file

-- ==========================================================================
-- ==========================================================================
--------------------------< CONSTANT DEFINITIONS >---------------------------
-- ==========================================================================

global constant
TEXT         = 0,                -- Compatible with VGAlib v1.2
G320x200x16  = 1,
G640x200x16  = 2,
G640x350x16  = 3,
G640x480x16  = 4,
G320x200x256 = 5,
G320x240x256 = 6,
G320x400x256 = 7,
G360x480x256 = 8,
G640x480x2   = 9,
--
G640x480x256  = 10,
G800x600x256  = 11,
G1024x768x256 = 12,
--
G1280x1024x256 = 13,        -- Additional modes.
--
G320x200x32K = 14,
G320x200x64K = 15,
G320x200x16M = 16,
G640x480x32K = 17,
G640x480x64K = 18,
G640x480x16M = 19,
G800x600x32K = 20,
G800x600x64K = 21,
G800x600x16M = 22,
G1024x768x32K = 23,
G1024x768x64K = 24,
G1024x768x16M = 25,
G1280x1024x32K = 26,
G1280x1024x64K = 27,
G1280x1024x16M = 28,
--
G800x600x16 = 29,
G1024x768x16 = 30,
G1280x1024x16 = 31,
--
G720x348x2 = 32,            -- Hercules emulation mode
--
G320x200x16M32 = 33,        -- 32-bit per pixel modes.
G640x480x16M32 = 34,
G800x600x16M32 = 35,
G1024x768x16M32 = 36,
G1280x1024x16M32 = 37,
-- additional resolutions
G1152x864x16 = 38,
G1152x864x256 = 39,
G1152x864x32K = 40,
G1152x864x64K = 41,
G1152x864x16M = 42,
G1152x864x16M32 = 43,
--
G1600x1200x16 = 44,
G1600x1200x256 = 45,
G1600x1200x32K = 46,
G1600x1200x64K = 47,
G1600x1200x16M = 48,
G1600x1200x16M32 = 49,
--
G320x240x256V = 50,
G320x240x32K = 51,
G320x240x64K = 52,
G320x240x16M = 53,
G320x240x16M32 = 54,
--
G400x300x256 = 55,
G400x300x32K = 56,
G400x300x64K = 57,
G400x300x16M = 58,
G400x300x16M32 = 59,
--
G512x384x256 = 60,
G512x384x32K = 61,
G512x384x64K = 62,
G512x384x16M = 63,
G512x384x16M32 = 64,
--
G960x720x256 = 65,
G960x720x32K = 66,
G960x720x64K = 67,
G960x720x16M = 68,
G960x720x16M32 = 69,
--
G1920x1440x256 = 70,
G1920x1440x32K = 71,
G1920x1440x64K = 72,
G1920x1440x16M = 73,
G1920x1440x16M32 = 74,
-- The following = modes have been introduced by SciTech Display Doctor
G320x400x256V = 75,
G320x400x32K = 76,
G320x400x64K = 77,
G320x400x16M = 78,
G320x400x16M32 = 79,
--
G640x400x256 = 80,
G640x400x32K = 81,
G640x400x64K = 82,
G640x400x16M = 83,
G640x400x16M32 = 84,
--
G320x480x256 = 85,
G320x480x32K = 86,
G320x480x64K = 87,
G320x480x16M = 88,
G320x480x16M32 = 89,
--
G720x540x256 = 90,
G720x540x32K = 91,
G720x540x64K = 92,
G720x540x16M = 93,
G720x540x16M32 = 94,
--
G848x480x256 = 95,
G848x480x32K = 96,
G848x480x64K = 97,
G848x480x16M = 98,
G848x480x16M32 = 99,
--
G1072x600x256 = 100,
G1072x600x32K = 101,
G1072x600x64K = 102,
G1072x600x16M = 103,
G1072x600x16M32 = 104,
--
G1280x720x256 = 105,
G1280x720x32K = 106,
G1280x720x64K = 107,
G1280x720x16M = 108,
G1280x720x16M32 = 109,
--
G1360x768x256 = 110,
G1360x768x32K = 111,
G1360x768x64K = 112,
G1360x768x16M = 113,
G1360x768x16M32 = 114,
--
G1800x1012x256 = 115,
G1800x1012x32K = 116,
G1800x1012x64K = 117,
G1800x1012x16M = 118,
G1800x1012x16M32 = 119,
--
G1920x1080x256 = 120,
G1920x1080x32K = 121,
G1920x1080x64K = 122,
G1920x1080x16M = 123,
G1920x1080x16M32 = 124,
--
G2048x1152x256 = 125,
G2048x1152x32K = 126,
G2048x1152x64K = 127,
G2048x1152x16M = 128,
G2048x1152x16M32 = 129,
--
G2048x1536x256 = 130,
G2048x1536x32K = 131,
G2048x1536x64K = 132,
G2048x1536x16M = 133,
G2048x1536x16M32 = 134,
--
G512x480x256 = 135,
G512x480x32K = 136,
G512x480x64K = 137,
G512x480x16M = 138,
G512x480x16M32 = 139,
--
G400x600x256 = 140,
G400x600x32K = 141,
G400x600x64K = 142,
G400x600x16M = 143,
G400x600x16M32 = 144,
--
-- #define __GLASTMODE G400x600x16M32
-- NOTE* leading underscore not supported by Euphoria so use this
exu__GLASTMODE = G400x600x16M32,
-- #define GLASTMODE vga_lastmodenumber()
-- Euphoria -- This function define farther down in library
--
-- Extensions to VGAlib v1.2:
-- blit flags
HAVE_BITBLIT = 1,
HAVE_FILLBLIT = 2,
HAVE_IMAGEBLIT = 4,
HAVE_HLINELISTBLIT = 8,
HAVE_BLITWAIT = 16,
-- other flags
HAVE_RWPAGE = 1,         -- vga_setreadpage() / vga_setwritepage() available
IS_INTERLACED = 2,       -- mode is interlaced
IS_MODEX = 4,            -- ModeX style 256 colors
IS_DYNAMICMODE = 8,      -- Dynamic defined mode
CAPABLE_LINEAR = 16,     -- Can go to linear addressing mode.
IS_LINEAR = 32,          -- Linear addressing enabled.
EXT_INFO_AVAILABLE = 64, -- Returned modeinfo contains valid extended fields
RGB_MISORDERED = 128,    -- Mach32 32bpp uses 0BGR instead of BGR0.
-- As of this version 1.25 also used to signal if real RGB
--   (red first in memory) is used instead of BGR (Mach32 DAC 4)
HAVE_EXT_SET = 256,        -- vga_ext_set() available
UNDEFINED =  0,
VGA       =  1,
ET4000    =  2,
CIRRUS    =  3,
TVGA8900  =  4,
OAK       =  5,
EGA       =  6,
S3        =  7,
ET3000    =  8,
MACH32    =  9,
GVGA6400  = 10,
ARK       = 11,
ATI       = 12,
ALI       = 13,
MACH64    = 14,
CHIPS     = 15,
APM       = 16,
NV3       = 17,
ET6000    = 18,
VESA      = 19,
MX        = 20,
PARADISE  = 21,
RAGE      = 22,
BANSHEE   = 23,
SIS       = 24,
I740      = 25,
NEOMAGIC  = 26,
			-- Hor. sync:
MON640_60   = 0,        -- 31.5 KHz (standard VGA)
MON800_56   = 1,        -- 35.1 KHz (old SVGA)
MON1024_43I = 2,        -- 35.5 KHz (low-end SVGA, 8514)
MON800_60   = 3,        -- 37.9 KHz (SVGA)
MON1024_60  = 4,        -- 48.3 KHz (SVGA non-interlaced)
MON1024_70  = 5,        -- 56.0 KHz (SVGA high frequency)
MON1024_72  = 6,
-- Valid values for what in vga_ext_set:
VGA_EXT_AVAILABLE   = 0,        -- supported flags
VGA_EXT_SET         = 1,        -- set flag(s)
VGA_EXT_CLEAR       = 2,        -- clear flag(s)
VGA_EXT_RESET       = 3,        -- set/clear flag(s)
VGA_EXT_PAGE_OFFSET = 4,        -- set an offset for all subsequent vga_set*page() calls
    -- Like: vga_ext_set(VGA_EXT_PAGE_OFFSET, 42);
    -- returns the previous offset value.
VGA_EXT_FONT_SIZE   = 5,        -- the (maximal) size of the font buffer
-- Valid params for VGA_EXT_AVAILABLE:
VGA_AVAIL_SET          = 0,        -- vga_ext_set sub funcs
VGA_AVAIL_ACCEL        = 1,        -- vga_accel sub funcs
VGA_AVAIL_FLAGS        = 2,        -- known flags for VGA_EXT_SET
VGA_AVAIL_ROP          = 3,        -- vga_accel ROP sub funcs
VGA_AVAIL_TRANSPARENCY = 4,        -- vga_accel TRANSPARENCY sub funcs
VGA_AVAIL_ROPMODES     = 5,        -- vga_accel ROP modes supported funcs
VGA_AVAIL_TRANSMODES   = 6,        -- vga_accel TRANSPARENCY modes supported
-- Known flags to vga_ext_set()
VGA_CLUT8              = 1,        -- 8 bit DAC entries
-- Acceleration interface. --
-- Accel operations. --
ACCEL_FILLBOX          =  1,        -- Simple solid fill.
ACCEL_SCREENCOPY       =  2,        -- Simple screen-to-screen BLT.
ACCEL_PUTIMAGE         =  3,        -- Straight image transfer.
ACCEL_DRAWLINE         =  4,        -- General line draw.
ACCEL_SETFGCOLOR       =  5,        -- Set foreground color.
ACCEL_SETBGCOLOR       =  6,        -- Set background color.
ACCEL_SETTRANSPARENCY  =  7,        -- Set transparency mode.
ACCEL_SETRASTEROP      =  8,        -- Set raster-operation.
ACCEL_PUTBITMAP        =  9,        -- Color-expand bitmap.
ACCEL_SCREENCOPYBITMAP = 10,        -- Color-expand from screen.
ACCEL_DRAWHLINELIST    = 11,        -- Draw horizontal spans.
ACCEL_SETMODE          = 12,        -- Set blit strategy.
ACCEL_SYNC             = 13,        -- Wait for blits to finish.
ACCEL_SETOFFSET        = 14,        -- Set screen offset
ACCEL_SCREENCOPYMONO   = 15,        -- Monochrome screen-to-screen BLT.
ACCEL_POLYLINE         = 16,        -- Draw multiple lines.
ACCEL_POLYHLINE        = 17,        -- Draw multiple horizontal spans.
ACCEL_POLYFILLMODE     = 18,        -- Set polygon mode.
-- Corresponding bitmask. --
ACCELFLAG_FILLBOX          = #1,        -- Simple solid fill.
ACCELFLAG_SCREENCOPY       = #2,        -- Simple screen-to-screen BLT.
ACCELFLAG_PUTIMAGE         = #4,        -- Straight image transfer.
ACCELFLAG_DRAWLINE         = #8,        -- General line draw.
ACCELFLAG_SETFGCOLOR       = #10,        -- Set foreground color.
ACCELFLAG_SETBGCOLOR       = #20,        -- Set background color.
ACCELFLAG_SETTRANSPARENCY  = #40,        -- Set transparency mode.
ACCELFLAG_SETRASTEROP      = #80,        -- Set raster-operation.
ACCELFLAG_PUTBITMAP        = #100,        -- Color-expand bitmap.
ACCELFLAG_SCREENCOPYBITMAP = #200,        -- Color-exand from screen.
ACCELFLAG_DRAWHLINELIST    = #400,        -- Draw horizontal spans.
ACCELFLAG_SETMODE          = #800,        -- Set blit strategy.
ACCELFLAG_SYNC             = #1000,        -- Wait for blits to finish.
ACCELFLAG_SETOFFSET        = #2000,        -- Set screen offset
ACCELFLAG_SCREENCOPYMONO   = #4000,        -- Monochrome screen-to-screen BLT.
ACCELFLAG_POLYLINE         = #8000,        -- Draw multiple lines.
ACCELFLAG_POLYHLINE        = #10000,        -- Draw multiple horizontal spans.
ACCELFLAG_POLYFILLMODE     = #20000,        -- Set polygon mode.
-- Mode for SetTransparency.
DISABLE_TRANSPARENCY_COLOR  = 0,
ENABLE_TRANSPARENCY_COLOR   = 1,
DISABLE_BITMAP_TRANSPARENCY = 2,
ENABLE_BITMAP_TRANSPARENCY  = 3,
-- Flags for SetMode (accelerator interface).
BLITS_SYNC          =  0,
BLITS_IN_BACKGROUND = #1,
-- Raster ops.
ROP_COPY   = 0,        -- Straight copy.
ROP_OR     = 1,        -- Source OR destination.
ROP_AND    = 2,        -- Source AND destination.
ROP_XOR    = 3,        -- Source XOR destination.
ROP_INVERT = 4,        -- Invert destination.
-- For the poly funcs
ACCEL_START = 1,
ACCEL_END   = 2,
--
-- valid values for what ( | is valid to combine them )
 --
VGA_MOUSEEVENT = 1,
VGA_KEYEVENT   = 2,
--
-- return value >= has bits set for mouse/keyboard events detected.
-- mouse and raw keyboard events are already handled and their bits removed
-- from *in when vga_waitevent returns.
-- VGA_KEYEVENT relates to vga_getch NOT vga_getkey.
-- return values < 0 signal errors. In this case check errno.
--
-- Background running
VGA_GOTOBACK     = -1,
VGA_COMEFROMBACK = -2,
----------------------------------------------------------------------------
----------------------------------------------------------------------------
-- Mouse interface for svgalib.
-- Can be used independently.
MOUSE_MICROSOFT    =  0,
MOUSE_MOUSESYSTEMS =  1,
MOUSE_MMSERIES     =  2,
MOUSE_LOGITECH     =  3,
MOUSE_BUSMOUSE     =  4,
MOUSE_PS2          =  5,
MOUSE_LOGIMAN      =  6,
MOUSE_GPM          =  7,
MOUSE_SPACEBALL    =  8,
MOUSE_NONE         =  9,  -- Some special number for a non supported/existing mouse
MOUSE_INTELLIMOUSE = 10,
MOUSE_IMPS2        = 11,
MOUSE_ORIENTATION_VERTICAL   = 0,
MOUSE_ORIENTATION_HORIZONTAL = 1,
MOUSE_ACCEL_TYPE_NORMAL =  1,
MOUSE_ACCEL_TYPE_POWER  =  2,
DEFAULT_ACCEL_THRESH    =  5,
DEFAULT_ACCEL_POWER     =  1.2,
DEFAULT_ACCEL_OFFSET    =  1,
DEFAULT_ACCEL_MULT      = 10,
DEFAULT_MAXDELTA        =  0,
DEFAULT_ACCEL_MAXDELTA  =  0,
DEFAULT_ACCEL_TYPE      =  0,   -- MOUSE_ACCEL_TYPE_POWER
-- MS IntelliMouse has 18 steps, Logitech FirstMouse+ has 24
DEFAULT_WHEEL_STEPS = 18,
DEFAULT_WHEEL_DELTA = (360 / DEFAULT_WHEEL_STEPS),
-- Logical or the following values to one of the above at will and give that for
-- type in mouse_init (still they make only sense for serial mice)
MOUSE_CHG_DTR  = #80000000, -- CLEAR (!) the DTR line
MOUSE_DTR_HIGH = #40000000, -- when used with MOUSE_CHG_DTR set DTR not clear it
MOUSE_CHG_RTS  = #20000000, -- CLEAR (!) the RTS line
MOUSE_RTS_HIGH = #10000000, -- when used with MOUSE_CHG_RTS set RTS not clear it
-- If MOUSE_CHG_DTR is not given the DTR state is not touched.. same with RTS resp. --
-- So I use MOUSE_MOUSESYSTEMS|MOUSE_CHG_RTS to force my
-- multiprotocol mouse to MOUSESYSTEMS and use init the driver to MOUSESYSTEMS
MOUSE_TYPE_MASK = #FFFF,    -- the upper 16bit are reserved for future flags
MOUSE_LEFTBUTTON   =  4,
MOUSE_MIDDLEBUTTON =  2,
MOUSE_RIGHTBUTTON  =  1,
MOUSE_FOURTHBUTTON =  8,
MOUSE_FIFTHBUTTON  = 16,
MOUSE_SIXTHBUTTON  = 32,
MOUSE_RESETBUTTON  = 64,
MOUSE_XDIM  =  1,
MOUSE_YDIM  =  2,
MOUSE_ZDIM  =  4,
MOUSE_RXDIM =  8,
MOUSE_RYDIM = 16,
MOUSE_RZDIM = 32,
MOUSE_2DIM  =  3,
MOUSE_3DIM  =  7,
MOUSE_6DIM  = 63,
MOUSE_DEFAULTSAMPLERATE = 150,
-- mouse_init sets default event handler that keeps track of absolute
-- coordinates:
MOUSE_NOWRAP =  0,
MOUSE_WRAPX  =  1,
MOUSE_WRAPY  =  2,
MOUSE_WRAPZ  =  4,
MOUSE_WRAPRX =  8,
MOUSE_WRAPRY = 16,
MOUSE_WRAPRZ = 32,
MOUSE_WRAP   = 63,
MOUSE_ROT_COORDS = 196,
MOUSE_ROT_INFINITESIMAL = 0, -- report changes in angle about axes
MOUSE_ROT_RX_RY_RZ = 64,     -- report angle about axes
-- Warning! Next two may not yet be supported!
MOUSE_ROT_ZXZ = 128,          -- use x convention Euler angles
MOUSE_ROT_YPR = 196,          -- use yaw, pitch, and roll
MOUSE_CAPS       =      1024,
MOUSE_WANTCAPS   = #002B0042,
MOUSE_GOTCAPS    = #0042FFD4,
MOUSE_INFO_WHEEL = #00000001, -- The mouse has a wheel
-- Keyboard interface for svgalib.
-- Can be used independently.
SCANCODE_ESCAPE = 1,
SCANCODE_1 =  2,
SCANCODE_2 =  3,
SCANCODE_3 =  4,
SCANCODE_4 =  5,
SCANCODE_5 =  6,
SCANCODE_6 =  7,
SCANCODE_7 =  8,
SCANCODE_8 =  9,
SCANCODE_9 = 10,
SCANCODE_0 = 11,
SCANCODE_MINUS = 12,
SCANCODE_EQUAL = 13,
SCANCODE_BACKSPACE = 14,
SCANCODE_TAB = 15,
SCANCODE_Q = 16,
SCANCODE_W = 17,
SCANCODE_E = 18,
SCANCODE_R = 19,
SCANCODE_T = 20,
SCANCODE_Y = 21,
SCANCODE_U = 22,
SCANCODE_I = 23,
SCANCODE_O = 24,
SCANCODE_P = 25,
SCANCODE_BRACKET_LEFT  = 26,
SCANCODE_BRACKET_RIGHT = 27,
SCANCODE_ENTER = 28,
SCANCODE_LEFTCONTROL = 29,
SCANCODE_A = 30,
SCANCODE_S = 31,
SCANCODE_D = 32,
SCANCODE_F = 33,
SCANCODE_G = 34,
SCANCODE_H = 35,
SCANCODE_J = 36,
SCANCODE_K = 37,
SCANCODE_L = 38,
SCANCODE_SEMICOLON  = 39,
SCANCODE_APOSTROPHE = 40,
SCANCODE_GRAVE = 41,
SCANCODE_LEFTSHIFT = 42,
SCANCODE_BACKSLASH = 43,
SCANCODE_Z = 44,
SCANCODE_X = 45,
SCANCODE_C = 46,
SCANCODE_V = 47,
SCANCODE_B = 48,
SCANCODE_N = 49,
SCANCODE_M = 50,
SCANCODE_COMMA  = 51,
SCANCODE_PERIOD = 52,
SCANCODE_SLASH  = 53,
SCANCODE_RIGHTSHIFT     = 54,
SCANCODE_KEYPADMULTIPLY = 55,
SCANCODE_LEFTALT  = 56,
SCANCODE_SPACE    = 57,
SCANCODE_CAPSLOCK = 58,
SCANCODE_F1  = 59,
SCANCODE_F2  = 60,
SCANCODE_F3  = 61,
SCANCODE_F4  = 62,
SCANCODE_F5  = 63,
SCANCODE_F6  = 64,
SCANCODE_F7  = 65,
SCANCODE_F8  = 66,
SCANCODE_F9  = 67,
SCANCODE_F10 = 68,
SCANCODE_NUMLOCK    = 69,
SCANCODE_SCROLLLOCK = 70,
SCANCODE_KEYPAD7 = 71,
SCANCODE_CURSORUPLEFT = 71,
SCANCODE_KEYPAD8  = 72,
SCANCODE_CURSORUP = 72,
SCANCODE_KEYPAD9  = 73,
SCANCODE_CURSORUPRIGHT = 73,
SCANCODE_KEYPADMINUS   = 74,
SCANCODE_KEYPAD4    = 75,
SCANCODE_CURSORLEFT = 75,
SCANCODE_KEYPAD5 = 76,
SCANCODE_KEYPAD6 = 77,
SCANCODE_CURSORRIGHT = 77,
SCANCODE_KEYPADPLUS  = 78,
SCANCODE_KEYPAD1     = 79,
SCANCODE_CURSORDOWNLEFT = 79,
SCANCODE_KEYPAD2    = 80,
SCANCODE_CURSORDOWN = 80,
SCANCODE_KEYPAD3    = 81,
SCANCODE_CURSORDOWNRIGHT = 81,
SCANCODE_KEYPAD0      = 82,
SCANCODE_KEYPADPERIOD = 83,
SCANCODE_LESS = 86,
SCANCODE_F11  = 87,
SCANCODE_F12  = 88,
SCANCODE_KEYPADENTER  =  96,
SCANCODE_RIGHTCONTROL =  97,
SCANCODE_CONTROL      =  97,
SCANCODE_KEYPADDIVIDE =  98,
SCANCODE_PRINTSCREEN  =  99,
SCANCODE_RIGHTALT     = 100,
SCANCODE_BREAK        = 101,        -- Beware: is 119
SCANCODE_BREAK_ALTERNATIVE = 119,   -- on some keyboards!
SCANCODE_HOME = 102,
SCANCODE_CURSORBLOCKUP = 103,       -- Cursor key block
SCANCODE_PAGEUP = 104,
SCANCODE_CURSORBLOCKLEFT  = 105,    -- Cursor key block
SCANCODE_CURSORBLOCKRIGHT = 106,    -- Cursor key block
SCANCODE_END = 107,
SCANCODE_CURSORBLOCKDOWN  = 108,    -- Cursor key block
SCANCODE_PAGEDOWN = 109,
SCANCODE_INSERT = 110,
SCANCODE_REMOVE = 111,
SCANCODE_RIGHTWIN = 126,
SCANCODE_LEFTWIN  = 125,
KEY_EVENTRELEASE =  0,
KEY_EVENTPRESS   =  1,
MAX_KEYNAME_LEN  = 20,
-- keyboard_init sets default event handler that keeps track of complete
-- keyboard state:
-- Result of keypressed.
KEY_NOTPRESSED = 0,
KEY_PRESSED = 1,
-- Modes for translatekeys.
TRANSLATE_CURSORKEYS  = 1,        -- Map cursor block to keypad cursor.
TRANSLATE_DIAGONAL    = 2,        -- Map keypad diagonal to keypad cursor.
TRANSLATE_KEYPADENTER = 4,        -- Map keypad enter to main enter key.
DONT_CATCH_CTRLC      = 8,         -- Disable Crtl-C check.
RTLD_LAZY             = #001,
RTLD_NOW              = #002,
RTLD_BINDING_MASK     = #3,
RTLD_GLOBAL           = #100,
-- event for joystick handlers
JOY_EVENTBUTTONDOWN = 1,
JOY_EVENTBUTTONUP   = 2,
JOY_EVENTAXIS       = 3

----------------------------------------------------------------------------

-- for defining functions
global
constant
  char_    = #01000001,
  uchar_   = #02000001,
  int_     = #01000004,
  uint_    = #02000004,
  short_   = #01000002,
  ushort_  = #02000002,
  word_    = #02000002,
  float_   = #03000004,
  double_  = #03000008,
  byte_    = #02000001,
  pointer_ = #02000004,
  long_    = #01000004,
  ulong_   = #02000004,
  dword_   = #02000004,
  bool_    = #01000002,
  fixed_   = #02000004,
  string_  = #03000001,
  wstring_ = #03000002,
  null_    = #00000000,
  True     = #0000FFFF,
  False    = #00000000,
  ST       = #00000001,
  AST      = #00000002,
  WST      = #00000004,
  AR       = #00000008,
  ANY      = #00000000,
  KEYBOARD = #00000000,
  STDOUT   = #00000001,
  ENABLE   = #00000001,
  DISABLE  = #00000000,
  CLEAR    = -1,

  ceeTYPES =
    { "pointer", pointer_, "ulong"  , ulong_, "long" , long_,
      "ushort" , ushort_ , "short"  , short_, "uint" , uint_, "int", int_,
      "bool"   , bool_   , "uchar"  , uchar_, "char" , char_,
      "dword"  , dword_  , "word"   , word_ , "byte" , byte_,
      "double" , double_ , "float"  , float_, "fixed", fixed_,
      "string" , string_ , "wstring", wstring_ }

-----------------------< END CONSTANT DEFINITIONS >--------------------------

-- ==========================================================================
----------------------------< BEGIN DEFINITIONS >----------------------------
-- ==========================================================================

  sequence DefList, LibList
  DefList = {}
--
  LibList = {"libvga.so","libvgagl.so"}
--
DefList = {
--
----------------------------------------------------------------<>----------
{-1,"\n-- These are the Functions and Structures used in this Program: --\n"},
{-1,"\n-- Function List -------------------------------------------------\n--"},
--
--=========================================================================--
{null_,"vga_setmode",1,{int_},int_},
{null_,"vga_hasmode",1,{int_},int_},
{null_,"vga_setflipchar",1,{int_},int_},
{null_,"vga_clear",1,{null_},int_},
{null_,"vga_flip",1,{null_},int_},
{null_,"vga_getxdim",1,{null_},int_},
{null_,"vga_getydim",1,{null_},int_},
{null_,"vga_getcolors",1,{null_},int_},
{null_,"vga_setpalette",1,{int_, int_, int_, int_},int_},
{null_,"vga_getpalette",1,{int_, pointer_,pointer_,pointer_},int_},
{null_,"vga_setpalvec",1,{int_, int_, pointer_},int_},
{null_,"vga_getpalvec",1,{int_, int_, pointer_},int_},
{null_,"vga_screenoff",1,{null_},int_},
{null_,"vga_screenon",1,{null_},int_},
{null_,"vga_setcolor",1,{int_},int_},
{null_,"vga_drawpixel",1,{int_,int_},int_},
{null_,"vga_drawline",1,{int_,int_,int_,int_},int_},
{null_,"vga_drawscanline",1,{int_,pointer_},int_},
{null_,"vga_drawscansegment",1,{pointer_,int_,int_,int_},int_},
{null_,"vga_getpixel",1,{int_,int_},int_},
{null_,"vga_getscansegment",1,{pointer_,int_,int_,int_},int_},
{null_,"vga_getch",1,{null_},int_},
{null_,"vga_dumpregs",1,{null_},int_},
{null_,"vga_getmodeinfo",1,{int_},pointer_},
{null_,"vga_getdefaultmode",1,{null_},int_},
{null_,"vga_getcurrentmode",1,{null_},int_},
{null_,"vga_getcurrentchipset",1,{null_},int_},
{null_,"vga_getmodename",1,{int_},pointer_},
{null_,"vga_getmodenumber",1,{pointer_},int_},
{null_,"vga_lastmodenumber",1,{null_},int_},
{null_,"vga_getoptmode",1,{int_,int_,int_,int_,int_},int_},
{null_,"vga_getgraphmem",1,{null_},pointer_},
{null_,"vga_setpage",1,{int_},null_},
{null_,"vga_setreadpage",1,{int_},null_},
{null_,"vga_setwritepage",1,{int_},null_},
{null_,"vga_setlogicalwidth",1,{int_},null_},
{null_,"vga_setdisplaystart",1,{int_},null_},
{null_,"vga_waitretrace",1,{null_},null_},
{null_,"vga_claimvideomemory",1,{int_},int_},
{null_,"vga_disabledriverreport",1,{null_},null_},
{null_,"vga_setmodeX",1,{null_},null_},
{null_,"vga_init",1,{null_},int_},
{null_,"vga_getmousetype",1,{null_},int_},
{null_,"vga_getmonitortype",1,{null_},int_},
{null_,"vga_setmousesupport",1,{int_},null_},
{null_,"vga_lockvc",1,{null_},null_},
{null_,"vga_unlockvc",1,{null_},null_},
{null_,"vga_getkey",1,{null_},int_},
{null_,"vga_oktowrite",1,{null_},int_},
{null_,"vga_copytoplanar256",1,{pointer_,int_,int_,int_,int_,int_},null_},
{null_,"vga_copytoplanar16",1,{pointer_,int_,int_,int_,int_,int_},null_},
{null_,"vga_copytoplane",1,{pointer_,int_,int_,int_,int_,int_,int_},null_},
{null_,"vga_setlinearaddressing",1,{null_},int_},
{null_,"vga_safety_fork",1,{pointer_},null_},
{null_,"vga_setchipset",1,{int_},null_},
{null_,"vga_setchipsetandfeatures",1,{int_,int_,int_},null_},
{null_,"vga_gettextfont",1,{pointer_},null_},
{null_,"vga_puttextfont",1,{pointer_},null_},
{null_,"vga_settextmoderegs",1,{pointer_},null_},
{null_,"vga_gettextmoderegs",1,{pointer_},null_},
{null_,"vga_white",1,{null_},int_},
{null_,"vga_setegacolor",1,{int_},int_},
{null_,"vga_setrgbcolor",1,{int_,int_,int_},int_},
{null_,"vga_bitblt",1,{int_,int_,int_,int_,int_},null_},
{null_,"vga_imageblt",1,{pointer_,int_,int_,int_,int_},null_},
{null_,"vga_fillblt",1,{int_,int_,int_,int_,int_},null_},
{null_,"vga_hlinelistblt",1,{int_,int_,pointer_,pointer_,int_,int_},null_},
{null_,"vga_blitwait",1,{null_},null_},
------ variable arguments must be handled in a different way
--    extern int vga_ext_set(unsigned what,...);
--    extern int vga_accel(unsigned operation,...);
{null_,"vga_ext_set",1,{99,uint_},int_},
{null_,"vga_accel",1,{99,uint_},int_},

{null_,"vga_initcursor",1,{int_},int_},
{null_,"vga_showcursor",1,{int_},null_},
{null_,"vga_setcursorposition",1,{int_,int_},null_},
{null_,"vga_selectcursor",1,{int_},null_},
{null_,"vga_setcursorimage",1,{int_,int_,int_,int_,pointer_},null_},

{null_,"vga_addtiming",1,{int_,int_,int_,int_,int_,int_,int_,int_,int_,int_},int_},
{null_,"vga_changetiming",1,{int_,int_,int_,int_,int_,int_,int_,int_,int_,int_},int_},
{null_,"vga_getcurrenttiming",1,{int_,int_,int_,int_,int_,int_,int_,int_,int_,int_},int_},
{null_,"vga_addmode",1,{int_,int_,int_,int_,int_},int_},
{null_,"vga_guesstiming",1,{int_,int_,int_,int_,int_},int_},
--
-- wait for keypress, mousemove, I/O, timeout. cf. select (3) for details on
-- all parameters execept which.
-- NULL is a valid argument for any of the ptrs.
--
{null_,"vga_waitevent",1,{int_,pointer_,pointer_,pointer_},int_},
------ variable arguments must be handled in a different way
-- void vga_runinbackground(int stat, ...);
{null_,"vga_runinbackground",1,{99,int_},null_},
{null_,"vga_runinbackground_version",1,null_,int_},
----------------------------------------------------------------<>----------
--
-- Initialize mouse device. Returns 0 if succesful, -1 otherwise.
-- (Get the svgalib configured type with vga_getmousetype()).
{null_,"mouse_init",1,{pointer_,int_,int_},int_},
-- Similar but returns the mouse fd if succesful.
{null_,"mouse_init_return_fd",1,{pointer_,int_,int_},int_},
---------------------------------------------------------------------------
-- Set event handler invoked by mouse_update().
-- #if 0 typedef void (*__mouse_handler) (int button, int dx, int dy, int dz,                                     int drx, int dry, int drz);
-- #else -- For backwards compatibility with:
--         typedef void (*__mouse_handler) (int button, int dx, int dy) we use:
--     typedef void *__mouse_handler;
-- #endif
--     void mouse_seteventhandler(__mouse_handler handler);
--
-- SEE BELOW FOR USING THESE FUNCTIONS IN EUPHORIA
-- ==========================================================================
-- This function is for setting a CALL-BACK for the __mouse_handler function
{null_,"mouse_seteventhandler",1,{pointer_},null_},
--
-- To use the CALL-BACK
-- Create a procedure in Euphoria with the following parameters like this:
--
-- procedure exu__mouse_handler(int button, int dx, int dy, int dz, int drx, int dry, int drz)
    --
     -- Insert the code to process the mouse events here.
    --
-- end procedure
--
-- Set the event handler in this library by setting it with this call:
--
-- cdecl("mouse_seteventhandler",{call_back(routine_id("exu__mouse_handler"))})
--
-- ==========================================================================
-- Close mouse device.
{null_,"mouse_close",1,{null_},null_},
-- Read mouse and handle events. Returns 0 if no event.
{null_,"mouse_update",1,{null_},int_},
-- Similar to mouse_update, but wait for an event to happen.
{null_,"mouse_waitforupdate",1,{null_},null_},
-- Revert to default handler.
{null_,"mouse_setdefaulteventhandler",1,{null_},null_},
-- Set position of mouse.
{null_,"mouse_setposition",1,{int_,int_},null_},
-- Set position of mouse in all 6 dimensions.
{null_,"mouse_setposition_6d",1,{int_,int_,int_,int_,int_,int_,int_},null_},
-- Set horizontal range of mouse to [x1, x2] incl.
{null_,"mouse_setxrange",1,{int_,int_},null_},
-- Set vertical range of mouse to [y1, y2] incl.
{null_,"mouse_setyrange",1,{int_,int_},null_},
-- Set all ranges of mouse in 6 dimensions.
{null_,"mouse_setrange_6d",1,{int_,int_,int_,int_,int_,int_,int_,int_,int_,int_,int_,int_,int_},null_},
-- Set scale factor by which raw mouse coordinates are divided.
{null_,"mouse_setscale",1,{int_},null_},
-- Enable/disable wrapping of mouse in horizontal and/or vertical range.
{null_,"mouse_setwrap",1,{int_},null_},
-- Get current mouse x-coordinate.
{null_,"mouse_getx",1,{null_},int_},
-- Get current mouse y-coordinate.
{null_,"mouse_gety",1,{null_},int_},
-- Get position of mouse in all 6 dimensions.
{null_,"mouse_getposition_6d",1,{int_,int_,int_,int_,int_,int_},null_},
-- Get current mouse button status.
{null_,"mouse_getbutton",1,{null_},int_},
-- Initialize keyboard handler (brings keyboard into RAW mode). Returns
-- 0 if succesful, -1 otherwise.
{null_,"keyboard_init",1,{null_},int_},
-- Similar, but returns console fd if succesful.
{null_,"keyboard_init_return_fd",1,{null_},int_},
-- ==========================================================================
-- This function is for setting a CALL-BACK for the __keyboard_handler function
{null_,"keyboard_seteventhandler",1,{pointer_},null_},
-- Set event handler invoked by keyboard_update().
--    typedef void (*__keyboard_handler) (int scancode, int press);
--
--    void keyboard_seteventhandler(__keyboard_handler handler);
--
-- To use the CALL-BACK
-- Create a procedure in Euphoria with the following parameters like this:
--
-- procedure exu__keyboard_handler(int scancode, int press)
    --
     -- Insert the code to process the mouse events here.
    --
-- end procedure
--
-- Set the keyboard event handler in this library by setting it with this call:
--
-- cdecl("keyboard_seteventhandler",{call_back(routine_id("exu__mouse_handler"))})
--
-- ==========================================================================
-- Return keyboard to normal state.
{null_,"keyboard_close",1,{null_},null_},
-- Read raw keyboard device and handle events. Returns 0 if no event.
{null_,"keyboard_update",1,{null_},int_},
-- Similar to keyboard_update, but wait for an event to happen.
-- [This doesn't seem to work very well -- use select on fd]
{null_,"keyboard_waitforupdate",1,{null_},null_},
-- Revert to default handler.
{null_,"keyboard_setdefaulteventhandler",1,{null_},null_},
-- Return pointer to buffer holding state of each key (scancode).
-- Value 1 corresponds to key that is pressed, 0 means not pressed.
{null_,"keyboard_getstate",1,{null_},pointer_},
-- Force keyboard state to nothing pressed (all zeroes).
{null_,"keyboard_clearstate",1,{null_},null_},
-- Let default handler translate cursor key block events to numeric keypad
-- cursor key events and other translations.
{null_,"keyboard_translatekeys",1,{int_},null_},
-- Return nonzero if key is depressed.
{null_,"keyboard_keypressed",1,{int_},int_},
-- int joystick_init(int joydev, __joystick_output jo);
-- joystick_output is a pointer to a constant character string
{null_,"joystick_init",1,{int_,pointer_},int_},
-- void joystick_close(int joydev);
{null_,"joystick_close",1,{int_},null_},
-- polls the joystick and calls the eventhandler
-- int joystick_update(void);
{null_,"joystick_update",1,{null_},int_},
-- typedef void (*__joystick_handler) (int event, int number, char value, int joydev);
--  event - event type; see above
--  number - the axis or button number for this event 0=x axis or button 1, etc.
--  value - value for axis events -128 - 0 - +127
-- void joystick_sethandler(int joydev, __joystick_handler jh);
{null_,"joystick_sethandler",1,{int_,pointer_},null_},
-- void joystick_setdefaulthandler(int joydev);
{null_,"joystick_setdefaulthandler",1,{int_},null_},
-- char joystick_getnumaxes(int joydev);
{null_,"joystick_getnumaxes",1,{int_},char_},
-- char joystick_getnumbuttons(int joydev);
{null_,"joystick_getnumbuttons",1,{int_},char_},
-- querys the default handler if used
-- char joystick_getaxis(int joydev, int a);
{null_,"joystick_getaxis",1,{int_,int_},char_},

----------------------------------------------------------------<>----------
{-1,"\n-- Structure List ------------------------------------------------\n--"},
--
{null_,"vga_modeinfo",           -- depends from actual driver/chiptype.. etc.
"width:int:1 "&
"height:int:1 "&
"bytesperpixel:int:1 "&
"colors:int:1 "&
"linewidth:int:1 "&              -- scanline width in bytes
"maxlogicalwidth:int:1 "&        -- maximum logical scanline width
"startaddressrange:int:1 "&      -- changeable bits set
"maxpixels:int:1 "&              -- video memory / bytesperpixel
"haveblit:int:1 "&               -- mask of blit functions available
"flags:int:1 "&                  -- other flags
"chiptype:int:1 "&               -- Chiptype detected  -- Extended fields:
"memory:int:1 "&                 -- videomemory in KB
"linewidth_unit:int:1 "&         -- Use only a multiple of this as parameter for set_logicalwidth and set_displaystart
"linear_aperture:pointer:1 "&    -- points to mmap secondary mem aperture of card (NULL if unavailable)
"aperture_size:int:1 "&          -- size of aperture in KB if size>=videomemory. 0 if unavail
"set_aperture_page:pointer:1 "&  -- void (*set_aperture_page) (int page);
"extensions:pointer:1"},         -- if aperture_size<videomemory select a memory page
				 -- points to copy of eeprom for mach32

-- "C" uses zero based array offsets which has to translated to
-- Euphoria's one based offset for access using peek/poke
-- 6-bit values -- color ->[red][green][blue] 0..................255
----------------------------------------------------------------<>----------
{null_,"Palette",
"[]:byte:768 "}, -- 256 x 3 uchar

{null_,"MouseCaps",
"key:int:1 "&        -- MOUSE_GOTCAPS
"buttons:int:1 "&    -- MOUSE_*BUTTON
"axes:int:1 "&       -- MOUSE_*DIM
"info:int:1 "&       -- MOUSE_INFO_*
"reserved0:int:1 "&  -- Don't use these!
"reserved1:int:1"},  -- The names may change in the future...

{null_,"framebufferfunctions",
"driver_setpixel_func:pointer:1 "&  -- void (*driver_setpixel_func) (int, int, int);
"driver_getpixel_func:pointer:1 "&  -- int (*driver_getpixel_func) (int, int);
"driver_hline_func:pointer:1 "&  -- void (*driver_hline_func) (int, int, int, int);
"driver_fillbox_func:pointer:1 "&  -- void (*driver_fillbox_func) (int, int, int, int, int);
"driver_putbox_func:pointer:1 "&  -- void (*driver_putbox_func) (int, int, int, int, void *, int);
"driver_getbox_func:pointer:1 "&  -- void (*driver_getbox_func) (int, int, int, int, void *, int);
"driver_putboxmask_func:pointer:1 "&  -- void (*driver_putboxmask_func) (int, int, int, int, void *);
"driver_putboxpart_func:pointer:1 "&  -- void (*driver_putboxpart_func) (int, int, int, int, int, int, void *,                                        int, int);
"driver_getboxpart_func:pointer:1 "&  -- void (*driver_getboxpart_func) (int, int, int, int, int, int, void *,                                        int, int);
"driver_copybox_func:pointer:1"}, -- void (*driver_copybox_func) (int, int, int, int, int, int);

{null_,"GraphicsContext",
"modetype:uchar:1 "& -- virtual, paged, linear, mode X
"modeflags:uchar:1 "& -- or planar16
"dummy:uchar:1 "& --
"flippage:uchar:1 "& --
"width:int:1 "&    -- width in pixels
"height:int:1 "&    -- height in pixels
"bytesperpixel:int:1 "& -- bytes per pixel (1, 2, 3, or 4)
"colors:int:1 "&    -- number of colors
"bitsperpixel:int:1 "&  -- bits per pixel (8, 15, 16 or 24)
"bytewidth:int:1 "& -- length of a scanline in bytes
"vbuf:pointer:1 "& -- address of framebuffer
"clip:int:1 "& -- clipping enabled?
"clipx1:int:1 "& -- top-left coordinate of clip window
"clipy1:int:1 "& --
"clipx2:int:1 "& -- bottom-right coordinate of clip window
"clipy2:int:1 "& --
-- framebufferfunctions ff;
"driver_setpixel_func:pointer:1 "&  -- void (*driver_setpixel_func) (int, int, int);
"driver_getpixel_func:pointer:1 "&  -- int (*driver_getpixel_func) (int, int);
"driver_hline_func:pointer:1 "&  -- void (*driver_hline_func) (int, int, int, int);
"driver_fillbox_func:pointer:1 "&  -- void (*driver_fillbox_func) (int, int, int, int, int);
"driver_putbox_func:pointer:1 "&  -- void (*driver_putbox_func) (int, int, int, int, void *, int);
"driver_getbox_func:pointer:1 "&  -- void (*driver_getbox_func) (int, int, int, int, void *, int);
"driver_putboxmask_func:pointer:1 "&  -- void (*driver_putboxmask_func) (int, int, int, int, void *);
"driver_putboxpart_func:pointer:1 "&  -- void (*driver_putboxpart_func) (int, int, int, int, int, int, void *,                                        int, int);
"driver_getboxpart_func:pointer:1 "&  -- void (*driver_getboxpart_func) (int, int, int, int, int, int, void *,                                        int, int);
"driver_copybox_func:pointer:1 "}, -- void (*driver_copybox_func) (int, int, int, int, int, int);

{-1,"\n-- End of all definitions and end of DefList sequence --\n"}}

-- Not needed in this Euphoria library
--
-- Use grab() or peekstruc() function to access GraphicsContext structure
--
-- extern GraphicsContext currentcontext;

--  global atom currentcontextpointer

--  currentcontextpointer = define_c_var(open_dll(LibList[2]), "currentcontext")
--  if currentcontextpointer = -1 then
--    puts(1, "Couldn't find \"currentcontext\" pointer\n")
--    abort(1)
--  end if
--
--
-- BYTESPERPIXEL (currentcontext.bytesperpixel) int
-- BYTEWIDTH (currentcontext.bytewidth)         int
-- WIDTH (currentcontext.width)                 int
-- HEIGHT (currentcontext.height)               int
-- VBUF (currentcontext.vbuf)                   pointer
-- MODETYPE (currentcontext.modetype)           uchar
-- MODEFLAGS (currentcontext.modeflags)         uchar
-- BITSPERPIXEL (currentcontext.bitsperpixel)   int
-- COLORS (currentcontext.colors)               int
-- NOTE* leading underscore not supported by Euphoria so use this
--
-- __clip (currentcontext.clip)                 int
-- __clipx1 (currentcontext.clipx1)             int
-- __clipy1 (currentcontext.clipy1)             int
-- __clipx2 (currentcontext.clipx2)             int
-- __clipy2 (currentcontext.clipy2)             int

--=========================================================================--

----------------------------< ENDS DEFINITIONS >-----------------------------

-- ==========================================================================
--
--  BASIC "C" TYPES
--
-- ==========================================================================
--
-- define the "C" type variables
--
global
type cee( object token )
  if atom(token) then
    token = find(token,ceeTYPES)
    if token then
      return ceeTYPES[token]
    end if
    return token
  else
    token = find(lower(token),ceeTYPES)
    if token then
      token = ceeTYPES[token+1]
    end if
    return token
  end if
end type
--
global
type char( atom data )
  return ( data >= -128 and data <= 127 )
end type
--
global
type uchar( atom data )
  return ( data >= 0 and data <= 255 )
end type
--
global
type int( atom data )
  return ( data >= -2147483648 and data <= 2147483647 )
end type
--
global
type uint( atom data )
  return ( data >= 0 and data <= 4294967295 )
end type
--
global
type short( atom data )
  return ( data >= -32768 and data <= 32767 )
end type
--
global
type ushort( atom data )
  return ( data >= 0 and data <= 65535 )
end type
--
global
type word( atom data )
  return ( data >= 0 and data <= 65535 )
end type
--
global
type float( atom data )
  return ( data >= -3.4E38 and data <= 3.4E38 )
end type
--
global
type double( atom data )
  return ( data >= -1.7E308 and data <= 1.7E308 )
end type
--
global
type byte( atom data )
  return ( data >= 0 and data <= 255 )
end type
--
global
type pointer( atom data )
  return ( data >= -1 and data <= 4294967295 )
end type
--
global
type long( atom data )
  return ( data >= -2147483648 and data <= 2147483647 )
end type
--
global
type ulong( atom data )
  return ( data >= 0 and data <= 4294967295 )
end type
--
global
type dword( atom data )
  return ( data >= 0 and data <= 4294967295 )
end type
--
global
type bool( atom data )
  return ( data >= 0 and data <= 65535 )
end type

-- global variables
--    extern int vga_version;
global atom vga_version
--    extern unsigned char *graph_mem;
global atom graph_mem

vga_version = null_
graph_mem   = null_

-- ==========================================================================
--------------------------< Support Routines >-------------------------------
-- ==========================================================================

  sequence MastList -- master structure list
  atom settextmode
  -- initialize
  MastList = {}

  bool DEBUG_ON DEBUG_ON = False
  settextmode = define_c_func(open_dll("libvga.so"),
			 "vga_setmode", {C_INT},C_INT)

procedure error(atom fn, sequence text, sequence params)
--
-- pause to read the error message
--
  int ok

  ok = c_func(settextmode, {TEXT})
  printf(fn, text, params)
  if getc(0) then
  -- wait for key-press
  end if
  -- if debug is on cause a false divide by zero error to force a ex.err dump
  if DEBUG_ON then
    printf(1, "Forcing a FALSE divide by zero error to cause a ex.err dump\n", params)
    free_console()
    abort(1/0)
  end if
--
end procedure

-----------------------------------------------------------------<>----------
global
function peek2( pointer address )
--
-- peek 2 bytes into 16 bits
--
  return (peek(address)+peek(address+1)*256)
--
end function -- end of peek2 function

-----------------------------------------------------------------<>----------
global
procedure poke2( pointer address, ushort data )
--
-- poke 16 bits into 2 bytes
--
  poke(address,{remainder(data,256),floor(data/256)})
--
end procedure -- end of poke2 procedure

-----------------------------------------------------------------<>----------
global
function isdigit(int chr)
--
-- Tests for digit
-- Return NON-ZERO if TRUE or ZERO if FALSE
--
  return ( chr >= '0' and chr <= '9' )
--
end function

-----------------------------------------------------------------<>----------
global
function val( sequence s )
--
-- converts a sequence to a number
--
  s = value( s )
  if s[1] = GET_SUCCESS then
    return s[2]
  else
    return 0
  end if
--
end function

-----------------------------------------------------------------<>----------
global
function sizeof(pointer pointer )
--
-- Look up the structure definition by pointer or c-type pointer
-- Return the structure size OR
-- Return the size of a c-type
--
--
  --- Layout of the description of a structure
  ---| ptr | ST | name | offset | type | size | ... | total bytes |---
--
  -- request for size of c-type
  if cee(pointer) then                          -- size of "C" type ?
    return and_bits(#F, pointer)
  end if
  if atom(pointer) then                         -- size of structure
    -- find the structure discription
    for i = 1 to length(MastList)  do
      if pointer = MastList[i][1] then
	return MastList[i][length(MastList[i])]
      end if
    end for
  end if
  --
  return 0
--
  end function -- end of sizeof function

-----------------------------------------------------------------<>----------
global
function string( object data )
--
-- Allocate a empty "C" type string buffer or
-- builds a initialized "C" type string.
-- Returns a pointer to the new string
--
  ulong size
  pointer str

  if atom(data) then                 -- wants a empty string ?
    str = allocate(data+1)           -- yes, allocate a empty string
    mem_set(str, 0, data+1)          -- initialize it to zero
    size = data+1                    -- save the size
  else
    str = allocate_string(data)      -- allocate and initialize
    size = length(data)+1
  end if
  ---| ptr | ST | name | offset | type | size | ... | total bytes |---
  MastList = append(MastList, { str, AST, "none", 0, string_, size - 1, size } )
  return str
--
end function -- end of String function

-----------------------------------------------------------------<>----------
global
procedure frees(pointer pointer)
--
-- Remove a structure discription from the Master List and free the pointer
--
  for entry = 1 to length(MastList) do
    if pointer = MastList[entry][1] then
      MastList = MastList[1..entry-1]& MastList[entry+1..length(MastList)]
      free(pointer)
      exit
    end if --
  end for --
--
end procedure -- end of frees procedure

-----------------------------------------------------------------<>----------
global
function addr2txt( pointer frame )
--
-- Convert a Euphoria pointer to a text string
--
--  return val(frame)
  return sprintf("%d ",frame)
--
end function -- end of addr2txt function

------------------------------ Assembler Code  ------------------------------

constant -- this structure will act as our stack

  stack_ = allocate(36) -- the stack

  constant c_code = allocate(669)
  poke(c_code, {
			    --    0: shl_: @
    #60,                    --    0:     pushad             ; ;  save all the registers
    #BD,#00,#00,#00,#00,    --    1: mov ebp, stack     ; addr2txt(STACK) & ;  point base pointer to stack (2)
    #8B,#45,#04,            --    6: mov eax, [ebp+4]   ; ;  value to shift
    #8B,#4D,#08,            --    9: mov ecx, [ebp+8]   ; ;  amount to shift
    #D3,#E0,                --    C: shl eax, cl        ; ;  shift left count
    #89,#45,#00,            --    E: mov [ebp], eax     ; ;  Return the shifted value
    #61,                    --   11: popad              ; ;  restore all the registers
			    --   12: ret                ; ;  back to Euphoria
    #C3,                    --   12: ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; -<>; ; ; ; ;
			    --   13: shr_: @
    #60,                    --   13:     pushad             ; ;  save all the registers
    #BD,#00,#00,#00,#00,    --   14: mov ebp, stack     ; addr2txt(STACK) & ;  point base pointer to stack (21)
    #8B,#45,#04,            --   19: mov eax, [ebp+4]   ; ;  value to shift
    #8B,#4D,#08,            --   1C: mov ecx, [ebp+8]   ; ;  amount to shift
    #D3,#E8,                --   1F: shr eax, cl        ; ;  shift right count
    #89,#45,#00,            --   21: mov [ebp], eax     ; ;  Return the shifted value
    #61,                    --   24: popad              ; ;  restore all the registers
			    --   25: ret                ; ;  back to Euphoria
    #C3,                    --   25: ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; -<>; ; ; ; ;
			    --   26: strlen_: @
    #60,                    --   26:     pushad             ; ;  save all the registers
    #BD,#00,#00,#00,#00,    --   27: mov ebp, stack     ; addr2txt(STACK) & ;  point base pointer to stack (40)
    #FC,                    --   2C: cld                ; ;  clear the direction flag
    #8B,#7D,#04,            --   2D: mov edi, [ebp+4]   ; ;  offset of str parameter
    #31,#C0,                --   30: xor eax, eax       ; ;  set al to contain zero
    #83,#C9,#FF,            --   32: or ecx, -1         ; ;  set counter to #FFFFFFFF
    #F2,#AE,                --   35: repne scasb        ; ;  scan for zero termination
    #F7,#D1,                --   37: not ecx            ; ;  invert ecx to get the count
    #49,                    --   39: dec ecx            ; ;  subtract 1 from the ecx ( null termination )
    #89,#4D,#00,            --   3A: mov [ebp], ecx     ; ;  Return ecx ( the length )
    #61,                    --   3D: popad              ; ;  restore all the registers
			    --   3E: ret                ; ;  back to Euphoria
    #C3,                    --   3E: ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; -
			    --   3F: strcpy_: @
    #60,                    --   3F:     pushad             ; ;  save all the registers
    #BD,#00,#00,#00,#00,    --   40: mov ebp, stack     ; addr2txt(STACK) & ;  point base pointer to stack (65)
    #FC,                    --   45: cld                ; ;  clear the direction flag
    #8B,#75,#08,            --   46: mov esi, [ebp+8]   ; ;  get src pointer
    #89,#F7,                --   49: mov edi, esi       ; ;  save a copy of src pointer in the edi
    #31,#C0,                --   4B: xor eax, eax       ; ;  set al to contain zero
    #83,#C9,#FF,            --   4D: or ecx, -1         ; ;  set counter to #FFFFFFFF
    #F2,#AE,                --   50: repne scasb        ; ;  scan for zero termination
    #F7,#D1,                --   52: not ecx            ; ;  invert ecx to get the count
    #8B,#7D,#04,            --   54: mov edi, [ebp+4]   ; ;  get pointer to dst string
    #89,#7D,#00,            --   57: mov [ebp], edi     ; ;  return dst pointer
    #89,#CA,                --   5A: mov edx,ecx        ; ;  save the counter
    #C1,#E9,#02,            --   5C: shr ecx, 2         ; ;  divide count by 4 to get number of double words
    #F3,#A5,                --   5F: rep movsd          ; ;  copy the double words
    #89,#D1,                --   61: mov ecx,edx        ; ;  get back the count
    #83,#E1,#03,            --   63: and ecx, 3         ; ;  mask out the number of bytes left over
    #F3,#A4,                --   66: rep movsb          ; ;  copy the remainder of bytes
    #61,                    --   68: popad              ; ;  restore all the registers
			    --   69: ret                ; ;  back to Euphoria
    #C3,                    --   69: ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; -
			    --   6A: stpcpy_: @
    #60,                    --   6A:     pushad             ; ;  save all the registers
    #BD,#00,#00,#00,#00,    --   6B: mov ebp, stack     ; addr2txt(STACK) & ;  point base pointer to stack (108)
    #FC,                    --   70: cld                ; ;  clear the direction flag
    #8B,#75,#08,            --   71: mov esi, [ebp+8]   ; ;  get pointer to src string
    #89,#F7,                --   74: mov edi, esi       ; ;  get a copy of src in the edi
    #83,#C9,#FF,            --   76: or ecx, -1         ; ;  set counter to #FFFFFFFF
    #31,#C0,                --   79: xor eax, eax       ; ;  set al to contain zero
    #F2,#AE,                --   7B: repne scasb        ; ;  calculate the src length
    #F7,#D1,                --   7D: not ecx            ; ;  invert ecx to get the count
    #8B,#7D,#04,            --   7F: mov edi, [ebp+4]   ; ;  get pointer to dst string
    #89,#CA,                --   82: mov edx,ecx        ; ;  save the counter
    #C1,#E9,#02,            --   84: shr ecx, 2         ; ;  divide count by 4 to get number of double words
    #F3,#A5,                --   87: rep movsd          ; ;  copy the double words
    #89,#D1,                --   89: mov ecx,edx        ; ;  get back the count
    #83,#E1,#03,            --   8B: and ecx, 3         ; ;  mask out the number of bytes left over
    #F3,#A4,                --   8E: rep movsb          ; ;  copy the remainder of bytes
    #8D,#47,#FF,            --   90: lea eax, [edi-1]   ; ;  adjust edi to point to zero terminating byte
    #89,#45,#00,            --   93: mov [ebp], eax     ; ;  setup to return edi pointer
    #61,                    --   96: popad              ; ;  restore all the registers
			    --   97: ret                ; ;  back to Euphoria
    #C3,                    --   97: ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; -
			    --   98: strupr_: @
    #60,                    --   98:     pushad             ; ;  save all the registers
    #BD,#00,#00,#00,#00,    --   99: mov ebp, stack     ; addr2txt(STACK) & ;  point base pointer to stack (154)
    #8B,#7D,#04,            --   9E: mov edi, [ebp+4]   ; ;  get pointer to the string
    #89,#7D,#00,            --   A1: mov [ebp], edi     ; ;  setup return pointer to processed string
			    --   A4: testcase1:             ; ;  look for uppercase
    #8B,#07,                --   A4:     mov eax, [edi]     ; ;  get character
    #3C,#61,                --   A6: cmp al, 97         ; ;  is character below 'a' ?
    #72,#08,                --   A8: jb next1           ; ;  yes, already uppercase goto next
    #3C,#7A,                --   AA: cmp al, 122        ; ;  is character above 'z' ?
    #77,#04,                --   AC: ja next1           ; ;  yes, already uppercase goto next
    #24,#5F,                --   AE: and al, 95         ; ;  mask out bit 5 using 5Fh as mask
    #88,#07,                --   B0: mov [edi], al      ; ;  replace character with uppercase character
			    --   B2: next1:                 ; ;  the character is now upper case
    #47,                    --   B2:     inc edi            ; ;  point to next character
    #08,#C0,                --   B3: or al, al          ; ;  test al for zero
    #75,#ED,                --   B5: jnz testcase1      ; ;  jump to test case unless zero
    #61,                    --   B7: popad              ; ;  restore all the registers
			    --   B8: ret                ; ;  back to Euphoria
    #C3,                    --   B8: ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; -
			    --   B9: strlwr_: @
    #60,                    --   B9:     pushad             ; ;  save all the registers
    #BD,#00,#00,#00,#00,    --   BA: mov ebp, stack     ; addr2txt(STACK) & ;  point base pointer to stack (187)
    #8B,#7D,#04,            --   BF: mov edi, [ebp+4]   ; ;  get pointer to string
    #89,#7D,#00,            --   C2: mov [ebp], edi     ; ;  setup return pointer to processed string
			    --   C5: testcase2:             ; ;  look for lowercase
    #8B,#07,                --   C5:     mov eax, [edi]     ; ;  get character
    #3C,#41,                --   C7: cmp al, 65         ; ;  is character below 'A' ?
    #72,#08,                --   C9: jb next2           ; ;  yes, already lowercase goto next
    #3C,#5A,                --   CB: cmp al, 90         ; ;  is character above 'Z' ?
    #77,#04,                --   CD: ja next2           ; ;  yes, already lowercase goto next
    #0C,#20,                --   CF: or al, 32          ; ;  or bit 5 into byte ( using 20h )
    #88,#07,                --   D1: mov [edi], al      ; ;  replace character with lowercase character
			    --   D3: next2:                 ; ;  the character is now lower case
    #47,                    --   D3:     inc edi            ; ;  point to next character
    #08,#C0,                --   D4: or al, al          ; ;  test al for zero
    #75,#ED,                --   D6: jnz testcase2      ; ;  jump to test case unless zero
    #61,                    --   D8: popad              ; ;  restore all the registers
			    --   D9: ret                ; ;  back to Euphoria
    #C3,                    --   D9: ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; -
			    --   DA: strcat_: @
    #60,                    --   DA:     pushad             ; ;  save all the registers
    #BD,#00,#00,#00,#00,    --   DB: mov ebp, stack     ; addr2txt(STACK) & ;  point base pointer to stack (220)
    #FC,                    --   E0: cld                ; ;  clear the direction flag
    #8B,#7D,#04,            --   E1: mov edi, [ebp+4]   ; ;  get pointer to dst string
    #89,#7D,#00,            --   E4: mov [ebp], edi     ; ;  setup to return dst pointer
    #8B,#75,#08,            --   E7: mov esi, [ebp+8]   ; ;  get pointer to src string
    #83,#C9,#FF,            --   EA: or ecx, -1         ; ;  set counter to #FFFFFFFF
    #31,#C0,                --   ED: xor eax, eax       ; ;  set al to contain zero
    #F2,#AE,                --   EF: repne scasb        ; ;  find end of string ( null )
    #4F,                    --   F1: dec edi            ; ;  backup over null terminator
    #AC,                    --   F2: next3: lodsb           ; ;  load a byte
    #AA,                    --   F3: stosb              ; ;  store a byte
    #3C,#00,                --   F4: cmp al, 0          ; ;  check for end of string
    #75,#FA,                --   F6: jnz next3          ; ;  no, get next byte
    #61,                    --   F8: popad              ; ;  restore all the registers
			    --   F9: ret                ; ;  back to Euphoria
    #C3,                    --   F9: ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; -
			    --   FA: strchr_: @
    #60,                    --   FA:     pushad             ; ;  save all the registers
    #BD,#00,#00,#00,#00,    --   FB: mov ebp, stack     ; addr2txt(STACK) & ;  point base pointer to stack (252)
    #FC,                    --  100: cld                ; ;  clear the direction flag
    #8B,#75,#04,            --  101: mov esi, [ebp+4]   ; ;  get pointer of string to search
    #8A,#65,#08,            --  104: mov ah, [ebp+8]    ; ;  get character to look for
			    --  107: look4:                 ; ;  start looking
    #AC,                    --  107:     lodsb              ; ;  load a byte into al
    #38,#C4,                --  108: cmp ah, al         ; ;  compare, is this the character ?
    #74,#08,                --  10A: jz found4          ; ;  if yes - jump to found
    #3C,#00,                --  10C: cmp al, 0          ; ;  is end of string ?
    #75,#F7,                --  10E: jne look4          ; ;  if no - look at next chracter
    #31,#C0,                --  110: xor eax, eax       ; ;  not found - zero eax ( a null )
    #EB,#03,                --  112: jmp short exit4    ; ;  clean up and exit
			    --  114: found4:                ; ;  yes, found
    #89,#F0,                --  114:     mov eax, esi       ; ;  get the pointer to character
    #48,                    --  116: dec eax            ; ;  correct the pointer for lodsb increment
			    --  117: exit4:                 ; ;  exit
    #89,#45,#00,            --  117:     mov [ebp], eax     ; ;  return the pointer to character or a null
    #61,                    --  11A: popad              ; ;  restore all the registers
			    --  11B: ret                ; ;  back to Euphoria
    #C3,                    --  11B: ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; -
			    --  11C: strcmp_: @
    #60,                    --  11C:     pushad             ; ;  save the registers
    #BD,#00,#00,#00,#00,    --  11D: mov ebp, stack     ; addr2txt(STACK) & ;  point base pointer to stack (286)
    #FC,                    --  122: cld                ; ;  clear the direction flag
    #8B,#7D,#08,            --  123: mov edi, [ebp+8]   ; ;  get pointer to str2 string
    #89,#FE,                --  126: mov esi,edi        ; ;  save a copy of str2 pointer
    #83,#C9,#FF,            --  128: or ecx,-1          ; ;  set counter to #FFFFFFFF
    #31,#C0,                --  12B: xor eax,eax        ; ;  set al to contain zero
    #F2,#AE,                --  12D: repne scasb        ; ;  calculate the str2 length
    #F7,#D1,                --  12F: not ecx            ; ;  invert ecx to get the count
    #89,#F7,                --  131: mov edi,esi        ; ;  get saved copy of str2
    #8B,#75,#04,            --  133: mov esi, [ebp+4]   ; ;  get pointer to str1
    #F3,#A6,                --  136: repe cmpsb         ; ;  while str1 = str2 loop
    #0F,#9F,#C0,            --  138: setg al            ; ;  set the al to 1 if greater
    #0F,#9C,#C4,            --  13B: setl ah            ; ;  set the ah to 1 if less
    #28,#E0,                --  13E: sub al,ah          ; ;  subtract the ah from the al
    #0F,#BE,#C0,            --  140: movsx eax,al       ; ;  set eax to reflect ordering
    #89,#45,#00,            --  143: mov [ebp], eax     ; ;  return 1 or -1 or zero
    #61,                    --  146: popad              ; ;  restore registers
			    --  147: ret                ; ;  back to Euphoria
    #C3,                    --  147: ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; -
			    --  148: strcspn_: @
    #60,                    --  148:     pushad             ; ;  save the registers
    #BD,#00,#00,#00,#00,    --  149: mov ebp, stack     ; addr2txt(STACK) & ;  point base pointer to stack (330)
    #FC,                    --  14E: cld                ; ;  clear the direction flag
    #31,#C0,                --  14F: xor eax, eax       ; ;  clear the counter
    #8B,#4D,#04,            --  151: mov ecx, [ebp+4]   ; ;  get pointer to str1 string
    #EB,#12,                --  154: jmp short eos5     ; ;  go test for end of string
			    --  156: nextptr5:              ; ;
    #41,                    --  156:     inc ecx            ; ;  point to next character in str1
    #8B,#7D,#08,            --  157: mov edi, [ebp+8]   ; ;  get pointer to str2 string
			    --  15A: scan5:                 ; ;
    #8A,#37,                --  15A:     mov dh, [edi]      ; ;  put character from str2 in dh
    #08,#F6,                --  15C: or dh, dh          ; ;  test for zero termination
    #74,#07,                --  15E: jz inceos5         ; ;  yes, go an update the counter
    #38,#F2,                --  160: cmp dl, dh         ; ;  compare str1 and str2 characters
    #74,#0A,                --  162: je exit5           ; ;  if equal exit
    #47,                    --  164: inc edi            ; ;  point to next str2 character
    #EB,#F3,                --  165: jmp short scan5    ; ;  jump to scan next
			    --  167: inceos5:               ; ;
    #40,                    --  167:     inc eax            ; ;  update the counter
			    --  168: eos5:                  ; ;
    #8A,#11,                --  168:     mov dl, [ecx]      ; ;  get next character
    #08,#D2,                --  16A: or dl, dl          ; ;  test for zero termination
    #75,#E8,                --  16C: jnz nextptr5       ; ;  no, goto next pointer
			    --  16E: exit5:                 ; ;
    #89,#45,#00,            --  16E:     mov [ebp], eax     ; ;  return the index counter
    #61,                    --  171: popad              ; ;  restore all the registers
			    --  172: ret                ; ;  back to Euphoria
    #C3,                    --  172: ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; -
			    --  173: strspn_: @
    #60,                    --  173:     pushad             ; ;  save the registers
    #BD,#00,#00,#00,#00,    --  174: mov ebp, stack     ; addr2txt(STACK) & ;  point base pointer to stack (373)
    #FC,                    --  179: cld                ; ;  clear the direction flag
    #31,#C0,                --  17A: xor eax, eax       ; ;  clear the counter
    #8B,#4D,#04,            --  17C: mov ecx, [ebp+4]   ; ;  get pointer to str1 string
    #EB,#12,                --  17F: jmp short eos6     ; ;  test for end of string
			    --  181: nextptr6:              ; ;  next pointer
    #41,                    --  181:     inc ecx            ; ;  point to next character in str1
    #8B,#7D,#08,            --  182: mov edi, [ebp+8]   ; ;  get pointer to str2 string
			    --  185: scan6                  ; ;  scan for character
    #8A,#37,                --  185:     mov dh, [edi]      ; ;  put character from str2 in dh
    #08,#F6,                --  187: or dh, dh          ; ;  test for zero termination
    #74,#0E,                --  189: jz exit6           ; ;  if equal exit
    #38,#F2,                --  18B: cmp dl, dh         ; ;  compare str1 and str2 characters
    #74,#03,                --  18D: je update6         ; ;  yes, go an update the counter
    #47,                    --  18F: inc edi            ; ;  point to next str2 character
    #EB,#F3,                --  190: jmp short scan6    ; ;  jump to scan next
			    --  192: update6:               ; ;  update
    #40,                    --  192:     inc eax            ; ;  update the counter
			    --  193: eos6:                  ; ;  look for the end of the string
    #8A,#11,                --  193:     mov dl, [ecx]      ; ;  get next character
    #08,#D2,                --  195: or dl, dl          ; ;  test for zero termination
    #75,#E8,                --  197: jnz nextptr6       ; ;  no, goto next pointer
			    --  199: exit6:                 ; ;  exit
    #89,#45,#00,            --  199:     mov [ebp], eax     ; ;  return the index counter
    #61,                    --  19C: popad              ; ;  restore all the registers
			    --  19D: ret                ; ;  back to Euphoria
    #C3,                    --  19D: ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; -
			    --  19E: strncat_: @
    #60,                    --  19E:     pushad             ; ;  save all the registers
    #BD,#00,#00,#00,#00,    --  19F: mov ebp, stack     ; addr2txt(STACK) & ;  point base pointer to stack (416)
    #FC,                    --  1A4: cld                ; ;  clear the direction flag
    #8B,#7D,#04,            --  1A5: mov edi, [ebp+4]   ; ;  get pointer to dst string
    #89,#7D,#00,            --  1A8: mov [ebp], edi     ; ;  setup to return dst pointer
    #8B,#75,#08,            --  1AB: mov esi, [ebp+8]   ; ;  get pointer to src string
    #8B,#5D,#0C,            --  1AE: mov ebx, [ebp+12]  ; ;  get count
    #83,#C9,#FF,            --  1B1: or ecx, -1         ; ;  set counter to #FFFFFFFF
    #31,#C0,                --  1B4: xor eax, eax       ; ;  set al to contain zero
    #F2,#AE,                --  1B6: repne scasb        ; ;  find end of string ( null )
    #4F,                    --  1B8: dec edi            ; ;  back up to overwrite terminating null
			    --  1B9: next7:                 ; ;  next character
    #83,#FB,#00,            --  1B9:     cmp ebx, 0         ; ;  is count in ebx 0 ?
    #74,#07,                --  1BC: jz exit7           ; ;  yes exit
    #AC,                    --  1BE: lodsb              ; ;  get a character
    #AA,                    --  1BF: stosb              ; ;  store the character
    #4B,                    --  1C0: dec ebx            ; ;  decrement ebx count
    #3C,#00,                --  1C1: cmp al, 0          ; ;  test for end of string
    #75,#F4,                --  1C3: jnz next7          ; ;  no get next character
			    --  1C5: exit7:                 ; ;  exit
    #31,#C0,                --  1C5:     xor eax, eax       ; ;  get a zero
    #89,#1F,                --  1C7: mov [edi], ebx     ; ;  put the zero termination byte end of string
    #61,                    --  1C9: popad              ; ;  restore all the registers
			    --  1CA: ret                ; ;  back to Euphoria
    #C3,                    --  1CA: ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; -
			    --  1CB: strncmp_: @
    #60,                    --  1CB:     pushad             ; ;  save the registers
    #BD,#00,#00,#00,#00,    --  1CC: mov ebp, stack     ; addr2txt(STACK) & ;  point base pointer to stack (461)
    #FC,                    --  1D1: cld                ; ;  clear the direction flag
    #8B,#7D,#08,            --  1D2: mov edi, [ebp+8]   ; ;  get pointer to str2 string
    #89,#FE,                --  1D5: mov esi,edi        ; ;  save a copy of str2 pointer
    #83,#C9,#FF,            --  1D7: or ecx,-1          ; ;  set counter to #FFFFFFFF
    #31,#C0,                --  1DA: xor eax,eax        ; ;  set al to contain zero
    #F2,#AE,                --  1DC: repne scasb        ; ;  calculate the src length
    #F7,#D1,                --  1DE: not ecx            ; ;  invert ecx to get the count
    #8B,#55,#0C,            --  1E0: mov edx, [ebp+12]  ; ;  get count
    #39,#D1,                --  1E3: cmp ecx,edx        ; ;  have we reach the count ?
    #76,#02,                --  1E5: jbe short
			    --  1E7: over8    ; ;  jump over if below or equal
    #89,#D1,                --  1E7:     mov ecx,edx        ; ;  save the count
			    --  1E9: jecxz short exit8  ; ;  exit if ecx is zero
			    --  1E9: over8:                 ; ;  below or equal
    #89,#F7,                --  1E9:     mov edi,esi        ; ;  get saved copy of str2
    #8B,#75,#04,            --  1EB: mov esi, [ebp+4]   ; ;  get the count into edx
    #F3,#A6,                --  1EE: repe cmpsb         ; ;  while str1 = str2 loop
    #0F,#9F,#C0,            --  1F0: setg al            ; ;  set the al to 1 if greater
    #0F,#9C,#C4,            --  1F3: setl ah            ; ;  set the ah to 1 if less
    #28,#E0,                --  1F6: sub al,ah          ; ;  subtract the ah from the al
    #0F,#BE,#C0,            --  1F8: movsx eax,al       ; ;  set eax to reflect ordering
			    --  1FB: exit8:                 ; ;  exit
    #89,#45,#00,            --  1FB:     mov [ebp], eax     ; ;  return 1 or -1 or zero
    #61,                    --  1FE: popad              ; ;  restore registers
			    --  1FF: ret                ; ;  back to Euphoria
    #C3,                    --  1FF: ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; -
			    --  200: strncpy_: @
    #60,                    --  200:     pushad             ; ;  save all the registers
    #BD,#00,#00,#00,#00,    --  201: mov ebp, stack     ; addr2txt(STACK) & ;  point base pointer to stack (514)
    #FC,                    --  206: cld                ; ;  clear the direction flag
    #8B,#55,#0C,            --  207: mov edx, [ebp+12]  ; ;  get the count
    #8B,#75,#08,            --  20A: mov esi, [ebp+8]   ; ;  get pointer to src string
    #89,#F7,                --  20D: mov edi, esi       ; ;  get a copy of src in the edi
    #31,#C0,                --  20F: xor eax, eax       ; ;  set al to contain zero
    #83,#C9,#FF,            --  211: or ecx, -1         ; ;  set counter to #FFFFFFFF
    #F2,#AE,                --  214: repne scasb        ; ;  calculate the src length
    #F7,#D1,                --  216: not ecx            ; ;  invert ecx to get the count
    #89,#C8,                --  218: mov eax, ecx       ; ;  save the src length
    #89,#D1,                --  21A: mov ecx, edx       ; ;  get number of characters to copy
    #8B,#7D,#04,            --  21C: mov edi, [ebp+4]   ; ;  get pointer to dst string
    #89,#7D,#00,            --  21F: mov [ebp], edi     ; ;  get pointer to dst string
    #F3,#A4,                --  222: repz movsb         ; ;  move bytes from src to dst
    #89,#D1,                --  224: mov ecx, edx       ; ;  get src length
    #29,#C1,                --  226: sub ecx, eax       ; ;  cnt - src = number of pad bytes
    #7F,#06,                --  228: jg exit9           ; ;  exit no pad bytes
    #F7,#D1,                --  22A: not ecx            ; ;  invert the ecx
    #31,#C0,                --  22C: xor eax, eax       ; ;  get null pad character
    #F3,#AA,                --  22E: repz stosb         ; ;  fill with pad bytes
			    --  230: exit9:                 ; ;
    #61,                    --  230:     popad              ; ;  restore all the registers
			    --  231: ret                ; ;  back to Euphoria
    #C3,                    --  231: ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; -
			    --  232: strpbrk_: @
    #60,                    --  232:     pushad             ; ;  save all the registers
    #BD,#00,#00,#00,#00,    --  233: mov ebp, stack     ; addr2txt(STACK) & ;  point base pointer to stack (564)
    #FC,                    --  238: cld                ; ;  clear the direction flag
    #8B,#45,#04,            --  239: mov eax, [ebp+4]   ; ;  get the count
    #8B,#5D,#08,            --  23C: mov ebx, [ebp+8]   ; ;  get the count
    #EB,#10,                --  23F: jmp short nextstr1 ; ;  get string1 1st character
			    --  241: getstr2:               ; ;  string2 pointer
    #89,#D9,                --  241:     mov ecx,ebx        ; ;  get head of str2 pointer
			    --  243: nextstr2:              ; ;  next character from string 2
    #8A,#31,                --  243:     mov dh,[ecx]       ; ;  get str2 char into the dh
    #08,#F6,                --  245: or dh,dh           ; ;  test for end of string
    #74,#07,                --  247: jz incstr1         ; ;  yes,
    #38,#F2,                --  249: cmp dl,dh          ; ;  compare str1 with str2
    #74,#0C,                --  24B: je exit10          ; ;  if a match exit
    #41,                    --  24D: inc ecx            ; ;  increment str2 pointer
    #EB,#F3,                --  24E: jmp short nextstr2 ; ;  get next
			    --  250: incstr1:               ; ;  update str1 pointer
    #40,                    --  250:     inc eax            ; ;  increment str1 pointer
			    --  251: nextstr1:              ; ;  next character from string 1
    #8A,#10,                --  251:     mov dl,[eax]       ; ;  get str1 char into the dl
    #08,#D2,                --  253: or dl,dl           ; ;  test for end of string
    #75,#EA,                --  255: jnz getstr2        ; ;  no, get new str2 pointer
    #31,#C0,                --  257: xor eax,eax        ; ;  setup eax to return ZERO
			    --  259: exit10:                ; ;  exit
    #89,#45,#00,            --  259:     mov [ebp], eax     ; ;  return a pointer or null
    #61,                    --  25C: popad              ; ;  restore all the registers
			    --  25D: ret                ; ;  back to Euphoria
    #C3,                    --  25D: ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; -
			    --  25E: strrchr_: @
    #60,                    --  25E:     pushad             ; ;  save all the registers
    #BD,#00,#00,#00,#00,    --  25F: mov ebp, stack     ; addr2txt(STACK) & ;  point base pointer to stack (608)
    #FC,                    --  264: cld                ; ;  clear the direction flag
    #8B,#75,#04,            --  265: mov esi, [ebp+4]   ; ;  get pointer of string to search
    #8A,#65,#08,            --  268: mov ah, [ebp+8]    ; ;  get character to look for in ebx
    #31,#DB,                --  26B: xor ebx, ebx       ; ;  set ebx counter to contain zero
			    --  26D: look11:                ; ;  look
    #AC,                    --  26D:     lodsb              ; ;  load a byte into al
    #38,#C4,                --  26E: cmp ah, al         ; ;  compare is this the character ?
    #74,#06,                --  270: jz found11         ; ;  if yes - jump to found
    #3C,#00,                --  272: cmp al, 0          ; ;  is end of string ?
    #75,#F7,                --  274: jne look11         ; ;  if no - look at next chracter
    #EB,#05,                --  276: jmp short exit11   ; ;  clean up and exit
			    --  278: found11:               ; ;  found
    #89,#F3,                --  278:     mov ebx, esi       ; ;  get the pointer
    #4B,                    --  27A: dec ebx            ; ;  correct the pointer
    #EB,#F0,                --  27B: jmp short look11   ; ;  look for next occurance
			    --  27D: exit11:                ; ;  exit
    #89,#5D,#00,            --  27D:     mov [ebp], ebx     ; ;  return a pointer or zero
    #61,                    --  280: popad              ; ;  restore all the registers
			    --  281: ret                ; ;  back to Euphoria
    #C3,                    --  281: ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; -
			    --  282: strset_: @
    #60,                    --  282:     pushad             ; ;  save all the registers
    #BD,#00,#00,#00,#00,    --  283: mov ebp, stack     ; addr2txt(STACK) & ;  point base pointer to stack (644)
    #FC,                    --  288: cld                ; ;  clear the direction flag
    #8B,#7D,#04,            --  289: mov edi, [ebp+4]   ; ;  get pointer of string to search
    #89,#7D,#00,            --  28C: mov [ebp], edi     ; ;  setup return pointer to processed string
    #B4,#00,                --  28F: mov ah, 0          ; ;  zero terminating byte
    #8A,#45,#08,            --  291: mov al, [ebp+8]    ; ;  get character to look for in al
    #EB,#01,                --  294: jmp short eos11    ; ;  test end of string
    #AA,                    --  296: set11: stosb           ; ;  set the character
    #3A,#27,                --  297: eos11: cmp ah, [edi]   ; ;  end of string ?
    #75,#FB,                --  299: jnz set11          ; ;  no set the next character
    #61,                    --  29B: popad              ; ;  restore all the registers
			    --  29C: ret                ; ;  back to Euphoria
    #C3})                   --  29C: ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; -

  poke4(c_code +   2, stack_)
  poke4(c_code +  21, stack_)
  poke4(c_code +  40, stack_)
  poke4(c_code +  65, stack_)
  poke4(c_code + 108, stack_)
  poke4(c_code + 154, stack_)
  poke4(c_code + 187, stack_)
  poke4(c_code + 220, stack_)
  poke4(c_code + 252, stack_)
  poke4(c_code + 286, stack_)
  poke4(c_code + 330, stack_)
  poke4(c_code + 373, stack_)
  poke4(c_code + 416, stack_)
  poke4(c_code + 461, stack_)
  poke4(c_code + 514, stack_)
  poke4(c_code + 564, stack_)
  poke4(c_code + 608, stack_)
  poke4(c_code + 644, stack_)

constant
  shl_     = c_code + #000,
  shr_     = c_code + #013,
  strlen_  = c_code + #026,
  strcpy_  = c_code + #03F,
  stpcpy_  = c_code + #06A,
  strupr_  = c_code + #098,
  strlwr_  = c_code + #0B9,
  strcat_  = c_code + #0DA,
  strchr_  = c_code + #0FA,
  strcmp_  = c_code + #11C,
  strcspn_ = c_code + #148,
  strspn_  = c_code + #173,
  strncat_ = c_code + #19E,
  strncmp_ = c_code + #1CB,
  strncpy_ = c_code + #200,
  strpbrk_ = c_code + #232,
  strrchr_ = c_code + #25E,
  strset_  = c_code + #282

----------------------------------------------------------------<>----------
global
function shl(atom data, char amount)
--
-- shift data left by amount
--
  poke4(stack_+4,data)             -- set parameters
  poke4(stack_+8,amount)           -- set parameters
  call(shl_)                   -- call assembler code
  return peek4u(stack_)          -- get return value
--
end function

----------------------------------------------------------------<>----------
global
function shr(atom data, char amount)
--
-- shift data right by amount
--
  poke4(stack_+4,data)             -- set parameters
  poke4(stack_+8,amount)           -- set parameters
  call(shr_)                   -- call assembler code
  return peek4u(stack_)          -- get return value
--
end function

----------------------------------------------------------------<>----------
global
function strlen(pointer str)
--
-- "C" -->  int strlen(char *str)
-- Calculates the string length - Returns length excluding null termination
--
  poke4(stack_+4,str)          -- set parameters
  call(strlen_)                -- call assembler code
  return peek4u(stack_)        -- get return value
--
end function

----------------------------------------------------------------<>----------
global
function strcpy(pointer dst, object src)
--
-- "C" -->  char *strcpy(char *str1, char *str2)
-- Copies src to dst including null termination - Returns pointer to dst
--
  if atom(src) then            -- is pointer ?
    poke4(stack_+4,dst)        -- set parameters
    poke4(stack_+8,src)        --
    call(strcpy_)              -- yes, call assembler code
    return peek4u(stack_)      -- get return value
  else                         -- no,
    src = allocate_string(src) -- convert sequence to asciiz string
    poke4(stack_+4,dst)        -- set parameters
    poke4(stack_+8,src)        --
    call(strcpy_)              -- call assembler code
    free(src)                  -- free temporary string
    return peek4u(stack_)      -- get return value
  end if
--
end function

----------------------------------------------------------------<>----------
global
function stpcpy(pointer dst, object src)
--
-- "C" -->  char *stpcpy(char *str1, char *str2)
-- Copies src to dst including null termination - Returns pointer to the null
--
  if atom(src) then            -- is pointer ?
    poke4(stack_+4,dst)        -- set parameters
    poke4(stack_+8,src)        --
    call(stpcpy_)              -- yes, call assembler code
    return peek4u(stack_)      -- get return value
  else                         -- no,
    src = allocate_string(src) -- convert sequence to asciiz string
    poke4(stack_+4,dst)        -- set parameters
    poke4(stack_+8,src)        --
    call(stpcpy_)              -- call assembler code
    free(src)                  -- free temporary string
    return peek4u(stack_)      -- get return value
  end if
--
end function

----------------------------------------------------------------<>----------
global
function strupr(pointer str)
--
-- "C" --> char *strupr(char *string)
-- Scans & converts string to uppercase - Returns pointer to converted string
--
  poke4(stack_+4,str)          -- set parameters
  call(strupr_)                -- call assembler code
  return peek4u(stack_)        -- get return value
--
end function

----------------------------------------------------------------<>----------
global
function strlwr(pointer str)
--
-- "C" --> char *strlwr(char *string)
-- Scans & converts string to lowercase - Returns pointer to converted string
--
  poke4(stack_+4,str)          -- set parameters
  call(strlwr_)                -- call assembler code
  return peek4u(stack_)        -- get return value
--
end function

-----------------------------------------------------------------<>----------
global
function strdup(pointer str)
--
-- "C" --> char *strdup(char *string)
-- Creates a duplicate string - Returns a pointer to the newly created string
--
  pointer clone

  poke4(stack_+4,str)          -- set parameters
  call(strlen_)                -- get string length
  clone = string(peek4u(stack_)) -- allocate the string
  poke4(stack_+4,clone)        -- set parameters
  poke4(stack_+8,str)          --
  call(strcpy_)                -- copy str into new buffer
  return peek4u(stack_)        -- return the clone pointer
--
end function

-----------------------------------------------------------------<>----------
global
function strcat(pointer dst, object src)
--
-- "C" --> char *strcat(char *string1, char *string2)
-- Appends characters from string2 (src) to string1 (dst)
-- Returns string1 (dst) pointer
--

  if atom(src) then            -- pointer ?
    poke4(stack_+4,dst)        -- set parameters
    poke4(stack_+8,src)        --
    call(strcat_)              -- call strcat code
  else
    src = allocate_string(src) -- convert to pointer
    poke4(stack_+4,dst)        -- set parameters
    poke4(stack_+8,src)        --
    call(strcat_)              -- call strcat code
    free(src)                  -- free string storage
  end if
  return peek4u(stack_)        -- get return value
--
end function

-----------------------------------------------------------------<>----------
global
function strchr(pointer str, int chr)
--
-- "C" --> char *strchr(char *string, int c)
-- Searchs string for a char. - Returns pointer to char. or zero if not found
--
  poke4(stack_+4,str)          -- set parameters
  poke4(stack_+8,chr)          --
  call(strchr_)                -- call assembler code
  return peek4u(stack_)        -- get return value
--
end function

----------------------------------------------------------------<>----------
global
function strcmp(pointer str1, pointer str2)
--
-- "C" -->  int strcmp(const char *string1, const char *string2)
-- Compares all the characters of string1 to string2 ( case sensitive )
--
-- Returns lexicographic order of string1 to string2 :
-- 1: Zero     if str1 equals str2
-- 2: negative if str1 is less than str2
-- 3: positive if str1 is greater than str2
--
  poke4(stack_+4,str1)         -- set parameters
  poke4(stack_+8,str2)         --
  call(strcmp_)                -- call assembler code
  return peek4s(stack_)        -- get return signed value
--
end function

----------------------------------------------------------------<>----------
global
function strcspn(pointer str1, pointer str2)
--
-- "C" -->  int strcspn(const char *string1, const char *string2)
-- Finds a index of the first character in str1 that is contained in str2
--
-- Returns one of the following conditions :
-- 1: index to first character in str1, that is contained in str2
-- 2: zero, if str1 begins with a character contained in str2
-- 3: length of str1, if str1 contains NO character that is in str2
--
  poke4(stack_+4,str1)         -- set parameters
  poke4(stack_+8,str2)         --
  call(strcspn_)               -- call assembler code
  return peek4u(stack_)        -- get return value
--
end function

----------------------------------------------------------------<>----------
global
function strspn(pointer str1, pointer str2)
--
-- "C" -->  int strspn(const char *string1, const char *string2)
-- Finds index of the first character in str1 that is NOT contained in str2
--
-- Returns one of the following conditions :
-- 1: index to first character in str1, that is NOT contained in str2
-- 2: zero, if str1 begins with a character NOT contained in str2
-- 3: length of str1, if str1 contains ONLY characters that are in str2
--
  poke4(stack_+4,str1)         -- set parameters
  poke4(stack_+8,str2)         --
  call(strspn_)                -- call assembler code
  return peek4u(stack_)        -- get return value
--
end function

-----------------------------------------------------------------<>----------
global
function strncat(pointer dst, pointer src, int cnt)
--
-- "C" --> char *strcat(char *string1, char *string2, int count)
-- Appends a specified count of characters from string2 (src) to string1 (dst)
-- Returns string1 (dst) pointer
--
  poke4(stack_+4,dst)          -- set parameters
  poke4(stack_+8,src)          --
  poke4(stack_+12,cnt)         --
  call(strncat_)               -- call assembler code
  return peek4u(stack_)        -- get return value
--
end function

----------------------------------------------------------------<>----------
global
function strncmp(pointer str1, pointer str2, int cnt)
--
-- "C" -->  int strncmp(const char *string1, const char *string2, int count)
-- Compares a specified number of characters of 2 strings ( case sensitive )
--
-- Returns lexicographic order for count characters of string1 to string2:
-- 1: Zero     if str1 equals str2
-- 2: negative if str1 is less than str2
-- 3: positive if str1 is greater than str2
--
  poke4(stack_+4,str1)         -- set parameters
  poke4(stack_+8,str2)         --
  poke4(stack_+12,cnt)         --
  call(strncmp_)               -- call assembler code
  return peek4s(stack_)        -- get return signed value
--
end function

----------------------------------------------------------------<>----------
global
function strncpy(pointer dst, pointer src, int cnt)
--
-- "C" -->  char *strncpy(char *string1, const char *string2, int count)
-- Copies src using count to dst padding with spaces - Returns pointer to dst
-- NOTE: In "C" if scr length < or = to count,  NO termination is added
--
  poke4(stack_+4,dst)          -- set parameters
  poke4(stack_+8,src)          --
  poke4(stack_+12,cnt)         --
  call(strncpy_)               -- call assembler code
  return peek4u(stack_)        -- get return value
--
end function

----------------------------------------------------------------<>----------
global
function strpbrk(pointer str1, pointer str2)
--
-- "C" -->  char *strpbrk(const char *string1, const char *string2)
-- Locates the first occurrence of any character from string2 in string 1
-- Null terminators are not included
-- Returns a pointer to a character in str1 if a match is found OR
-- Returns ZERO if NO match is found
--
  poke4(stack_+4,str1)         -- set parameters
  poke4(stack_+8,str2)         --
  call(strpbrk_)               -- call assembler code
  return peek4u(stack_)        -- get return value
--
end function

-----------------------------------------------------------------<>----------
global
function strrchr(pointer str, int chr)
--
-- "C" --> char *strrchr(const char *string, int c)
-- Finds the last occurance of c in string.
-- Returns ptr to the last occurance of char in string or ZERO if not found
--
  poke4(stack_+4,str)          -- set parameters
  poke4(stack_+8,chr)          --
  call(strrchr_)               -- call assembler code
  return peek4u(stack_)        -- get return value
--
end function

-----------------------------------------------------------------<>----------
global
function strset(pointer str, int chr)
--
-- "C" --> char *strset(const char *string, int c)
-- put all characters in string to c excluding null termination byte
-- Returns pointer to the altered string
--
  poke4(stack_+4,str)          -- set parameters
  poke4(stack_+8,chr)          --
  call(strset_)                -- call assembler code
  return peek4u(stack_)        -- get return chrue
--
end function

----------------------------------------------------------------<>----------
-- strtok static variables
global  pointer savbufptr_, buffer_, token_, endbuffer_
global  bool lasttk_
  token_  = null_
  buffer_ = null_
  endbuffer_ = null_
-- end of strtok static variables
-----------------------------------------------------------------<>----------
global
function strtok(pointer buffer, pointer delimiters)
--
-- "C" -->  char *strtok(char *string1, const char *string2)
-- Isolates & returns tokens from a buffer using the delimiters in string 2
-- Make first call to strtok with buffer to be tokenized and the list of
-- delimiters to use to isolate the tokens. The first token pointer will be
-- returned. Subsequent calls with the buffer pointer set to ZERO will
-- return the next token pointer. If no more tokens are available a ZERO
-- pointer will be returned. Any time the buffer parameter is not ZERO the
-- process will restart the tokenizing with the new buffer parameter. The
-- delimiter parameter can be different or the same for each call of strtok.
-- This is a very powerful function that can be used for parsing strings.
--
  ulong tklen

  if buffer then                             -- buffer ptr ? then first time
    lasttk_ = False                          -- initialize last token flag
    buffer_ = strdup(buffer)                 -- create a duplicate of buffer
    savbufptr_ = buffer_                     -- save the ptr for later use
    token_  = string(strlen(buffer))         -- create a token buffer
    buffer_ += strspn(buffer_, delimiters)   -- go to first token
  end if                                     --
  if lasttk_ then return null_ end if          -- block if last token flag true
  tklen = strpbrk(buffer_, delimiters)       -- find the end of the token
  if tklen then                              -- if token exists
    tklen -= buffer_                         -- convert tklen ptr to a length
    token_ = strncpy(token_, buffer_, tklen) -- copy token in to token buffer
    buffer_ += tklen                         -- move buffer ptr over token
    buffer_ += strspn(buffer_, delimiters)   -- move to the next token
    return token_                            -- return the token
  elsif strlen(buffer_) then                 -- token at very end of buffer
    token_ = strcpy(token_, buffer_)         -- copy token in to token buffer
    lasttk_ = True                           -- set the last token flag
    return token_                            -- return the token
  else                                       -- no more tokens
    frees(savbufptr_)                        -- free string buffer allocation
    buffer_ = null_                            -- set buffer_ pointer to ZERO
    frees(token_)                            -- free token buffer allocation
    token_ = null_                             -- set token_ pointer to ZERO
    lasttk_ = True                           -- set the last token flag
    return null_                               -- return a null
  end if                                     --
--
end function

-----------------------------------------------------------------<>----------
global
function str2seq( pointer str )
--
-- Convert a ansi "C" type string to Euphoria sequence
--
    return peek( {str, strlen(str)} )
--
end function -- end of str2seq function

-----------------------------------------------------------------<>----------
global
function wstr2seq( pointer str )
--
-- Convert a wide "C" type string to Euphoria sequence
--
  sequence wdata
  ushort wchar

  wdata = {}
  wchar = peek2(str)
  while wchar do
    wdata &= wchar
    str += 2
    wchar = peek2(str)
  end while
  return wdata
--
end function -- end of str2seq function

-----------------------------------------------------------------<>----------
global
procedure cout(int fn, object str)
--
-- Output a "C" ansi and wide string or any other data to a file or device
-- String can be a pointer to a "C" type string, a qouted string or
-- the same format as printf but enclosing last to parameters in a sequence
--
  if atom(str) then
    str = peek( {str, strlen(str)} )
    for idx = 1 to length(str) do
      printf(fn, "%s", str[idx])
    end for
    return
  else
    if atom(str[1]) then
      for idx = 1 to length(str) do
	printf(fn, "%s", str[idx])
      end for
    else
      printf(fn, str[1], str[2])
    end if
  end if
--
end procedure -- end of cout procedure

----------------------------------------------------------------<>----------
global
function ODD(atom n)
--
-- Returns true if odd
--
  return and_bits(n,1)
--
end function

----------------------------------------------------------------<>----------
global
function ABS(atom a)
--
-- Returns absolute value
--
  if a >= 0 then return a else return -a end if
--
end function

----------------------------------------------------------------<>----------
global
function SGN(atom v)
--
-- Returns sign of v
--
  if (v > 0) then return 1
  elsif (v < 0) then return -1
  else return 0
  end if
--
end function

----------------------------------------------------------------<>----------
global
function MAX(atom a, atom b)
--
-- Returns which number is greater
--
  if a > b then return a else return b end if
--
end function

----------------------------------------------------------------<>----------
global
function MIN(atom a, atom b)
--
-- Returns which number is the smallest
--
  if a < b then return a else return b end if
--
end function

----------------------------------------------------------------<>----------
global
function ROUND(atom n)
--
-- Round to the nearest integer
--
  return floor(n+0.5)
--
end function

-----------------------------------------------------------------<>----------
global
function loc( pointer structure, sequence member )
--
-- Returns the address of a member in a structure
--
  --- Layout of the description of a structure
  ---| ptr | ST | name | offset | type | size | ... | total bytes |---
--
  int name
  sequence d

  name = 0
  d = {}
  for entry = 1 to length(MastList) do
    -- search for pointer in the list of declared structures
    if compare(structure, MastList[entry][1]) = 0 then -- found in list
      d = MastList[entry]
      exit
    end if
  end for
  if length(d) = 0 then
    error(1,"LOC FUNCTION FAILED !\n"&
      "Structure may not be declared\n",{})
    abort(1)
  end if
  name = find(member, d)                             -- look for member name
  if not name then
    error(1,"LOC FUNCTION FAILED !\n"&
      "Member %s does not exists\n",{member})
    abort(1)
  end if
  --- d[name+1] = offset --- d[name+2] = type --- d[name+3] = size ---
  ---| ptr | ST | name | offset | type | size | ... | total bytes |---
  return structure+d[name+1]
--
end function -- end of loc function

-----------------------------------------------------------------<>----------
global
procedure put(pointer structure, object member, object value)
--
-- Set a member of a structure to a value
--
  --- Layout of the description of a structure
  ---| ptr | ST | name | offset | type | size | ... | total bytes |---
--
  int name, size
  ulong case
  pointer address, buffer
  sequence d

  name = 0
  size = 0
  case = 0
  address = null_
  d = {}

  for entry = 1 to length(MastList) do
    -- search for pointer in the list of declared structures
    if compare(structure, MastList[entry][1]) = 0 then -- found in list
      d = MastList[entry]
      exit
    end if
  end for
  if length(d) = 0 then
    error(1,"PUT PROCEDURE FAILED !\n"&
      "Can not set member %s\n"&
      "Structure may not declared\n",{member})
    abort(1)
  end if
  -- is structure ?
  ---| ptr | ST | name | offset | type | size | ... | total bytes |---
  if d[2] = ST then
    -- convert a numeric offset to a name
    if atom(member) then
      if member = 1 then
	member = d[3]
      else
	member = d[(member*4)-1]
      end if
    end if
    -- look for member name
    name = find(member, d)
    if not name then
      error(1,"PUT PROCEDURE FAILED !\n"&
	"Member %s does not exist\n",{member})
      abort(1)
    end if
    address = structure+d[name+1]
    case = d[name+2]
    size = d[name+3]
  --- d[name+1] = offset --- d[name+2] = type --- d[name+3] = size ---
  ---| ptr | AR | name | offset | type | size | ... | total bytes |---
  -- is an array ?
  elsif d[2] = AR then
    case = d[5]
    if member = 0 then
      address = structure
    else
      if member >= d[6]-and_bits(#F, case) then
	error(1,"PUT PROCEDURE FAILED !\n"&
	  "The offset of %d is beyond the end of the array \n",{member})
	abort(1)
      else
	address = structure+(member*and_bits(#F, case))
      end if
    end if
  else
    error(1,"PUT PROCEDURE FAILED !\n"&
      "No structure or array exists for this member\n",{})
    abort(1)
  end if
  -- validate data and store
  if    case = double_ and double(value) then
    poke(address, atom_to_float64(value))
  --
  elsif case = float_  and float(value)  then
    poke(address, atom_to_float32(value))
  -- ansi
  elsif case = string_ and atom(value) then
    address = strncpy(address, value, size - 1)
  elsif case = string_ and sequence(value) then
    buffer = allocate_string(value)
    address = strncpy(address, buffer, size - 1)
    free(buffer)
  -- unicode
  elsif case = wstring_ and atom(value) then
    for idx = 0 to size - 1 do
      poke2(address+idx, peek2(value+idx))
    end for
  elsif case = wstring_ and sequence(value) then
    if length(value) > size - 1 then
      -- chop off to fit in buffer
      value = value[1..size]
    end if
    for idx = 1 to length(value) do
      poke2(address, value[idx])
      address += 2
    end for
    poke2(address, 0)
  --
  elsif sizeof(case) = 4 and ulong(value) then poke4(address, value)
  --
  elsif sizeof(case) = 4 and long(value) then poke4(address, value)
  --
  elsif sizeof(case) = 2 and ushort(value) then poke2(address, value)
  --
  elsif sizeof(case) = 2 and short(value) then poke2(address, value)
  --
  elsif sizeof(case) = 1 and uchar(value) then poke(address, value)
  --
  elsif sizeof(case) = 1 and char(value) then poke(address, value)
  --
  else -- error !
    error(1,"PUT FUNCTION FAILED !\nput failure using ----> "&
      "Pointer: %d  Variable: %s  Value: %d\n",{structure,member,value})
    abort(1)
  end if -- end of switch
--
end procedure -- end of put procedure

-----------------------------------------------------------------<>----------
global
function grab( pointer structure, object member )
--
-- grab a value from a member of a structure
--
  --- Layout of the description of a structure
  ---| ptr | ST | name | offset | type | size | ... | total bytes |---
--
  int name, size
  ulong case
  pointer address
  sequence d

  name = 0
  size = 0
  case = 0
  address = null_
  d = {}

  for entry = 1 to length(MastList) do
    -- search for pointer in the list of declared structures
    if compare(structure, MastList[entry][1]) = 0 then -- found in list
      d = MastList[entry]
      exit
    end if
  end for
  if length(d) = 0 then
    error(1,"GRAB FUNCTION FAILED !\n"&
      "Can not get member %s\n"&
      "Structure may not be declared\n",{member})
    abort(1)
  end if
  -- is structure ?
  ---| ptr | ST | name | offset | type | size | ... | total bytes |---
  if d[2] = ST then
    -- convert a numeric offset to a name
    if atom(member) then
      if member = 1 then
	member = d[3]
      else
	member = d[(member*4)-1]
      end if
    end if
    -- look for member name
    name = find(member, d)
    if not name then
      error(1,"GRAB FUNCTION FAILED !\n"&
	"Member %s does not exist\n",{member})
      abort(1)
    end if
    address = structure+d[name+1]
    case = d[name+2]
  -- is an array ?
  --- d[name+1] = offset --- d[name+2] = type --- d[name+3] = size ---
  ---| ptr | AR | name | offset | type | size | ... | total bytes |---
  elsif d[2] = AR then
    case = d[5]
    if member = 0 then
      address = structure
    else
      if member >= d[6]-and_bits(#F, case) then
	error(1,"GRAB FUNCTION FAILED !\n"&
	  "The offset of %d is beyond the end of the array \n",{member})
	abort(1)
      else
	address = structure+(member*and_bits(#F, case))
      end if
    end if
  else
    error(1,"GRAB FUNCTION FAILED !\n"&
      "No structure or a array exists for this member\n",{})
    abort(1)
  end if
  -- validate and return the data
  if    case = double_ then return float64_to_atom(peek({address,8}))
  --
  elsif case = float_  then return float32_to_atom(peek({address,4}))
  --
  elsif case = string_  then return address -- ansi
  --
  elsif case = wstring_ then return address -- unicode
  --
  elsif sizeof(case) = 4 then return peek4u(address)
  --
  elsif sizeof(case) = 2 then return peek2(address)
  --
  elsif sizeof(case) = 1 then return peek(address)
  --
  else -- error !
    error(1,"GRAB FUNCTION FAILED !\nPeek failure using ----> "&
      "Pointer: %d  Variable: %s  Value: %d\n",{structure,member})
    abort(1)
  end if -- end of switch
--
end function -- end of grab function

-----------------------------------------------------------------<>----------
global
function struc( sequence definition )
--
-- Builds and allocates memory for a structure
--
  --- Layout of the description of a structure
  ---| ptr | ST | name | offset | type | size | ... | total bytes |---
--
  pointer buffer, delimit, token
  sequence entry
  object list
  ulong nbytes
  bool init

  init = False
  list = definition[length(definition)]
  if atom(list) then
    buffer = string(definition)
  else
    if length(list) then
      init = True
      buffer = string(definition[1..length(definition)-1])
    else
      definition = definition[1..length(definition)-1]
      buffer = string(definition)
    end if
  end if
  --
  delimit = string(" :")
  entry = {ST} -- mark as a structure description
  list = {}
  nbytes = 0

  -- parse and build the definition list
  token = strtok(buffer, delimit)             -- get first token
  while token do                              -- last token ?
    list = append(list, str2seq(token) )      -- add token to the list
    token = strtok(null_,delimit)             -- get next token
  end while
  if remainder(length(list), 3) then          -- test number of parameters
    error(1, "STRUC FUNCTION FAILED !\n"&
      "definition not formed properly\n%s\n",
      {definition})
    abort(1)
  end if
  for ctype = 2 to length(list) by 3 do      -- convert type to constant
    token = cee(list[ctype])                 -- verify if c-type
    if token then
      list[ctype] = token                    -- replace c-type with constant
    else
      error(1, "STRUC FUNCTION FAILED !\n"&
	"invalid \"C\" type : %s\n", {list[ctype]})
      abort(1)
    end if
  end for
  for idx = 3 to length(list) by 3 do        -- convert bytes to numeric val
    list[idx] = val(list[idx])               -- replace byte with a numeric
  end for
  nbytes = 0
  for item = 1 to length(list) by 3 do       -- calculate byte allocation
    entry = append(entry,list[item])         -- name
    entry = append(entry,nbytes)             -- offset
    entry = append(entry,list[item+1])       -- type
    if list[item+1] = string_  or            -- if string
       list[item+1] = wstring_ then
       list[item+2] += 1                     -- add extra for terminator
    end if
    entry = append(entry,list[item+2])       -- size
    nbytes += list[item+2]*and_bits(#F, list[item+1])
  end for
  entry = append(entry,nbytes)               -- size of structure
  entry = prepend(entry, allocate(nbytes)) -- prepend structure pointer
  if not entry[1] then
    error(1,"STRUC FUNCTION FAILED !\n"&
      "Euphoria could not allocate memory for this structure :\n\n%s\n\n",
      {definition})
    abort(1)
  end if
  -- set structure to all zeros
  mem_set(entry[1], 0, entry[length(entry)])
  -- is an array ?
  if equal(entry[3],"[]") then
    entry[2] = AR -- yes mark as an array
  end if
  -- added to the master list
  MastList = append(MastList, entry)         -- add entry to master list
  -- or initialize to some values
  if init then
    definition = definition[length(definition)]
    for idx = 1 to length(definition) do
      put(entry[1], idx, definition[idx])
    end for
  end if
  -- free temporay strings
  frees(buffer)
  frees(delimit)
  -- return pointer
  return entry[1]
--
end function

-----------------------------------------------------------------<>----------
global
procedure clears( pointer structure )
--
-- wipes all the data from a structure
--
  mem_set(structure, 0, sizeof(structure))
--
end procedure

-----------------------------------------------------------------<>----------
global
function dups( pointer structure )
--
-- Duplicates a structure including data
--
  --- Layout of the description of a structure
  ---| ptr | ST | name | offset | type | size | ... | total bytes |---
--
  pointer original
  sequence d

  original = null_
  d = {}
  for entry = 1 to length(MastList) do
    -- search for pointer in the list of declared structures
    if compare(structure, MastList[entry][1]) = 0 then -- found in list
      d = MastList[entry]
      exit
    end if
  end for
  if length(d) = 0 then
    error(1,"DUPS FUNCTION FAILED !\n"&
      "Structure may not be declared",{})
    abort(1)
  end if
  ---| ptr | ST | name | offset | type | size | ... | total bytes |---
  original = d[1]
  d[1] = allocate(sizeof(original))
  if d[1] = 0 then
    error(1,"DUPS FUNCTION FAILED !\n"&
      "Can not allocate memory\n",{})
    abort(1)
  end if
  mem_copy(d[1], original, sizeof(original))
  MastList = append(MastList, d)
  return d[1]
--
end function

-----------------------------------------------------------------<>----------
global
procedure outs( long handle, pointer block, ulong size )
--
-- Outputs a memory block or binary structure to a file
--
  puts(handle, peek({block, size}))
--
end procedure -- end of outs procedure

-----------------------------------------------------------------<>----------
global
function ins( long handle, pointer block, ulong size )
--
-- Inputs a memory block or binary structure from a file
--
  ulong idx
  integer data
  idx =  0

  data = getc(handle)
  while idx < size - 1 do
    if data = -1 then exit end if
    poke(block+idx, data)
    data = getc(handle)
    idx += 1
  end while
  return idx
--
end function -- end of ins function

-----------------------------------------------------------------<>----------
function xpnd( sequence s )
--
  sequence x

  x = {}
  for idx = 1 to length(s) do
    if s[idx] = '\t' then
      x &= "        "
    else
      x &= s[idx]
    end if
  end for
  return x
--
end function

-----------------------------------------------------------------<>----------
--
-- logically OR a list of attributes
--
global
function or_list( sequence list )
--
  atom member
  member = 0

  if atom(list) then
    return list
  else
    for i = 1 to length(list) do
      member = or_bits(member, list[i])
    end for
    return member
  end if
--
end function -- end of list_all function

-----------------------------------------------------------------<>----------
sequence libs, save4
libs = repeat(-1,length(LibList))

function cdecl(sequence name, sequence parameters)
--
-- declares and/or calls a "C" function or declares a "C" structure
--
-- definition     --| used | name | lib | parms | return |--
  int offset
  atom id, lib, ptr
  sequence parms, msg

  offset = 0
  -- search the DefList for a definition
  for entry = 1 to length( DefList ) do
    if compare( name, DefList[entry][2] ) = 0 then
      -- found
      if length(DefList[entry]) > 3 then  -- test if a structure
	if DefList[entry][4][1] = 99 then -- no is variable arguments ?
	  offset = entry                  -- yes
	  exit
	end if
      end if
      -- already declared ?
      if DefList[entry][1] and length(DefList[entry]) > 3 then
	-- function ?
	if DefList[entry][length(DefList[entry])] then
	  return c_func(DefList[entry][1], parameters)
	else
	  c_proc(DefList[entry][1], parameters)
	  return 0
	end if
      end if
      offset = entry
      exit
    end if
  end for
  -- found and is a function that needs to be declared
  if offset and length(DefList[offset]) > 3 then
    if libs[DefList[offset][3]] = -1 then
      libs[DefList[offset][3]] = open_dll(LibList[DefList[offset][3]])
      if libs[DefList[offset][3]] = -1 then
	error(1,"CDECL FUNCTION FAILED !\n"&
	  "Could not Open library %s\n"&
	  "open_dll returned -1\n",{LibList[DefList[offset][3]]})
	abort(1)
      end if
    end if
    lib = libs[DefList[offset][3]]
    if DefList[offset][4][1] = 99 then -- variable parameters
      parms = {}
      -- build fixed part of parameter list
      for fixed = 2 to length(DefList[offset][4]) do
	parms = append(parms,DefList[offset][4][fixed])
      end for
      -- build variable part of parameter list
      for arg = 0 to length(parameters)-length(parms)-1 do
	parms = append(parms,long_)
      end for
      -- define the function
      if DefList[offset][length(DefList[offset])] then
	id =  define_c_func(lib, DefList[offset][2], parms, DefList[offset][5])
	msg = "define_c_func"
      else
	id =  define_c_proc(lib, DefList[offset][2], parms)
	msg = "define_c_proc"
      end if
      if id = -1 then
	error(1,"CDECL FUNCTION FAILED !\n"&
	  "%s %s returned -1\n"&
	  "verify argument list by using man %s command\n",{msg,name,name})
	abort(1)
      end if
      DefList[offset][1] = id
      -- do recursive call to execute new declared function
      save4 = DefList[offset][4]               -- save parameter description
      DefList[offset][4] = parms               -- set variable arguments
      ptr = cdecl(name, parameters)            -- do recursive call
      DefList[offset][4]  = save4              -- restore parm description
      return ptr                               -- return pointer
    else
      if DefList[offset][4][1] = null_ then
	parms = {}
      else
	parms = DefList[offset][4]
      end if
      -- define the function
      if DefList[offset][5] then
	id =  define_c_func(lib, DefList[offset][2], parms, DefList[offset][5])
	msg = "define_c_func"
      else
	id =  define_c_proc(lib, DefList[offset][2], parms)
	msg = "define_c_proc"
      end if
      if id = -1 then
	error(1,"CDECL FUNCTION FAILED !\n"&
	  "%s %s returned -1\n",{msg,name})
	abort(1)
      end if
      DefList[offset][1] = id
      -- do recursive call to execute new declared function
      return cdecl(name, parameters)
      --
    end if
  elsif offset then
    -- declaring a structure
    return struc(DefList[offset][3]&{parameters})
  else
    error(1,"CDECL FUNCTION FAILED !\n"&
      "Structure or function not found\n"&
      "%s not in DefList definitions\n",{name})
    abort(1)
  end if
--
end function

-----------------------------------------------------------------<>----------
global
function wstring( object data )
--
-- Allocate a empty UNICODE "C" type string buffer or
-- builds a initialized "C" type string.
-- Returns a pointer to the new string
--
  ulong size
  pointer str

  if atom(data) then                 -- wants a empty string ?
    str = allocate(data*2+2)         -- yes, allocate a empty string
    mem_set(str, 0, data*2+2)        -- initialize it to zero
    size = data+2                    -- save the size
  else
    size = length(data)*2+2
    str = allocate(size)             -- allocate and initialize
    mem_set(str, 0, size)            -- initialize it to zero
    for idx = 0 to length(data) - 1 do
      poke2(str+idx, data[idx+1])
    end for
  end if
  ---| ptr | ST | name | offset | type | size | ... | total bytes |---
  MastList = append(MastList, { str, WST, "none", 0, wstring_, size - 2, size } )
  return str
--
end function -- end of String function

-----------------------------------------------------------------<>----------
--
-- Associates pointer to a structure that was returned by a "C"
--
global
procedure AssociatePtr( pointer address, sequence structure )
  -- declare
  pointer ptr

  ---| ptr | ST | name | offset | type | size | ... | total bytes |---
  ptr = cdecl(structure,{})
  MastList[length(MastList)][1] = address

  free(ptr)
--
end procedure -- end of AssociatePtr procedure

-- ==========================================================================
--=========================================================================--
-- ==========================================================================
-- GRAPHICS.E
-- ==========================================================================
--=========================================================================--
--=========================================================================--
--
-- binary image of font8x8 follows
global constant eu1_font8x8 =
     {
    0,   0,   0,   0,   0,   0,   0,   0, 126, 129, 165, 129, 189, 129, 126,   0, --    0 to   15
  126, 255, 219, 255, 195, 255, 126,   0,  54, 127, 127, 127,  62,  28,   8,   0, --   16 to   31
    8,  28,  62, 127,  62,  28,   8,   0,  28,  28,   8, 107, 127, 107,   8,  28, --   32 to   47
    8,  28,  62, 127,  62,   8,  28,  62,   0,   0,  24,  60,  60,  24,   0,   0, --   48 to   63
  255, 255, 231, 195, 195, 231, 255, 255,   0,  60, 102,  66,  66, 102,  60,   0, --   64 to   79
  255, 195, 153, 189, 189, 153, 195, 255,  15,   7,  13,  60, 102, 102, 102,  60, --   80 to   95
   60, 102, 102, 102,  60,  24, 126,  24,  48,  56,  60,  54,  52, 112, 240, 224, --   96 to  111
  127,  99, 127,  99,  99, 103, 230, 192,  24, 219, 126, 102, 102, 126, 219,  24, --  112 to  127
   64, 112, 124, 127, 124, 112,  64,   0,   1,   7,  31, 127,  31,   7,   1,   0, --  128 to  143
   24,  60, 126,  24,  24, 126,  60,  24, 102, 102, 102, 102, 102,   0, 102,   0, --  144 to  159
   63, 122, 122,  58,  10,  10,  10,   0,  30,  51,  28,  54,  54,  28, 102,  60, --  160 to  175
    0,   0,   0,   0, 126, 126, 126,   0,  24,  60, 126,  24, 126,  60,  24, 126, --  176 to  191
   24,  60, 126,  24,  24,  24,  24,   0,  24,  24,  24,  24, 126,  60,  24,   0, --  192 to  207
    0,  12,  14, 127,  14,  12,   0,   0,   0,  24,  56, 127,  56,  24,   0,   0, --  208 to  223
    0,   0,  96,  96,  96, 127,   0,   0,   0,  36, 102, 255, 102,  36,   0,   0, --  224 to  239
    0,  24,  60, 126, 255, 255,   0,   0,   0, 255, 255, 126,  60,  24,   0,   0, --  240 to  255
    0,   0,   0,   0,   0,   0,   0,   0,  24,  24,  24,  24,  24,   0,  24,   0, --  256 to  271
  102, 102, 102,   0,   0,   0,   0,   0, 108, 108, 254, 108, 254, 108, 108,   0, --  272 to  287
   16, 124, 208, 124,  22, 124,  16,   0,   0, 198, 204,  24,  48, 102, 198,   0, --  288 to  303
   56, 108,  56, 118, 220, 204, 118,   0,  24,  24,  48,   0,   0,   0,   0,   0, --  304 to  319
   12,  24,  48,  48,  48,  24,  12,   0,  48,  24,  12,  12,  12,  24,  48,   0, --  320 to  335
    0, 108,  56, 254,  56, 108,   0,   0,   0,  24,  24, 126,  24,  24,   0,   0, --  336 to  351
    0,   0,   0,   0,   0,  24,  24,  48,   0,   0,   0, 126,   0,   0,   0,   0, --  352 to  367
    0,   0,   0,   0,   0,  48,  48,   0,   0,   6,  12,  24,  48,  96, 192,   0, --  368 to  383
   60, 102, 110, 126, 118, 102,  60,   0,  12,  28,  60,  12,  12,  12,  12,   0, --  384 to  399
   60, 102,   6,  28,  48,  96, 126,   0,  60, 102,   6,  28,   6, 102,  60,   0, --  400 to  415
   28,  60, 108, 204, 254,  12,  12,   0, 126,  96,  96, 124,   6, 102,  60,   0, --  416 to  431
   60,  96,  96, 124, 102, 102,  60,   0, 126,   6,   6,  12,  24,  48,  48,   0, --  432 to  447
   60, 102, 102,  60, 102, 102,  60,   0,  60, 102, 102,  62,   6,   6,  60,   0, --  448 to  463
    0,  48,  48,   0,   0,  48,  48,   0,   0,  24,  24,   0,   0,  24,  24,  48, --  464 to  479
   12,  24,  48,  96,  48,  24,  12,   0,   0,   0, 126,   0,   0, 126,   0,   0, --  480 to  495
   48,  24,  12,   6,  12,  24,  48,   0,  60, 102,   6,  12,  24,   0,  24,   0, --  496 to  511
   60, 102, 110, 110, 108,  96,  60,   0,  24,  60, 102, 102, 126, 102, 102,   0, --  512 to  527
  124, 102, 102, 124, 102, 102, 124,   0,  60, 102,  96,  96,  96, 102,  60,   0, --  528 to  543
  124, 102, 102, 102, 102, 102, 124,   0, 126,  96,  96, 124,  96,  96, 126,   0, --  544 to  559
  126,  96,  96, 124,  96,  96,  96,   0,  60, 102,  96, 110, 102, 102,  60,   0, --  560 to  575
  102, 102, 102, 126, 102, 102, 102,   0,  60,  24,  24,  24,  24,  24,  60,   0, --  576 to  591
    6,   6,   6,   6, 102, 102,  60,   0, 102, 108, 120, 112, 120, 108, 102,   0, --  592 to  607
   96,  96,  96,  96,  96,  96, 126,   0, 198, 238, 254, 214, 198, 198, 198,   0, --  608 to  623
  102, 118, 126, 110, 102, 102, 102,   0,  60, 102, 102, 102, 102, 102,  60,   0, --  624 to  639
  124, 102, 102, 124,  96,  96,  96,   0,  60, 102, 102, 102, 102, 110,  60,   6, --  640 to  655
  124, 102, 102, 124, 102, 102, 102,   0,  60, 102,  96,  60,   6, 102,  60,   0, --  656 to  671
  126,  24,  24,  24,  24,  24,  24,   0, 102, 102, 102, 102, 102, 102,  60,   0, --  672 to  687
  102, 102, 102, 102, 102,  60,  24,   0, 198, 198, 198, 214, 254, 238, 198,   0, --  688 to  703
  102, 102,  60,  24,  60, 102, 102,   0, 102, 102, 102,  60,  24,  24,  24,   0, --  704 to  719
  126,   6,  12,  24,  48,  96, 126,   0,  60,  48,  48,  48,  48,  48,  60,   0, --  720 to  735
    0, 192,  96,  48,  24,  12,   6,   0,  60,  12,  12,  12,  12,  12,  60,   0, --  736 to  751
   24,  60, 102,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 255, --  752 to  767
   24,  24,  12,   0,   0,   0,   0,   0,   0,   0,  60,   6,  62, 102,  62,   0, --  768 to  783
   96,  96,  96, 124, 102, 102, 124,   0,   0,   0,  60, 102,  96, 102,  60,   0, --  784 to  799
    6,   6,   6,  62, 102, 102,  62,   0,   0,   0,  60, 102, 126,  96,  62,   0, --  800 to  815
   28,  54,  48, 124,  48,  48,  48,   0,   0,   0,  62, 102, 102,  62,   6,  60, --  816 to  831
   96,  96, 124, 102, 102, 102, 102,   0,  24,   0,  24,  24,  24,  24,  24,   0, --  832 to  847
   12,   0,  12,  12,  12,  12, 108,  56,  96,  96, 102, 108, 120, 108, 102,   0, --  848 to  863
   48,  48,  48,  48,  48,  48,  24,   0,   0,   0, 236, 254, 214, 214, 198,   0, --  864 to  879
    0,   0, 124, 102, 102, 102, 102,   0,   0,   0,  60, 102, 102, 102,  60,   0, --  880 to  895
    0,   0, 124, 102, 102, 124,  96,  96,   0,   0,  62, 102, 102,  62,   6,   6, --  896 to  911
    0,   0, 124, 102,  96,  96,  96,   0,   0,   0,  62,  96,  60,   6, 124,   0, --  912 to  927
   48,  48, 124,  48,  48,  54,  28,   0,   0,   0, 102, 102, 102, 102,  62,   0, --  928 to  943
    0,   0, 102, 102, 102,  60,  24,   0,   0,   0, 198, 214, 254, 238,  68,   0, --  944 to  959
    0,   0, 102,  60,  24,  60, 102,   0,   0,   0, 102, 102, 102,  62,   6,  60, --  960 to  975
    0,   0, 126,  12,  24,  48, 126,   0,  28,  48,  48,  96,  48,  48,  28,   0, --  976 to  991
   24,  24,  24,  24,  24,  24,  24,   0,  56,  12,  12,   6,  12,  12,  56,   0, --  992 to 1007
  118, 220,   0,   0,   0,   0,   0,   0,   0,   0,  24,  60, 102, 102, 126,   0, -- 1008 to 1023
   60, 102,  96,  96, 102,  60,  24,  48, 102,   0, 102, 102, 102, 102,  62,   0, -- 1024 to 1039
   14,   0,  60, 102, 126,  96,  60,   0,  60, 102,  60,   6,  62, 102,  62,   0, -- 1040 to 1055
  102,   0,  60,   6,  62, 102,  62,   0, 112,   0,  60,   6,  62, 102,  62,   0, -- 1056 to 1071
   24,  24,  60,   6,  62, 102,  62,   0,   0,   0,  62,  96,  96,  62,  24,  48, -- 1072 to 1087
   60, 102,  60, 102, 126,  96,  60,   0, 102,   0,  60, 102, 126,  96,  60,   0, -- 1088 to 1103
  112,   0,  60, 102, 126,  96,  60,   0, 102,   0,  24,  24,  24,  24,  24,   0, -- 1104 to 1119
   60, 102,  24,  24,  24,  24,  24,   0, 112,   0,  24,  24,  24,  24,  24,   0, -- 1120 to 1135
  198,  56, 108, 198, 254, 198, 198,   0,  24,  24,   0,  60, 102, 126, 102,   0, -- 1136 to 1151
   14,   0, 124,  96, 120,  96, 124,   0,   0,   0, 126,  26, 126, 216, 126,   0, -- 1152 to 1167
   62, 120, 216, 222, 248, 216, 222,   0,  60, 102,  60, 102, 102, 102,  60,   0, -- 1168 to 1183
  102,   0,  60, 102, 102, 102,  60,   0, 112,   0,  60, 102, 102, 102,  60,   0, -- 1184 to 1199
   60, 102,   0, 102, 102, 102,  62,   0, 112,   0, 102, 102, 102, 102,  62,   0, -- 1200 to 1215
  102,   0, 102, 102, 102,  62,   6,  60, 102,  60, 102, 102, 102, 102,  60,   0, -- 1216 to 1231
  102,   0, 102, 102, 102, 102,  60,   0,  12,  12,  62,  96,  96,  62,  12,  12, -- 1232 to 1247
   56, 108,  96, 240,  96, 102, 252,   0, 102, 102,  60,  24, 126,  24, 126,  24, -- 1248 to 1263
  124, 102, 102, 124, 102, 111, 102,  99,  14,  27,  24,  60,  24,  24, 120,  48, -- 1264 to 1279
   14,   0,  60,   6,  62, 102,  62,   0,  14,   0,  24,  24,  24,  24,  24,   0, -- 1280 to 1295
   14,   0,  60, 102, 102, 102,  60,   0,  14,   0, 102, 102, 102, 102,  62,   0, -- 1296 to 1311
  118, 220,   0, 124, 102, 102, 102,   0, 126,   0, 102, 118, 126, 110, 102,   0, -- 1312 to 1327
   62, 102, 102,  62,   0, 126,   0,   0,  60, 102, 102,  60,   0, 126,   0,   0, -- 1328 to 1343
   24,   0,  24,  48,  96, 102,  60,   0,   0,   0,   0, 126,  96,  96,   0,   0, -- 1344 to 1359
    0,   0,   0, 126,   6,   6,   0,   0, 198, 204, 216,  62,  99, 198,  12,  31, -- 1360 to 1375
  198, 204, 216,  54, 110, 214,  31,   6,  24,   0,  24,  24,  24,  24,  24,   0, -- 1376 to 1391
    0,  54, 108, 216, 108,  54,   0,   0,   0, 216, 108,  54, 108, 216,   0,   0, -- 1392 to 1407
   34, 136,  34, 136,  34, 136,  34, 136,  85, 170,  85, 170,  85, 170,  85, 170, -- 1408 to 1423
  221, 119, 221, 119, 221, 119, 221, 119,   8,   8,   8,   8,   8,   8,   8,   8, -- 1424 to 1439
    8,   8,   8,   8, 248,   8,   8,   8,   8,   8,   8, 248, 248,   8,   8,   8, -- 1440 to 1455
   28,  28,  28,  28, 252,  28,  28,  28,   0,   0,   0,   0, 252,  28,  28,  28, -- 1456 to 1471
    0,   0,   0, 248, 248,   8,   8,   8,  28,  28,  28, 252, 252,  28,  28,  28, -- 1472 to 1487
   28,  28,  28,  28,  28,  28,  28,  28,   0,   0,   0, 252, 252,  28,  28,  28, -- 1488 to 1503
   28,  28,  28, 252, 252,   0,   0,   0,  28,  28,  28,  28, 252,   0,   0,   0, -- 1504 to 1519
    8,   8,   8, 248, 248,   0,   0,   0,   0,   0,   0,   0, 248,   8,   8,   8, -- 1520 to 1535
    8,   8,   8,   8,  15,   0,   0,   0,   8,   8,   8,   8, 255,   0,   0,   0, -- 1536 to 1551
    0,   0,   0,   0, 255,   8,   8,   8,   8,   8,   8,   8,  15,   8,   8,   8, -- 1552 to 1567
    0,   0,   0,   0, 255,   0,   0,   0,   8,   8,   8,   8, 255,   8,   8,   8, -- 1568 to 1583
    8,   8,   8,  15,  15,   8,   8,   8,  28,  28,  28,  28,  31,  28,  28,  28, -- 1584 to 1599
   28,  28,  28,  31,  31,   0,   0,   0,   0,   0,   0,  31,  31,  28,  28,  28, -- 1600 to 1615
   28,  28,  28, 255, 255,   0,   0,   0,   0,   0,   0, 255, 255,  28,  28,  28, -- 1616 to 1631
   28,  28,  28,  31,  31,  28,  28,  28,   0,   0,   0, 255, 255,   0,   0,   0, -- 1632 to 1647
   28,  28,  28, 255, 255,  28,  28,  28,   8,   8,   8, 255, 255,   0,   0,   0, -- 1648 to 1663
   28,  28,  28,  28, 255,   0,   0,   0,   0,   0,   0, 255, 255,   8,   8,   8, -- 1664 to 1679
    0,   0,   0,   0, 255,  28,  28,  28,  28,  28,  28,  28,  31,   0,   0,   0, -- 1680 to 1695
    8,   8,   8,  15,  15,   0,   0,   0,   0,   0,   0,  15,  15,   8,   8,   8, -- 1696 to 1711
    0,   0,   0,   0,  31,  28,  28,  28,  28,  28,  28,  28, 255,  28,  28,  28, -- 1712 to 1727
    8,   8,   8, 255, 255,   8,   8,   8,   8,   8,   8,   8, 248,   0,   0,   0, -- 1728 to 1743
    0,   0,   0,   0,  15,   8,   8,   8, 255, 255, 255, 255, 255, 255, 255, 255, -- 1744 to 1759
    0,   0,   0,   0, 255, 255, 255, 255, 240, 240, 240, 240, 240, 240, 240, 240, -- 1760 to 1775
   15,  15,  15,  15,  15,  15,  15,  15, 255, 255, 255, 255,   0,   0,   0,   0, -- 1776 to 1791
    0,   0, 118, 204, 204, 204, 118,   0,  60, 102, 102, 124, 102, 102, 124,  96, -- 1792 to 1807
  126, 102,  96,  96,  96,  96,  96,   0,   0,   0, 254, 108, 108, 108, 102,   0, -- 1808 to 1823
  126, 102,  48,  24,  48, 102, 126,   0,   0,   0,  62, 108, 108, 108,  56,   0, -- 1824 to 1839
    0,   0, 102, 102, 102, 102, 127, 192,   0,   0, 126, 216,  24,  24,  12,   0, -- 1840 to 1855
  124,  56, 124, 214, 214, 124,  56, 124, 124, 198, 198, 254, 198, 198, 124,   0, -- 1856 to 1871
  124, 198, 198, 198, 108, 108, 238,   0,  30,  48,  24,  60, 102, 102,  60,   0, -- 1872 to 1887
    0,   0, 126, 219, 219, 126,   0,   0,   3,   6,  62, 107, 115,  62,  96, 192, -- 1888 to 1903
   30,  48,  96, 126,  96,  48,  30,   0, 124, 198, 198, 198, 198, 198, 198,   0, -- 1904 to 1919
    0, 126,   0, 126,   0, 126,   0,   0,  24,  24, 126,  24,  24,   0, 126,   0, -- 1920 to 1935
   48,  24,  12,  24,  48,   0, 126,   0,  12,  24,  48,  24,  12,   0, 126,   0, -- 1936 to 1951
   14,  27,  27,  24,  24,  24,  24,  24,  24,  24,  24,  24,  24, 216, 216, 112, -- 1952 to 1967
   24,  24,   0, 126,   0,  24,  24,   0,   0, 118, 220,   0, 118, 220,   0,   0, -- 1968 to 1983
   60, 102, 102,  60,   0,   0,   0,   0,   0,   0,   0,  24,  24,   0,   0,   0, -- 1984 to 1999
    0,   0,   0,   0,  24,   0,   0,   0,  30,  24,  24,  24,  24, 216, 120,  56, -- 2000 to 2015
  120, 108, 108, 108, 108,   0,   0,   0,  56,  12,  24,  48,  60,   0,   0,   0, -- 2016 to 2031
    0,   0,  60,  60,  60,  60,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0  -- 2032 to 2047
     }

-- machine() commands
constant M_SOUND          = 1,
	 M_CURSOR         = 6,
	 M_WRAP           = 7,
	 M_SCROLL         = 8,
	 M_SET_T_COLOR    = 9,
	 M_SET_B_COLOR    = 10,
	 M_TEXTROWS       = 12,
	 M_VIDEO_CONFIG   = 13,
	 M_GET_POSITION   = 25

-- COLOR values -- for characters and pixels

global integer RED, BROWN, BLUE, CYAN, BRIGHT_RED,
	       YELLOW, BRIGHT_BLUE, BRIGHT_CYAN

  -- GRAPHICS MODE -- TEXT MODE --
      --  4 --        --  1 -- red.
      --  6 --        --  3 -- brown.
      --  1 --        --  4 -- blue.
      --  3 --        --  6 -- cyan.
      -- 12 --        --  9 -- light red.
      -- 14 --        -- 11 -- yellow (light brown).
      --  9 --        -- 12 -- light blue.
      -- 11 --        -- 14 -- light cyan.

global constant
  BLACK = 0,           --    -- black. in graphics modes this is "transparent"
  GREEN = 2,           --    -- green.
  MAGENTA = 5,         --    -- magenta.
  WHITE = 7,           --    -- grey.
  GRAY  = 8,           --    -- dark grey (light black).
  BRIGHT_GREEN = 10,   --    -- light green.
  BRIGHT_MAGENTA = 13, --    -- light magenta.
  BRIGHT_WHITE = 15,   --    -- white (light grey).
  BLINKING = 16,       --    -- add to color to get blinking text.

  VC_COLOR   = 1,
  VC_MODE    = 2,
  VC_LINES   = 3,
  VC_COLUMNS = 4,
  VC_XPIXELS = 5,
  VC_YPIXELS = 6,
  VC_NCOLORS = 7,
  VC_PAGES   = 8

atom retval
int GRAPHICS GRAPHICS = TEXT

-- enable wrap on - default
bool WRAP WRAP = True
--
-- general purpose variable
object ok
--
integer internal_text_color, internal_bkcolor, internal_line, internal_col
integer active_font_width, active_font_height, internal_scanseg, first_time
sequence active_font
--
  active_font = eu1_font8x8
  active_font_height = 8
  active_font_width = 8

global
procedure setactivefont(sequence name, integer fontwidth, integer fontheight)
--
  active_font = name
  active_font_width = fontwidth
  active_font_height = fontheight
--
end procedure

  internal_scanseg = -1
  internal_text_color = 15
  internal_bkcolor = 0
  internal_line = 1
  internal_col = 1

function  getcurrentcontext()
--
  atom currentcontext

  currentcontext = define_c_var(open_dll(LibList[2]), "currentcontext")
  if currentcontext = -1 then
    puts(1, "Couldn't find \"currentcontext\" pointer\n")
    abort(1)
  end if
  return currentcontext
--
end function

procedure init_mse()
--
-- set mouse to middle of screen, hidden
-- confine mouse to visible screen area
--
  ok = cdecl("vga_setmousesupport",{1})
  ok = cdecl("mouse_setxrange",{0, cdecl("vga_getxdim",{})})
  ok = cdecl("mouse_setyrange",{0, cdecl("vga_getydim",{})})
  ok = cdecl("mouse_setposition",{floor(cdecl("vga_getxdim",{})/2),
				  floor(cdecl("vga_getydim",{})/2)})
  first_time = False
--
end procedure -- init_mse

procedure init_joy()
--
  ok = cdecl("joystick_setdefaulthandler",{0}) -- single device
--
end procedure -- init_mse

global
function graphics_mode(integer m)
-- try to set up a new graphics mode
-- return 0 if successful, non-zero if failed
  integer status
  status = -1

  if m < 4 or m = 7 or m = -1 or m = TEXT then
    m = TEXT
    status = cdecl("vga_setmode",{TEXT})
  elsif m = 4 or m = 5 or m = 13 then
    status = cdecl("vga_setmode",{G320x200x16})
  elsif m = 6 or m = 14 then
    status = cdecl("vga_setmode",{G640x200x16})
  elsif m = 11 then
    status = cdecl("vga_setmode",{G720x348x2})
  elsif m = 15 or m = 16 then
    status = cdecl("vga_setmode",{G640x350x16})
  elsif m = 17 then
    status = cdecl("vga_setmode",{G640x480x2})
  elsif m = 18 then
    status = cdecl("vga_setmode",{G640x480x16})
  elsif m = 19 then
    status = cdecl("vga_setmode",{G320x200x256})
  elsif m = 256 then
    status = cdecl("vga_setmode",{G640x400x256})
  elsif m = 257 then
    status = cdecl("vga_setmode",{G640x480x256})
  elsif m = 258 then
    status = cdecl("vga_setmode",{G800x600x16})
  elsif m = 259 then
    status = cdecl("vga_setmode",{G800x600x256})
  elsif m = 260 then
    status = cdecl("vga_setmode",{G1024x768x16})
  elsif m = 261 then
    status = cdecl("vga_setmode",{G1024x768x256})
  elsif m >= #800  then m = and_bits(#7FF,m)
    status = cdecl("vga_setmode",{m})
  end if
  GRAPHICS = m
  init_mse()
  init_joy()
  internal_scanseg = allocate(2048)
  ok = cdecl("keyboard_setdefaulteventhandler",{})
  ok = cdecl("keyboard_translatekeys",{
	      TRANSLATE_CURSORKEYS+   -- Map cursor block to keypad cursor.
	      TRANSLATE_DIAGONAL+     -- Map keypad diagonal to keypad cursor.
	      TRANSLATE_KEYPADENTER}) -- Map keypad enter to main enter key.
  if GRAPHICS then
    -- use graphics colors
    RED   = 4            --  1 -- red.
    BROWN = 6            --  3 -- brown.
    BLUE  = 1            --  4 -- blue.
    CYAN =  3            --  6 -- cyan.
    BRIGHT_RED = 12      --  9 -- light red.
    YELLOW = 14          -- 11 -- yellow (light brown).
    BRIGHT_BLUE = 9      -- 12 -- light blue.
    BRIGHT_CYAN = 11     -- 14 -- light cyan.
  else
    -- use text colors
    RED   = 1            --  4 -- red.
    BROWN = 3            --  6 -- brown.
    BLUE  = 4            --  1 -- blue.
    CYAN =  6            --  3 -- cyan.
    BRIGHT_RED = 9       -- 12 -- light red.
    YELLOW = 11          -- 14 -- yellow (light brown).
    BRIGHT_BLUE = 12     --  9 -- light blue.
    BRIGHT_CYAN = 14     -- 11 -- light cyan.
  end if
  return status
--
end function
--
global function vga_setmode(object parms) if atom(parms) then GRAPHICS = parms else GRAPHICS = parms[1] end if return graphics_mode(or_bits(#800,GRAPHICS)) end function
global function vga_hasmode(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_hasmode",parms) return retval end function
global function vga_setflipchar(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_setflipchar",parms) return retval end function
global function vga_clear() retval = cdecl("vga_clear",{})  return retval end function
global function vga_flip() retval = cdecl("vga_flip",{}) return retval end function
global function vga_getxdim() retval = cdecl("vga_getxdim",{}) return retval end function
global function vga_getydim() retval = cdecl("vga_getydim",{}) return retval end function
global function vga_getcolors() retval = cdecl("vga_getcolors",{}) return retval end function
global function vga_setpalette(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_setpalette",parms) return retval end function
global function vga_getpalette(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_getpalette",parms) return retval end function
global function vga_setpalvec(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_setpalvec",parms) return retval end function
global function vga_getpalvec(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_getpalvec",parms) return retval end function
global function vga_screenoff() retval = cdecl("vga_screenoff",{}) return retval end function
global function vga_screenon() retval = cdecl("vga_screenon",{}) return retval end function
global procedure vga_setcolor(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_setcolor",parms) end procedure
global function vga_drawpixel(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_drawpixel",parms) return retval end function
global function vga_drawline(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_drawline",parms) return retval end function
global function vga_drawscanline(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_drawscanline",parms) return retval end function
global function vga_drawscansegment(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_drawscansegment",parms) return retval end function
global function vga_getpixel(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_getpixel",parms) return retval end function
global function vga_getscansegment(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_getscansegment",parms) return retval end function
global function vga_getch() retval = cdecl("vga_getch",{}) return retval end function
global function vga_dumpregs() retval = cdecl("vga_dumpregs",{}) return retval end function
global function vga_getmodeinfo(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_getmodeinfo",parms) return retval end function
global function vga_getdefaultmode() retval = cdecl("vga_getdefaultmode",{}) return retval end function
global function vga_getcurrentmode() retval = cdecl("vga_getcurrentmode",{}) return retval end function
global function vga_getcurrentchipset() retval = cdecl("vga_getcurrentchipset",{}) return retval end function
global function vga_getmodename(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_getmodename",parms) return retval end function
global function vga_getmodenumber(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_getmodenumber",parms) return retval end function
global function vga_lastmodenumber() retval = cdecl("vga_lastmodenumber",{}) return retval end function
global function vga_getoptmode(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_getoptmode",parms) return retval end function
global function vga_getgraphmem() retval = cdecl("vga_getgraphmem",{}) return retval end function
global function vga_setpage(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_setpage",parms) return retval end function
global function vga_setreadpage(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_setreadpage",parms) return retval end function
global function vga_setwritepage(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_setwritepage",parms) return retval end function
global function vga_setlogicalwidth(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_setlogicalwidth",parms) return retval end function
global function vga_setdisplaystart(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_setdisplaystart",parms) return retval end function
global procedure vga_waitretrace() retval = cdecl("vga_waitretrace",{}) end procedure
global function vga_claimvideomemory(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_claimvideomemory",parms) return retval end function
global procedure vga_disabledriverreport() retval = cdecl("vga_disabledriverreport",{}) end procedure
global procedure vga_setmodeX() retval = cdecl("vga_setmodeX",{}) retval = graphics_mode(or_bits(#800,vga_getcurrentmode())) end procedure
global function vga_init() retval = cdecl("vga_init",{}) return retval end function
global function vga_getmousetype() retval = cdecl("vga_getmousetype",{}) return retval end function
global function vga_getmonitortype() retval = cdecl("vga_getmonitortype",{}) return retval end function
global procedure vga_setmousesupport(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_setmousesupport",parms) end procedure
global procedure vga_lockvc() retval = cdecl("vga_lockvc",{}) end procedure
global procedure vga_unlockvc() retval = cdecl("vga_unlockvc",{}) end procedure
global function vga_getkey() retval = cdecl("vga_getkey",{}) return retval end function
global function vga_oktowrite() retval = cdecl("vga_oktowrite",{}) return retval end function
global procedure vga_copytoplanar256(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_copytoplanar256",parms) end procedure
global procedure vga_copytoplanar16(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_copytoplanar16",parms) end procedure
global procedure vga_copytoplane(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_copytoplane",parms) end procedure
global function vga_setlinearaddressing() retval = cdecl("vga_setlinearaddressing",{}) return retval end function
global procedure vga_safety_fork(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_safety_fork",parms) end procedure
global procedure vga_setchipset(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_setchipset",parms) end procedure
global procedure vga_setchipsetandfeatures(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_setchipsetandfeatures",parms) end procedure
global procedure vga_gettextfont(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_gettextfont",parms) end procedure
global procedure vga_puttextfont(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_puttextfont",parms) end procedure
global procedure vga_settextmoderegs(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_settextmoderegs",parms) end procedure
global procedure vga_gettextmoderegs(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_gettextmoderegs",parms) end procedure
global function vga_white() retval = cdecl("vga_white",{}) return retval end function
global function vga_setegacolor(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_setegacolor",parms) return retval end function
global function vga_setrgbcolor(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_setrgbcolor",parms) return retval end function
global procedure vga_bitblt() retval = cdecl("vga_bitblt",{}) end procedure
global procedure vga_imageblt(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_imageblt",parms) end procedure
global procedure vga_fillblt(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_fillblt",parms) end procedure
global procedure vga_hlinelistblt(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_hlinelistblt",parms) end procedure
global procedure vga_blitwait() retval = cdecl("vga_blitwait",{}) end procedure
global function vga_ext_set(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_ext_set",parms) return retval end function
global function vga_accel(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_accel",parms) return retval end function
global function vga_initcursor(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_initcursor",parms) return retval end function
global procedure vga_showcursor(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_showcursor",parms) end procedure
global procedure vga_setcursorposition(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_setcursorposition",parms) end procedure
global procedure vga_selectcursor(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_selectcursor",parms) end procedure
global procedure vga_setcursorimage(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_setcursorimage",parms) end procedure
global function vga_addtiming(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_addtiming",parms) return retval end function
global function vga_changetiming(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_changetiming",parms) return retval end function
global function vga_getcurrenttiming(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_getcurrenttiming",parms) return retval end function
global function vga_addmode(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_addmode",parms) return retval end function
global function vga_guesstiming(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_guesstiming",parms) return retval end function
global function vga_waitevent(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_waitevent",parms) return retval end function
global procedure vga_runinbackground(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("vga_runinbackground",parms) end procedure
global function vga_runinbackground_version() retval = cdecl("vga_runinbackground_version",{}) return retval end function
global function mouse_init(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("mouse_init",parms) return retval end function
global function mouse_init_return_fd(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("mouse_init_return_fd",parms) return retval end function
global procedure mouse_seteventhandler(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("mouse_seteventhandler",parms) end procedure
global procedure mouse_close() retval = cdecl("mouse_close",{}) end procedure
global function mouse_update() retval = cdecl("mouse_update",{}) return retval end function
global procedure mouse_waitforupdate() retval = cdecl("mouse_waitforupdate",{}) end procedure
global procedure mouse_setdefaulteventhandler() retval = cdecl("mouse_setdefaulteventhandler",{}) end procedure
global procedure mouse_setposition(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("mouse_setposition",parms) end procedure
global procedure mouse_setposition_6d(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("mouse_setposition_6d",parms) end procedure
global procedure mouse_setxrange(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("mouse_setxrange",parms) end procedure
global procedure mouse_setyrange(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("mouse_setyrange",parms) end procedure
global procedure mouse_setrange_6d(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("mouse_setrange_6d",parms) end procedure
global procedure mouse_setscale(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("mouse_setscale",parms) end procedure
global procedure mouse_setwrap(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("mouse_setwrap",parms) end procedure
global function mouse_getx() retval = cdecl("mouse_getx",{}) return retval end function
global function mouse_gety() retval = cdecl("mouse_gety",{}) return retval end function
global procedure mouse_getposition_6d(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("mouse_getposition_6d",parms) end procedure
global function mouse_getbutton() retval = cdecl("mouse_getbutton",{}) return retval end function
global function keyboard_init() retval = cdecl("keyboard_init",{}) return retval end function
global function keyboard_init_return_fd() retval = cdecl("keyboard_init_return_fd",{}) return retval end function
global procedure keyboard_seteventhandler(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("keyboard_seteventhandler",parms) end procedure
global procedure keyboard_close() retval = cdecl("keyboard_close",{}) end procedure
global function keyboard_update() retval = cdecl("keyboard_update",{}) return retval end function
global procedure keyboard_waitforupdate() retval = cdecl("keyboard_waitforupdate",{}) end procedure
global procedure keyboard_setdefaulteventhandler() retval = cdecl("keyboard_setdefaulteventhandler",{}) end procedure
global function keyboard_getstate() retval = cdecl("keyboard_getstate",{}) return retval end function
global procedure keyboard_clearstate() retval = cdecl("keyboard_clearstate",{}) end procedure
global procedure keyboard_translatekeys(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("keyboard_translatekeys",parms) end procedure
global function keyboard_keypressed(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("keyboard_keypressed",parms) return retval end function
--
global procedure joystick_close(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("joystick_close",parms) end procedure
global procedure joystick_sethandler(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("joystick_sethandler",parms) end procedure
global procedure joystick_setdefaulthandler(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("joystick_setdefaulthandler",parms) end procedure
global function joystick_init(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("joystick_init",parms) return retval end function
global function joystick_getnumaxes(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("joystick_getnumaxes",parms) return retval end function
global function joystick_getnumbuttons(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("joystick_getnumbuttons",parms) return retval end function
global function joystick_getaxis(object parms) if atom(parms) then parms = {parms} end if retval = cdecl("joystick_getaxis",parms) return retval end function
global function joystick_update() retval = cdecl("joystick_update",{}) return retval end function
--=========================================================================--
--=========================================================================--
--
-- Use this function to get information about the mouse without depending on
--  mouse types known when your app was made. The weirdness is so that you
--  don't need to depend on having svgalib 1.3.0; as long as you don't depend
--  on other features your app should be able to work with older versions too,
--  just without this info... In a future version this will be made a real
--  function. Returns 0 on success or -1 on failure. --
--    static inline int mouse_getcaps(struct MouseCaps *caps)
--    {
--         mouse_setposition_6d(MOUSE_WANTCAPS,0,0, 0,0,0, MOUSE_CAPS);
--         mouse_getposition_6d(&(caps->key), &(caps->buttons), &(caps->axes),
--                              &(caps->info), &(caps->reserved0), &(caps->reserved1));
--         return ((caps->key == MOUSE_GOTCAPS) ? (0) : (-1));
--     }

-- You have declare the predefined structure -- "struct MouseCaps *caps"
-- BEFORE using this function like this:
-- constant caps = cdecl("MouseCaps")
--
global
function mouse_getcaps( pointer caps )
--
  mouse_setposition_6d({MOUSE_WANTCAPS,0,0, 0,0,0, MOUSE_CAPS})

  mouse_getposition_6d({ grab(caps,"key"), grab(caps,"buttons"),
			    grab(caps,"axes"), grab(caps,"info"),
			    grab(caps,"reserved0"), grab(caps,"reserved1")})
  if ( grab(caps,"key") = MOUSE_GOTCAPS ) then return 0 else return -1 end if
--
end function
--
--
-- #define __GLASTMODE G400x600x16M32
-- #define GLASTMODE vga_lastmodenumber()
--
global
function GLASTMODE()
--
  return vga_lastmodenumber()
--
end function
--
--=========================================================================--
--=========================================================================--

-- ==========================================================================

global
function video_config()
-- return sequence of information on video configuration
-- {color?, mode, text lines, text columns, xpixels, ypixels, #colors, pages}
--
sequence VC

  VC = repeat(0, 8)
  if GRAPHICS then
    VC[1] = True
    VC[2] = vga_getcurrentmode()
    VC[3] = floor(vga_getydim()/active_font_height)
    VC[4] = floor(vga_getxdim()/active_font_width)
    VC[5] = vga_getxdim()
    VC[6] = vga_getydim()
    VC[7] = vga_getcolors()
    VC[8] = 1
    return VC
  else
    return machine_func(M_VIDEO_CONFIG, 0)
  end if
--
end function

-- initialize to a known mode
  ok = vga_init()
  ok = graphics_mode(TEXT)
--

-- type declarations from graphics.e
type mode(integer x)
    return (x >= -3 and x <= 19) or (x >= 256 and x <= 263)
end type

type color(integer x)
    return x >= 0 and x <= 255
end type

type boolean(integer x)
    return x = 0 or x = 1
end type

type positive_int(integer x)
    return x >= 1
end type

type point(sequence x)
    return length(x) = 2
end type

type multi_point(sequence x)
    return length(x) = 2 or length(x) = 3
end type

type point_sequence(sequence x)
    return length(x) >= 2
end type

function old_get_key()
--
  return get_key()
--
end function

procedure old_clear_screen()
--
  clear_screen()
--
end procedure

procedure old_position(integer line, integer col)
--
  position(line, col)
--
end procedure

procedure old_puts(integer fn, object text)
--
  puts(fn, text)
--
end procedure

procedure old_printf(integer fn, sequence format, object x)
--
  printf(fn, format, x)
--
end procedure

function old_gets(integer fn)
--
  return gets(fn)
--
end function

without warning -- shuts off built-in complaint

global
procedure pixel(object col, sequence s) -- same as DOS built-in
--
  if atom(col) then
    vga_setcolor(col)
    ok = vga_drawpixel({s[1],s[2]})
  else
    poke(internal_scanseg, col)
    ok = vga_drawscansegment({internal_scanseg,s[1],s[2],length(col)})
  end if
--
end procedure

global
function get_pixel(sequence s)
--
  sequence ret_s ret_s = {}

  if length(s) = 2 then
    return vga_getpixel({s[1],s[2]})
  elsif length(s) = 3 then
    for i = 0 to s[3] - 1 do
      ret_s &= vga_getpixel({s[1]+i,s[2]})
    end for
    return ret_s
  else return -1
  end if
--
end function

constant
  linux_key_table = {
   10, -- cr
  263, -- backspace
  331, -- insert
  262, -- home
  339, -- pageup
  330, -- delete
  360, -- end
  338, -- pagedown
  259, -- uparrow
  260, -- leftarrow
  258, -- downarrow
  261, -- rightarrow
  265, -- F1
  275, -- shift F1
  266, -- F2
  276, -- shift F2
  267, -- F3
  277, -- shift F3
  268, -- F4
  278, -- shift F4
  269, -- F5
  279, -- shift F5
  270, -- F6
  280, -- shift F6
  271, -- F7
  281, -- shift F7
  272, -- F8
  282, -- shift F8
  273, -- F9
  283, -- shift F9
  274, -- F10
  284}, -- shift F10

  dos_key_table = {
    13,8,338,327,329,339,335,337,328,331,336,333,315,340,316,341,317,342,318,
    343,319,344,320,345,321,321,322,347,323,348,324,349 }

global atom USE_DOS_KEYS
  USE_DOS_KEYS = False

global
function get_key()
--
integer key, ptr
--
  key = old_get_key()

  if USE_DOS_KEYS then
    ptr = find(key,linux_key_table)
    if ptr then
      key = dos_key_table[ptr]
    end if
  end if
  return key
--
end function

global
procedure clear_screen()
--
  if GRAPHICS then
    ok = vga_clear()
  else
    old_clear_screen()
  end if
--
end procedure

global
procedure position(integer line, integer col)
--
  integer newline, newcol
  if GRAPHICS then
    if line*active_font_height > vga_getydim() or
       col*active_font_width  > vga_getxdim()  then
       error(1,"Position Line: %d Column: %d is off the screen !",{line,col})
       abort(1)
    else
      internal_line = line
      internal_col  = col
    end if
  else
    old_position(line,col)
  end if
--
end procedure

with warning -- turn warning back on back on

global
procedure gwrite( sequence font, sequence text, integer x, integer y,
		  integer fc, integer bc, integer hsize, integer vsize )
--
  sequence pix
  integer char, byte, bit, p, cr_flag

  cr_flag = False
  if length(text) = 1 and text[1] = 10 then
    position(internal_line +1, 1)
    return
  end if
  p = 1                                              -- initialize text ptr
  while p != length(text) + 1 do                     -- while text
    if text[p] = '\n' then                           -- cr ?
      cr_flag = True
    else                                             --
      char = text[p]*hsize+1                         -- get font offset
      for v = 0 to vsize - 1  do                     -- for each scanline
	byte = font[char+v]                          -- get scanline byte
	pix = reverse(int_to_bits(byte,hsize))       -- convert to bits
	bit = hsize                                  -- need to use reverse
	while bit do                                 -- for each pixel
	  if pix[bit] then                           -- test next bit
	    vga_setcolor(fc)                         -- set color
	    ok = vga_drawpixel({x+bit,y+v})          -- yes -- set pixel
	  else                                       -- change background ?
	    if bc != CLEAR then                      -- clear background
	      vga_setcolor(bc)                       -- set bk color
	      ok = vga_drawpixel({x+bit,y+v})        -- yes -- set pixel
	    end if                                   --
	  end if                                     --
	  bit -= 1                                   -- advance 1 bit
	end while                                    -- next bit
      end for                                        -- next scanline
    end if                                           --
    if cr_flag then                                  -- check for cr
      if y+vsize+1 >= vga_getydim() then             -- bottom of screen ?
	internal_line = 1 internal_col = 1           -- yes go top of screen
	x = 0 y = 0                                  -- update position
      else                                           -- else
	internal_line += 1                           -- yes go down a line
	internal_col = 1                             --
	x = 0                                        -- update position
	y += vsize                                   --
      end if                                         --
      cr_flag = False                                -- reset cr flag
    elsif WRAP then                                  -- wrap ?
      if x+hsize >= vga_getxdim() then               -- move down or top ?
	if y+vsize+1 >= vga_getydim() then           -- bottom of screen ?
	  internal_line = 1 internal_col = 1         -- yes go top of screen
	  x = 0 y = 0                                -- update position
	else                                         -- else
	  internal_line += 1 internal_col = 1        -- yes go down a line
	  x = 0                                      -- update position
	end if                                       --
      else                                           -- else
	internal_col += 1                            -- update position
	x += hsize                                   -- next print position
      end if                                         --
    else -- truncate                                 -- no wrap, truncate
      if x+hsize >= vga_getxdim() then               -- move down or top ?
	if y+vsize >= vga_getydim() then             -- bottom of screen ?
	  internal_line = 1 internal_col = 1         -- yes go top of screen
	  return                                     -- and exit
	else                                         -- else
	  internal_line += 1 internal_col = 1        -- yes go down a line
	  return                                     -- and exit
	end if                                       --
      else                                           -- else
	internal_col += 1                            -- update position
	x += hsize                                   -- next print position
      end if                                         --
    end if                                           --
    p += 1                                           -- update text pointer
  end while                                          -- next text chararacter
--
end procedure

without warning -- shuts off built-in complaint

global
procedure puts(integer fn, object text)
--
  if GRAPHICS and fn = 1 then

    gwrite(active_font, sprintf("%s", {text}),
	  (internal_col*active_font_width)-active_font_width,
	  (internal_line*active_font_height+1)-active_font_height,
	   internal_text_color, internal_bkcolor, active_font_width,
	   active_font_height)
  else
    old_puts(fn, text)
  end if
--
end procedure

global
procedure printf(integer fn, sequence format, object x)
--
  if GRAPHICS and fn = 1 then

    gwrite(active_font, sprintf(format, x),
	  (internal_col*active_font_width)-active_font_width,
	  (internal_line*active_font_height+1)-active_font_height,
	   internal_text_color, internal_bkcolor, active_font_width,
	   active_font_height)
  else
    old_printf(fn, format, x)
  end if
--
end procedure

global
function gets(integer fn)
--
  sequence text
  atom c

  text ={}
  if GRAPHICS and fn = 0 then
    c = wait_key()
    while c != '\n' do
      puts(1,{c})
      text &= c
      c = wait_key()
    end while
    puts(1,'\n')
    text &= '\n'
    return text
  else
    return old_gets(fn)
  end if
--
end function

with warning -- turn warning back on back on

global procedure text_color(color c)
-- set the foreground text color to c - text or graphics modes
-- add 16 to get blinking
--
  if GRAPHICS then
    internal_text_color = c
  else
    internal_text_color = c
    machine_proc(M_SET_T_COLOR, c)
  end if
--
end procedure

-- cursor styles:
global constant NO_CURSOR       = #2000,
	 UNDERLINE_CURSOR       = #0607,
	 THICK_UNDERLINE_CURSOR = #0507,
	 HALF_BLOCK_CURSOR      = #0407,
	 BLOCK_CURSOR           = #0007

global procedure cursor(integer style)
-- choose a cursor style
  if not GRAPHICS then
    machine_proc(M_CURSOR, style)
  end if
end procedure

global function get_position()
-- return {line, column} of current cursor position
  if GRAPHICS then
    return {internal_line,internal_col}
  else
    return machine_func(M_GET_POSITION, 0)
  end if
--
end function

global function text_rows(positive_int rows)
  if not GRAPHICS then
    return machine_func(M_TEXTROWS, rows)
  end if
end function

global procedure wrap(boolean on)
-- on = 1: characters will wrap at end of long line
-- on = 0: lines will be truncated
  if GRAPHICS then
    if on then WRAP = 1 else WRAP = 0 end if
  else
    machine_proc(M_WRAP, on)
  end if
end procedure

global procedure scroll(integer amount,
			positive_int top_line,
			positive_int bottom_line)
-- scroll lines of text on screen between top_line and bottom_line
-- amount > 0: scroll text up by amount lines
-- amount < 0: scroll text down by amount lines
-- (had only the first parameter in v1.2)
  if not GRAPHICS then
    machine_proc(M_SCROLL, {amount, top_line, bottom_line})
  end if
end procedure

constant internal_rgb = allocate(12)

global procedure bk_color(color c)
-- set the background color to c - text or graphics modes
--
  if GRAPHICS then
    ok = vga_getpalvec({c,1,internal_rgb})
    ok = vga_setpalvec({0,1,internal_rgb})
  else
    machine_proc(M_SET_B_COLOR, c)
  end if
end procedure

type mixture(sequence s)
    return length(s) = 3 -- {red, green, blue}
end type

global function palette(color c, mixture s)
-- choose a new mix of {red, green, blue} to be shown on the screen for
-- color number c. Returns previous mixture as {red, green, blue}.
  return vga_setpalette({c, s[1], s[2], s[3]})
end function

global procedure all_palette(sequence s)
-- s is a sequence of the form: {{r,g,b},{r,g,b}, ...{r,g,b}}
-- that specifies new color intensities for the entire set of
-- colors in the current graphics mode.
  for i = 1 to length(s) do
    ok = vga_setpalette({i-1, s[i][1], s[i][2], s[i][3]})
  end for
end procedure

-- Sound Effects --

global procedure sound(integer f)
-- turn on speaker at frequency f
-- turn off speaker if f is 0
  if not GRAPHICS then
    machine_proc(M_SOUND, f)
  end if
--
end procedure

-- ==========================================================================
-- ==========================================================================

global
procedure draw_line(integer c, sequence xyarray)
-- draw a line connecting the 2 or more points
-- in xyarray: {{x1, y1}, {x2, y2}, ...}
-- using a certain color
--
  vga_setcolor(c)
  for i = 1 to length(xyarray)- 1 do
    ok = vga_drawline({xyarray[i][1],xyarray[i][2],xyarray[i+1][1],
    xyarray[i+1][2]})
  end for
--
end procedure

-- Bresenham's
global
procedure polygon( integer color, integer fill, sequence xyarray )
-- draw a polygon using a certain color
-- fill the area if fill is TRUE
-- 3 or more vertices are given in xyarray
--
sequence paper, hline
atom a,b,c,d,u,s,v,d1x,d1y,d2x,d2y,m,n,
     startx,ptr,mark,pxmax,pymax

  mark = 1
  vga_setcolor(color)
  if length(xyarray) < 3 then return
  elsif not equal(xyarray[1],xyarray[length(xyarray)]) then
    xyarray = append(xyarray,xyarray[1])
  end if
  pxmax = vga_getxdim()+1
  pymax = vga_getydim()+1
  mem_set(internal_scanseg,color,pxmax)
  paper = repeat(repeat(0,pxmax),pymax)
--===========================================================================
  for j = 1 to length(xyarray) - 1 do
    c = xyarray[j][1]
    d = xyarray[j][2]
    ok = vga_drawpixel({c,d})
    a = xyarray[j+1][1]
    b = xyarray[j+1][2]

    u   = c-a
    v   = d-b
    d1x = SGN(u)
    d1y = SGN(v)
    d2x = SGN(u)
    d2y = 0
    m   = ABS(u)
    n   = ABS(v)
    if (m<=n) then
      d2x = 0
      d2y = SGN(v)
      m   = ABS(v)
      n   = ABS(u)
    end if
    s = (m / 2)
    for i = 0 to ROUND(m)-1 do
      if fill then
	if a < 0 then a = 0 end if
	if b < 0 then b = 0 end if
	if a >= pxmax-2 then a = pxmax-3 end if
	if b >= pymax-2 then b = pymax-3 end if
	paper[b+1][a+1] = mark
      else
	ok = vga_drawpixel({a,b})
      end if
      s += n
      if (s >= m) then
	s -= m
	a += d1x
	b += d1y
      else
	a += d2x
	b += d2y
      end if
    end for
  end for
  if not fill then return end if
--===========================================================================
  for yy = 1 to pymax do                        -- for each y
    hline = paper[yy]                           --
    startx = 1                                  -- set to begining of line
    while True do                               -- loop
      ptr = find(mark,hline[startx..length(hline)]) -- get next scan segment
      startx += ptr                             -- move to next dot
      if not ptr then exit end if               -- skip empty line
      if hline[startx+1] = mark then            -- next dot true ?
	ptr = find(0,hline[startx+1..length(hline)])-1                                    --
	ok = vga_drawscansegment({internal_scanseg,startx-2,yy-1,ptr+2}) -- draw dot
      else                                              --
	ptr = find(mark,hline[startx+1..length(hline)]) -- find end of segment
	if not ptr then exit end if                     -- only one pixel
	ok = vga_drawscansegment({internal_scanseg,startx-2,yy-1,ptr+2}) -- draw dot
      end if                                            --
      startx += ptr+1                                   -- skip to next
    end while                                           --
  end for                                               --
--
end procedure

-- Bresenham's ellipse with or without fill
global
procedure ellipse( integer col, integer fill, sequence s1, sequence s2 )
--
  integer a, b, xc, yc, x,y,a2,b2, s, t

  s1[1] = ROUND(ABS(s1[1]))
  s1[2] = ROUND(ABS(s1[2]))
  s2[1] = ROUND(ABS(s2[1]))
  s2[2] = ROUND(ABS(s2[2]))
  mem_set(internal_scanseg,col,vga_getxdim())
  vga_setcolor(col)
  -- convert from Euphoria convention
  xc = floor(((s2[1]-s1[1])/2)+s1[1])
  yc = floor(((s2[2]-s1[2])/2)+s1[2])
  a = xc-s1[1]
  b = yc-s1[2]
  a2 = a*a
  b2 = b*b
  x = 0
  y = b
  s = a2*(1-2*b) + 2*b2
  t = b2 - 2*a2*(2*b-1)
  while 1 do
    if (s<0) then
      s += 2*b2*(2*x+3)
      t += 4*b2*(x+1)
      x += 1
    elsif (t<0) then
      s += 2*b2*(2*x+3) - 4*a2*(y-1)
      t += 4*b2*(x+1) - 2*a2*(2*y-3)
      x += 1
      y -= 1
    else
      s -= 4*a2*(y-1)
      t -= 2*a2*(2*y-3)
      y -= 1
    end if
    ok = vga_drawpixel({+x+xc, +y+yc}) ok = vga_drawpixel({-x+xc, +y+yc})
    ok = vga_drawpixel({-x+xc, -y+yc}) ok = vga_drawpixel({+x+xc, -y+yc})

    if fill then
      ok = vga_drawscansegment({internal_scanseg,xc-x,yc+y,(xc+x)-(xc-x)})
      ok = vga_drawscansegment({internal_scanseg,xc-x,yc-y,(xc+x)-(xc-x)})
    end if
    if y <= 0 then exit end if
  end while
--
end procedure

global
procedure Hyperbeli(integer x,integer y,object a,object b,integer col)
--
  integer xx,lx lx=a

  for i = 0 to b do
    xx=floor(sqrt((a*a)*((b*b)+(i*i))))
    xx=floor(xx/b)
    vga_setcolor(col)
    ok = vga_drawline({x+xx,y+i, lx+x+3,y+i})
    ok = vga_drawline({x+xx,y-i, lx+x+3,y-i})
    ok = vga_drawline({x-xx,y+i,-lx+x-3,y+i})
    ok = vga_drawline({x-xx,y-i,-lx+x-3,y-i})
    lx=xx
  end for
--
end procedure

-- ==========================================================================
-- ==========================================================================
-- IMAGE.E
-- ==========================================================================
-- ==========================================================================
-- Graphical Image routines
-- ==========================================================================

constant BMPFILEHDRSIZE = 14
constant OLDHDRSIZE = 12, NEWHDRSIZE = 40
constant EOF = -1

-- error codes returned by read_bitmap(), save_bitmap() and save_screen()
global constant BMP_SUCCESS = 0,
		BMP_OPEN_FAILED = 1,
		BMP_UNEXPECTED_EOF = 2,
		BMP_UNSUPPORTED_FORMAT = 3,
		BMP_INVALID_MODE = 4

integer fn, error_code

function get_word()
-- read 2 bytes
    integer lower, upper

    lower = getc(fn)
    upper = getc(fn)
    if upper = EOF then
	error_code = BMP_UNEXPECTED_EOF
    end if
    return upper * 256 + lower
end function

function get_dword()
-- read 4 bytes
    integer lower, upper

    lower = get_word()
    upper = get_word()
    return upper * 65536 + lower
end function

function get_c_block(integer num_bytes)
-- read num_bytes bytes
    sequence s

    s = repeat(0, num_bytes)
    for i = 1 to num_bytes do
	s[i] = getc(fn)
    end for
    if s[length(s)] = EOF then
	error_code = BMP_UNEXPECTED_EOF
    end if
    return s
end function

function get_rgb(integer set_size)
-- get red, green, blue palette values
    integer red, green, blue

    blue = getc(fn)
    green = getc(fn)
    red = getc(fn)
    if set_size = 4 then
	if getc(fn) then
	end if
    end if
    return {red, green, blue}
end function

function get_rgb_block(integer num_dwords, integer set_size)
-- reads palette
    sequence s

    s = {}
    for i = 1 to num_dwords do
	s = append(s, get_rgb(set_size))
    end for
    if s[length(s)][3] = EOF then
	error_code = BMP_UNEXPECTED_EOF
    end if
    return s
end function

function row_bytes(atom BitCount, atom Width)
-- number of bytes per row of pixel data
    return floor(((BitCount * Width) + 31) / 32) * 4
end function

function unpack(sequence image, integer BitCount, integer Width, integer Height)
-- unpack the 1-d byte sequence into a 2-d sequence of pixels
    sequence pic_2d, row, bits
    integer bytes, next_byte, byte

    pic_2d = {}
    bytes = row_bytes(BitCount, Width)
    next_byte = 1
    for i = 1 to Height do
	row = {}
	if BitCount = 1 then
	    for j = 1 to bytes do
		byte = image[next_byte]
		next_byte += 1
		bits = repeat(0, 8)
		for k = 8 to 1 by -1 do
		    bits[k] = and_bits(byte, 1)
		    byte = floor(byte/2)
		end for
		row &= bits
	    end for
	elsif BitCount = 2 then
	    for j = 1 to bytes do
		byte = image[next_byte]
		next_byte += 1
		bits = repeat(0, 4)
		for k = 4 to 1 by -1 do
		    bits[k] = and_bits(byte, 3)
		    byte = floor(byte/4)
		end for
		row &= bits
	    end for
	elsif BitCount = 4 then
	    for j = 1 to bytes do
		byte = image[next_byte]
		row = append(row, floor(byte/16))
		row = append(row, and_bits(byte, 15))
		next_byte += 1
	    end for
	elsif BitCount = 8 then
	    row = image[next_byte..next_byte+bytes-1]
	    next_byte += bytes
	else
	    error_code = BMP_UNSUPPORTED_FORMAT
	    exit
	end if
	pic_2d = prepend(pic_2d, row[1..Width])
    end for
    return pic_2d
end function

global function read_bitmap(sequence file_name)
-- read a bitmap (.BMP) file into a 2-d sequence of sequences (image)
-- return {palette,image}
    atom Size
    integer Type, Xhot, Yhot, Planes, BitCount
    atom Width, Height, Compression, OffBits, SizeHeader,
	 SizeImage, XPelsPerMeter, YPelsPerMeter, ClrUsed,
	 ClrImportant, NumColors
    sequence Palette, Bits, two_d_bits

    error_code = 0
    fn = open(file_name, "rb")
    if fn = -1 then
	return BMP_OPEN_FAILED
    end if
    Type = get_word()
    Size = get_dword()
    Xhot = get_word()
    Yhot = get_word()
    OffBits = get_dword()
    SizeHeader = get_dword()

    if SizeHeader = NEWHDRSIZE then
	Width = get_dword()
	Height = get_dword()
	Planes = get_word()
	BitCount = get_word()
	Compression = get_dword()
	if Compression != 0 then
	    close(fn)
	    return BMP_UNSUPPORTED_FORMAT
	end if
	SizeImage = get_dword()
	XPelsPerMeter = get_dword()
	YPelsPerMeter = get_dword()
	ClrUsed = get_dword()
	ClrImportant = get_dword()
	NumColors = (OffBits - SizeHeader - BMPFILEHDRSIZE) / 4
	if NumColors < 2 or NumColors > 256 then
	    close(fn)
	    return BMP_UNSUPPORTED_FORMAT
	end if
	Palette = get_rgb_block(NumColors, 4)

    elsif SizeHeader = OLDHDRSIZE then
	Width = get_word()
	Height = get_word()
	Planes = get_word()
	BitCount = get_word()
	NumColors = (OffBits - SizeHeader - BMPFILEHDRSIZE) / 3
	SizeImage = row_bytes(BitCount, Width) * Height
	Palette = get_rgb_block(NumColors, 3)
    else
	close(fn)
	return BMP_UNSUPPORTED_FORMAT
    end if
    if Planes != 1 or Height <= 0 or Width <= 0 then
	close(fn)
	return BMP_UNSUPPORTED_FORMAT
    end if
    Bits = get_c_block(row_bytes(BitCount, Width) * Height)
    close(fn)
    two_d_bits = unpack(Bits, BitCount, Width, Height)
    if error_code then
	return error_code
    end if
    return {Palette, two_d_bits}
end function

type graphics_point(sequence p)
    return length(p) = 2 and p[1] >= 0 and p[2] >= 0
end type

type text_point(sequence p)
    return length(p) = 2 and p[1] >= 1 and p[2] >= 1
	   and p[1] <= 200 and p[2] <= 500 -- rough sanity check
end type

--------------------------

global procedure display_image(graphics_point xy, sequence pixels)
-- display a 2-d sequence of pixels at location xy
-- N.B. coordinates are {x, y} with {0,0} at top left of screen
-- and x values increasing towards the right,
-- and y values increasing towards the bottom of the screen
--                   {x,y} scanline
  pointer colors
  colors = allocate(2048)

  for i = 1 to length(pixels) do
		poke(colors,pixels[i])
		ok = vga_drawscansegment({colors,xy[1],xy[2],length(pixels[i])})
	  xy[2] = xy[2] + 1
  end for
  free(colors)
--
end procedure

global function save_image(graphics_point top_left, graphics_point bottom_right)
-- Save a rectangular region on a graphics screen,
-- given the {x, y} coordinates of the top-left and bottom-right
-- corner pixels. The result is a 2-d sequence of pixels suitable
-- for use in display_image() above.
  pointer colors
  sequence save
  int width

  save = {}
  width = bottom_right[1] - top_left[1] + 1
  colors = allocate(2048)
  for y = top_left[2] to bottom_right[2] do
    ok = vga_getscansegment({colors,top_left[1],y,width})
    save = append(save, peek({colors,width}))
  end for
  free(colors)
  return save
--
end function

--------------------------

constant COLOR_TEXT_MEMORY = #B8000,
	  MONO_TEXT_MEMORY = #B0000

constant M_GET_DISPLAY_PAGE = 28,
	 M_SET_DISPLAY_PAGE = 29,
	 M_GET_ACTIVE_PAGE = 30,
	 M_SET_ACTIVE_PAGE = 31

constant BYTES_PER_CHAR = 2

type page_number(integer p)
    return p >= 0 and p <= 7
end type

global function get_display_page()
-- return current page# mapped to the monitor
    return machine_func(M_GET_DISPLAY_PAGE, 0)
end function

global procedure set_display_page(page_number page)
-- select a page to be displayed
    machine_proc(M_SET_DISPLAY_PAGE, page)
end procedure

global function get_active_page()
-- return current page# that screen output is sent to
    return machine_func(M_GET_ACTIVE_PAGE, 0)
end function

global procedure set_active_page(page_number page)
-- select a page for screen output
    machine_proc(M_SET_ACTIVE_PAGE, page)
end procedure

constant M_GET_SCREEN_CHAR = 58,
	 M_PUT_SCREEN_CHAR = 59

type positive_atom(atom x)
    return x >= 1
end type

function DOS_scr_addr(sequence vc, text_point xy)
-- calculate address in DOS screen memory for a given line, column
    atom screen_memory
    integer page_size

    if vc[VC_MODE] = 7 then
	screen_memory = MONO_TEXT_MEMORY
    else
	screen_memory = COLOR_TEXT_MEMORY
    end if
    page_size = vc[VC_LINES] * vc[VC_COLUMNS] * BYTES_PER_CHAR
    page_size = 1024 * floor((page_size + 1023) / 1024)
    screen_memory = screen_memory + get_active_page() * page_size
    return screen_memory + ((xy[1]-1) * vc[VC_COLUMNS] + (xy[2]-1))
			   * BYTES_PER_CHAR
end function

global function get_screen_char(positive_atom line, positive_atom column)
-- returns {character, attributes} of the single character
-- at the given (line, column) position on the screen
--
  return machine_func(M_GET_SCREEN_CHAR, {line, column})
--
end function

global procedure put_screen_char(positive_atom line, positive_atom column,
				 sequence char_attr)
-- stores {character, attributes, character, attributes, ...}
-- of 1 or more characters at position (line, column) on the screen
--
  machine_proc(M_PUT_SCREEN_CHAR, {line, column, char_attr})
--
end procedure

global procedure display_text_image(text_point xy, sequence text)
-- Display a text image at line xy[1], column xy[2] in any text mode.
-- N.B. coordinates are {line, column} with {1,1} at the top left of screen
-- Displays to the active text page.
    integer extra_col2, extra_lines
    sequence vc, one_row

    vc = video_config()
    if xy[1] < 1 or xy[2] < 1 then
	return -- bad starting point
    end if
    extra_lines = vc[VC_LINES] - xy[1] + 1
    if length(text) > extra_lines then
	if extra_lines <= 0 then
	    return -- nothing to display
	end if
	text = text[1..extra_lines] -- truncate
    end if
    extra_col2 = 2 * (vc[VC_COLUMNS] - xy[2] + 1)
    for row = 1 to length(text) do
	one_row = text[row]
	if length(one_row) > extra_col2 then
	    if extra_col2 <= 0 then
		return -- nothing to display
	    end if
	    one_row = one_row[1..extra_col2] -- truncate
	end if
	-- Linux
	machine_proc(M_PUT_SCREEN_CHAR, {xy[1]+row-1, xy[2], one_row})
    end for
end procedure

global function save_text_image(text_point top_left, text_point bottom_right)
-- Copy a rectangular block of text out of screen memory,
-- given the coordinates of the top-left and bottom-right corners.
-- Reads from the active text page.
    sequence image, row_chars, vc
    integer screen_width, image_width

    vc = video_config()
    screen_width = vc[VC_COLUMNS] * BYTES_PER_CHAR
    image = {}
    image_width = (bottom_right[2] - top_left[2] + 1) * BYTES_PER_CHAR
    for row = top_left[1] to bottom_right[1] do
	-- Linux
	row_chars = {}
	for col = top_left[2] to bottom_right[2] do
	    row_chars &= machine_func(M_GET_SCREEN_CHAR, {row, col})
	end for
       image = append(image, row_chars)
    end for
    return image
end function

-- save_screen() and related functions were written by
-- Junko C. Miura of Rapid Deployment Software.

integer numXPixels, numYPixels, bitCount, numRowBytes
integer startXPixel, startYPixel, endYPixel

type region(object r)
    -- a region on the screen
    if atom(r) then
	return r = 0
    else
	return length(r) = 2 and graphics_point(r[1]) and
				 graphics_point(r[2])
    end if
end type

type two_seq(sequence s)
    -- a two element sequence, both elements are sequences
    return length(s) = 2 and sequence(s[1]) and sequence(s[2])
end type

procedure putBmpFileHeader(integer numColors)
    integer offBytes

    -- calculate bitCount, ie, color bits per pixel, (1, 2, 4, 8, or error)
    if numColors = 256 then
	bitCount = 8            -- 8 bits per pixel
    elsif numColors = 16 then
	bitCount = 4            -- 4 bits per pixel
    elsif numColors = 4 then
	bitCount = 2            -- 2 bits per pixel
    elsif numColors = 2 then
	bitCount = 1            -- 1 bit per pixel
    else
	error_code = BMP_INVALID_MODE
	return
    end if

    puts(fn, "BM")  -- file-type field in the file header
    offBytes = 4 * numColors + BMPFILEHDRSIZE + NEWHDRSIZE
    numRowBytes = row_bytes(bitCount, numXPixels)
    -- put total size of the file
    puts(fn, int_to_bytes(offBytes + numRowBytes * numYPixels))

    puts(fn, {0, 0, 0, 0})              -- reserved fields, must be 0
    puts(fn, int_to_bytes(offBytes))    -- offBytes is the offset to the start
					--   of the bitmap information
    puts(fn, int_to_bytes(NEWHDRSIZE))  -- size of the secondary header
    puts(fn, int_to_bytes(numXPixels))  -- width of the bitmap in pixels
    puts(fn, int_to_bytes(numYPixels))  -- height of the bitmap in pixels

    puts(fn, {1, 0})                    -- planes, must be a word of value 1

    puts(fn, {bitCount, 0})     -- bitCount

    puts(fn, {0, 0, 0, 0})      -- compression scheme
    puts(fn, {0, 0, 0, 0})      -- size image, not required
    puts(fn, {0, 0, 0, 0})      -- XPelsPerMeter, not required
    puts(fn, {0, 0, 0, 0})      -- YPelsPerMeter, not required
    puts(fn, int_to_bytes(numColors))   -- num colors used in the image
    puts(fn, int_to_bytes(numColors))   -- num important colors in the image
end procedure

procedure putOneRowImage(sequence x, integer numPixelsPerByte, integer shift)
-- write out one row of image data
    integer  j, byte, numBytesFilled

    x &= repeat(0, 7)   -- 7 zeros is safe enough

    numBytesFilled = 0
    j = 1
    while j <= numXPixels do
	byte = x[j]
	for k = 1 to numPixelsPerByte - 1 do
	    byte = byte * shift + x[j + k]
	end for

	puts(fn, byte)
	numBytesFilled += 1
	j += numPixelsPerByte
    end while

    for m = 1 to numRowBytes - numBytesFilled do
	puts(fn, 0)
    end for
end procedure

procedure putImage()
-- Write image data packed according to the bitCount information, in the order
-- last row ... first row. Data for each row is padded to a 4-byte boundary.
    sequence x
    integer  numPixelsPerByte, shift

    numPixelsPerByte = 8 / bitCount
    shift = power(2, bitCount)
    for i = endYPixel to startYPixel by -1 do
	x = get_pixel({startXPixel, i, numXPixels})
	putOneRowImage(x, numPixelsPerByte, shift)
    end for
end procedure

global function get_all_palette()
-- Get color intensities for the entire set of colors in the current
-- graphics mode. Returned sequence is {{r,g,b},{r,g,b},...,{r,g,b}}.
-- Intensity values are in the range 0 to 63.
--
  integer numColors
  sequence vc, ret_seq

  vc = video_config()
  numColors = vc[VC_NCOLORS]
  ret_seq = {}

  for i = 0 to numColors - 1 do
    ok = vga_getpalette({i,internal_rgb,internal_rgb+4,internal_rgb+8})
    ret_seq = append(ret_seq,{peek4u(internal_rgb),
			      peek4u(internal_rgb+4),
			      peek4u(internal_rgb+8)})
  end for
  return ret_seq
--
end function

procedure putColorTable(integer numColors, sequence pal)
-- Write color table information to the .BMP file.
-- palette data is given as a sequence {{r,g,b},..,{r,g,b}}, where each
-- r, g, or b value is 0 to 255.

    for i = 1 to numColors do
	puts(fn, pal[i][3])     -- blue first in .BMP file
	puts(fn, pal[i][2])     -- green second
	puts(fn, pal[i][1])     -- red third
	puts(fn, 0)             -- reserved, must be 0
    end for
end procedure

global function save_screen(region r, sequence file_name)
-- Capture the whole screen or a region of the screen, and create a Windows
-- bitmap (.BMP) file. The file name is given as a parameter. Region r is
-- either a sequence of 2 sequences: {{topLeftXPixel, topLeftYPixel},
-- {bottomRightXPixel, bottomRightYPixel}} defining a region,
-- or the integer 0 if you want to save the whole screen.
    sequence vc
    integer numColors

    error_code = BMP_SUCCESS
    fn = open(file_name, "wb")
    if fn = -1 then
	return BMP_OPEN_FAILED
    end if

    vc = video_config()
    if sequence(r) then
	numXPixels = r[2][1] - r[1][1] + 1
	numYPixels = r[2][2] - r[1][2] + 1
	if r[2][1] >= vc[VC_XPIXELS] or r[2][2] >= vc[VC_YPIXELS] then
	    close(fn)
	    return BMP_INVALID_MODE   -- not a valid argument
	end if
	startXPixel = r[1][1]
	startYPixel = r[1][2]
	endYPixel   = r[2][2]
    else
	numXPixels = vc[VC_XPIXELS]
	numYPixels = vc[VC_YPIXELS]
	startXPixel = 0
	startYPixel = 0
	endYPixel   = numYPixels - 1
    end if

    if numXPixels <= 0 or numYPixels <= 0 then
	-- not a valid graphics mode or not a valid argument
	close(fn)
	return BMP_INVALID_MODE
    end if

    numColors = vc[VC_NCOLORS]
    putBmpFileHeader(numColors)

    if error_code = BMP_SUCCESS then
	putColorTable(numColors, get_all_palette()*4)
    end if
    if error_code = BMP_SUCCESS then
	putImage()
    end if
    close(fn)
    return error_code
end function

procedure putImage1(sequence image)
-- Write image data packed according to the bitCount information, in the order
-- last row ... first row. Data for each row is padded to a 4-byte boundary.
-- Image data is given as a 2-d sequence in the order first row... last row.
    object   x
    integer  numPixelsPerByte, shift

    numPixelsPerByte = 8 / bitCount
    shift = power(2, bitCount)
    for i = numYPixels to 1 by -1 do
	x = image[i]
	if atom(x) then
	    error_code = BMP_INVALID_MODE
	    return
	elsif length(x) != numXPixels then
	    error_code = BMP_INVALID_MODE
	    return
	end if
	putOneRowImage(x, numPixelsPerByte, shift)
    end for
end procedure

global function save_bitmap(two_seq palette_n_image, sequence file_name)
-- Create a .BMP bitmap file, given a palette and a 2-d sequence of sequences.
-- The opposite of read_bitmap().
    sequence color, image
    integer numColors

    error_code = BMP_SUCCESS
    fn = open(file_name, "wb")
    if fn = -1 then
	return BMP_OPEN_FAILED
    end if

    color = palette_n_image[1]
    image = palette_n_image[2]
    numYPixels = length(image)
    numXPixels = length(image[1])   -- assume the same length with each row
    numColors = length(color)

    putBmpFileHeader(numColors)

    if error_code = BMP_SUCCESS then
	putColorTable(numColors, color)
	putImage1(image)
    end if
    close(fn)
    return error_code
end function

global
procedure putsxy(sequence loc, sequence text, atom fc, atom bc, atom down)
--
  integer step

  if down = 'd' then -- vertical text
    step = loc[2]
    for p = 1 to length(text) do
      gwrite(active_font, {text[p]}, loc[1], step, fc, bc,
	     active_font_width, active_font_height)
      step += active_font_height
    end for
  else               -- normal direction
    gwrite(active_font, text, loc[1], loc[2], fc, bc,
	   active_font_width, active_font_height)
  end if
--
end procedure

--==========================================================================--

		--------------------
		-- Mouse Routines --
		--------------------
--------------------------------------------------------------------------------
-- xor pointers
--------------------------------------------------------------------------------

global constant
    ARROW={{1,1},
	{8},
	{8,8},
	{8,7,8},
	{8,7,7,8},
	{8,7,7,7,8},
	{8,7,7,7,7,8},
	{8,7,7,7,7,7,8},
	{8,7,7,7,8,8,8,8},
	{8,7,8,8,8},
	{8,8,0,8,8},
	{8,0,0,0,8,8},
	{0,0,0,0,8,8},
	{0,0,0,0,0,8,8},
	{0,0,0,0,0,8,8}},

    ARROW1={{1,1},
	{8},
	{8,8},
	{8,7,8},
	{8,7,7,8},
	{8,7,7,7,8},
	{8,7,7,7,7,8},
	{8,7,7,7,7,7,8},
	{8,7,7,7,8,8,8,8},
	{8,7,8,8,8},
	{8,8,0,8,8,8},
	{8,0,0,8,8,8,8},
	{0,0,0,8}},

    TRIANGLE={{1,1},
	{8,8,8,8,8,8,8,8,8,8,8},
	{8,7,7,7,7,7,7,7,7,7},
	{8,7,7,7,7,7,7,7,7},
	{8,7,7,7,7,7,7,7},
	{8,7,7,7,7,7,7},
	{8,7,7,7,7,7},
	{8,7,7,7,7},
	{8,7,7,7},
	{8,7,7},
	{8,7},
	{8}},

    CROSSHAIR={{6,6},
	{0,0,0,0,0,8},
	{0,0,0,0,0,8},
	{0,0,0,0,0,8},
	{0,0,0,0,0,8},
	{},
	{8,8,8,8,0,0,0,8,8,8,8},
	{},
	{0,0,0,0,0,8},
	{0,0,0,0,0,8},
	{0,0,0,0,0,8},
	{0,0,0,0,0,8}},

    NOGO = {{7,7},
	{0,0,0,0,0,8,8,8,8},
	{0,0,0,8,8,5,5,5,5,8,8},
	{0,0,8,5,5,5,8,8,5,5,5,8},
	{0,8,5,5,8,8,0,0,8,5,5,5,8},
	{0,8,5,8,0,0,0,8,5,5,8,5,8},
	{8,5,5,8,0,0,8,5,5,8,8,5,5,8},
	{8,5,8,0,0,8,5,5,8,0,0,8,5,8},
	{8,5,5,8,8,5,5,8,0,0,8,5,5,8},
	{0,8,5,8,5,5,8,0,0,0,8,5,8},
	{0,8,5,5,5,8,0,0,8,8,5,5,8},
	{0,0,8,5,5,5,8,8,5,5,5,8},
	{0,0,0,8,8,5,5,5,5,8,8},
	{0,0,0,0,0,8,8,8,8}},

    RESIZE = {{9,9},
	{0,0,0,0,0,0,0,0,8},
	{0,0,0,0,0,0,0,8,7,8},
	{0,0,0,0,0,0,8,7,7,7,8},
	{0,0,0,0,0,8,7,7,7,7,7,8},
	{0,0,0,0,0,8,8,8,7,8,8,8},
	{0,0,0,8,8,0,0,8,7,8,0,0,8,8},
	{0,0,8,7,8,0,0,8,7,8,0,0,8,7,8},
	{0,8,7,7,8,8,8,8,7,8,8,8,8,7,7,8},
	{8,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,8},
	{0,8,7,7,8,8,8,8,7,8,8,8,8,7,7,8},
	{0,0,8,7,8,0,0,8,7,8,0,0,8,7,8},
	{0,0,0,8,8,0,0,8,7,8,0,0,8,8},
	{0,0,0,0,0,8,8,8,7,8,8,8},
	{0,0,0,0,0,8,7,7,7,7,7,8},
	{0,0,0,0,0,0,8,7,7,7,8},
	{0,0,0,0,0,0,0,8,7,8},
	{0,0,0,0,0,0,0,0,8}},

    IBEAM={{2,6},
	{8,8,8},
	{0,8},
	{0,8},
	{0,8},
	{0,8},
	{0,8},
	{0,8},
	{0,8},
	{0,8},
	{0,8},
	{8,8,8}},

    LTRB={{6,6},
	{8,8,8,8,8},
	{8,7,7,8},
	{8,7,7,7,8},
	{8,8,7,7,7,8},
	{8,0,8,7,7,7,8},
	{0,0,0,8,7,7,7,8},
	{0,0,0,0,8,7,7,7,8,0,8},
	{0,0,0,0,0,8,7,7,7,8,8},
	{0,0,0,0,0,0,8,7,7,7,8},
	{0,0,0,0,0,0,0,8,7,7,8},
	{0,0,0,0,0,0,8,8,8,8,8}},

    RTLB={{6,6},
	{0,0,0,0,0,0,8,8,8,8,8},
	{0,0,0,0,0,0,0,8,7,7,8},
	{0,0,0,0,0,0,8,7,7,7,8},
	{0,0,0,0,0,8,7,7,7,8,8},
	{0,0,0,0,8,7,7,7,8,0,8},
	{0,0,0,8,7,7,7,8},
	{8,0,8,7,7,7,8},
	{8,8,7,7,7,8},
	{8,7,7,7,8},
	{8,7,7,8},
	{8,8,8,8,8}},

    LR={{8,4},
	{0,0,0,8,0,0,0,0,0,0,0,8},
	{0,0,8,8,0,0,0,0,0,0,0,8,8},
	{0,8,7,8,8,8,8,8,8,8,8,8,7,8},
	{8,7,7,7,7,7,7,7,7,7,7,7,7,7,8},
	{0,8,7,8,8,8,8,8,8,8,8,8,7,8},
	{0,0,8,8,0,0,0,0,0,0,0,8,8},
	{0,0,0,8,0,0,0,0,0,0,0,8}},

    TB={{4,8},
	{0,0,0,8},
	{0,0,8,7,8},
	{0,8,7,7,7,8},
	{8,8,8,7,8,8,8},
	{0,0,8,7,8},
	{0,0,8,7,8},
	{0,0,8,7,8},
	{0,0,8,7,8},
	{0,0,8,7,8},
	{0,0,8,7,8},
	{0,0,8,7,8},
	{8,8,8,7,8,8,8},
	{0,8,7,7,7,8},
	{0,0,8,7,8},
	{0,0,0,8}},

    PENCIL={{1,1},
	{12,12,6,6,6},
	{12,6,6,6,8,6},
	{6,6,6,8,6,8,6},
	{6,6,8,8,8,6,8,6},
	{6,8,6,8,8,8,6,8,6},
	{0,6,8,6,8,8,8,6,8,6},
	{0,0,6,8,6,8,8,8,6,8,6},
	{0,0,0,6,8,6,8,8,8,6,8,6},
	{0,0,0,0,6,8,6,8,8,8,6,8,6},
	{0,0,0,0,0,6,8,6,8,8,8,6},
	{0,0,0,0,0,0,6,8,6,8,6},
	{0,0,0,0,0,0,0,6,8,6},
	{0,0,0,0,0,0,0,0,6}},


    HGLASS={{5,7},
	{8,8,8,8,8,8,8,8,8},
	{8,0,0,0,0,0,0,0,8},
	{8,0,0,0,0,0,0,0,8},
	{0,8,7,7,7,7,7,8},
	{0,0,8,7,7,7,8},
	{0,0,0,8,7,8},
	{0,0,0,0,8},
	{0,0,0,8,0,8},
	{0,0,8,0,0,0,8},
	{0,8,0,0,7,0,0,8},
	{8,0,7,7,7,7,7,0,8},
	{8,7,7,7,7,7,7,7,8},
	{8,8,8,8,8,8,8,8,8}},

    HAND={{3,1},
	{0,0,8,8,8},
	{0,0,8,0,8},
	{0,0,8,0,8},
	{0,0,8,0,8},
	{0,0,8,0,8},
	{0,0,8,0,8},
	{0,0,8,0,8,8,8,8,8,8,8},
	{0,0,8,0,8,0,8,0,8,0,8},
	{8,8,8,0,8,0,8,0,8,0,8},
	{8,0,8,0,8,0,8,0,8,0,8},
	{8,0,8,0,0,0,0,0,0,0,8},
	{8,0,8,0,0,0,0,0,0,0,8},
	{8,0,0,0,0,0,0,0,0,0,8},
	{8,0,0,0,0,0,0,0,0,0,8},
	{8,0,0,0,0,0,0,0,0,0,8},
	{8,8,8,8,8,8,8,8,8,8,8}},

    HAND1={{3,1},
	{0,0,8,8,8},
	{0,0,8,7,8},
	{0,0,8,7,8},
	{0,0,8,7,8},
	{0,0,8,7,8},
	{0,0,8,7,8},
	{0,0,8,7,8,8,8,8,8,8,8},
	{0,0,8,7,8,7,8,7,8,7,8},
	{8,8,8,7,8,7,8,7,8,7,8},
	{8,7,8,7,8,7,8,7,8,7,8},
	{8,7,8,7,7,7,7,7,7,7,8},
	{8,7,8,7,7,7,7,7,7,7,8},
	{8,7,7,7,7,7,7,7,7,7,8},
	{8,7,7,7,7,7,7,7,7,7,8},
	{8,7,7,7,7,7,7,7,7,7,8},
	{8,8,8,8,8,8,8,8,8,8,8}},

    HAND2={{3,1},
	{0,0,8,8,8},
	{0,0,8,0,8},
	{0,0,8,0,8},
	{0,0,8,0,8},
	{0,0,8,0,8},
	{0,0,8,0,8,8,8},
	{0,0,8,0,8,0,8,8,8},
	{0,0,8,0,8,0,8,0,8,8,8},
	{8,8,8,0,8,0,8,0,8,0,8},
	{8,0,8,0,0,0,0,0,8,0,8},
	{8,0,8,0,0,0,0,0,0,0,8},
	{8,0,8,0,0,0,0,0,0,0,8},
	{8,0,0,0,0,0,0,0,0,0,8},
	{8,0,0,0,0,0,0,0,0,0,8},
	{8,0,0,0,0,0,0,0,0,0,8},
	{8,8,8,8,8,8,8,8,8,8,8}}

--==========================================================================--
		--------------------
		-- Mouse Routines --
		--------------------
global constant
    MOVE = 8,
    LEFT_DOWN = MOUSE_LEFTBUTTON,
    LEFT_UP = MOUSE_LEFTBUTTON,
    RIGHT_DOWN = MOUSE_RIGHTBUTTON,
    RIGHT_UP = MOUSE_RIGHTBUTTON,
    MIDDLE_DOWN = MOUSE_MIDDLEBUTTON,
    MIDDLE_UP = MOUSE_MIDDLEBUTTON,
    ANY_UP = 7  -- LEFT, RIGHT or MIDDLE up (best you can do under xterm)

sequence
    rat_state,  -- rat_state={button_state,x,y}
    srs,
    hotspot,    -- hot spot coordinates within pointer image
    ipointer    -- 2-d pixel color pointer image

integer msemask

  msemask = #F
  hotspot = {0,0}
  srs = {0,0,0}
  rat_state = {0,0,0}
  ipointer = {}

global
function get_mouse()
-- report mouse events,
-- otherwise returns {event#, x-coord, y-coord}
integer event, x, y

  ok = mouse_update()
  x = mouse_getx()
  y = mouse_gety()
  event = mouse_getbutton()
  if srs[2] != x or srs[3] != y then event += 8 end if
  event = and_bits(msemask,event)
  return {event,x,y}
--
end function

global
procedure mouse_events(integer events)
-- select the mouse events to be reported by get_mouse()
-- e.g. mouse_events(LEFT_UP + LEFT_DOWN + RIGHT_DOWN)
  msemask = events
--
end procedure

global
procedure place_mouse(integer x, integer y)
--
--  move mouse to x,y position
--
  mouse_setposition({x,y})
--
end procedure

global
procedure trap_mouse(integer x1, integer y1, integer x2, integer y2)
--
-- confine mouse pointer to rectangle x1,y1 - x2,y2
--
    mouse_setxrange({x1,x2})
    mouse_setyrange({y1,y2})
end procedure  -- confine_rat

procedure draw_mse()
--
  sequence p
--
  p=srs[2..3]-hotspot
  for i=1 to length(ipointer) do
    pixel(xor_bits(get_pixel(p&length(ipointer[i])),ipointer[i]),p)
    p[2]=p[2]+1
  end for
--
end procedure

procedure show_mse()
-- display pointer if it is currently hidden
-- if pointer is already displayed redraw it only if it has changed location
  rat_state=get_mouse() -- get mse state
  if not srs[1] or rat_state[2]!=srs[2] or rat_state[3]!=srs[3] then
    if srs[1] then draw_mse() end if
    srs=1 & rat_state[2..3]
    draw_mse()
  end if
--
end procedure

procedure hide_mse()
  if srs[1] then draw_mse() end if
  srs[1]=0
end procedure

global
procedure set_mouse_cursor(sequence p)
  -- select new pointer defined by p
  integer flag

  flag=srs[1]         -- save mouse pointer state, shown or hidden
  hide_mse()
  hotspot=p[1]-1
  ipointer=p[2..length(p)]
  if flag then show_mse() end if   -- restore original state
end procedure

global
procedure mouse_pointer(integer show_it)
-- show (1) or hide (0) the mouse pointer
  if show_it then
    show_mse()
  else
    hide_mse()
  end if
--
end procedure

  set_mouse_cursor(ARROW)

global
function joystick_button1( integer joydev )
--
-- Used for multiple joysticks
--
  return cdecl("joystick_getbutton",{joydev,0})
--
end function

global
function joystick_button2( integer joydev )
--
-- Used for multiple joysticks
--
  return cdecl("joystick_getbutton",{joydev,1})
--
end function

global
function joystick_button3( integer joydev )
--
-- Used for multiple joysticks
--
  return cdecl("joystick_getbutton",{joydev,2})
--
end function

global
function joystick_button4( integer joydev )
--
-- Used for MULTIPLE joysticks
--
  return cdecl("joystick_getbutton",{joydev,3})
--
end function

global
function joystick_getb1()
--
-- Used for a SINGLE joysticks
--
  return cdecl("joystick_getbutton",{0,0})
--
end function

global
function joystick_getb2()
--
-- Used for a SINGLE joysticks
--
  return cdecl("joystick_getbutton",{0,1})
--
end function

global
function joystick_getb3()
--
-- Used for a SINGLE joysticks
--
  return cdecl("joystick_getbutton",{0,2})
--
end function

global
function joystick_getb4()
--
-- Used for a SINGLE joysticks
--
  return cdecl("joystick_getbutton",{0,3})
--
end function

global
function joystick_x( integer joydev )
--
-- Used for getting MULTIPLE joysticks axis's
--
  return cdecl("joystick_getaxis",{joydev,0})
--
end function

global
function joystick_y( integer joydev )
--
-- Used for getting MULTIPLE joysticks axis's
--
  return cdecl("joystick_getaxis",{joydev,1})
--
end function

global
function joystick_z( integer joydev )
--
-- Used for getting MULTIPLE joysticks axis's
--
  return cdecl("joystick_getaxis",{joydev,2})
--
end function

global
function joystick_getx( integer joydev )
--
-- Used for getting SINGLE joysticks axis's
--
  return cdecl("joystick_getaxis",{joydev,0})
--
end function

global
function joystick_gety( integer joydev )
--
-- Used for getting SINGLE joysticks axis's
--
  return cdecl("joystick_getaxis",{joydev,1})
--
end function

global
function joystick_getz( integer joydev )
--
-- Used for getting SINGLE joysticks axis's
--
  return cdecl("joystick_getaxis",{joydev,2})
--
end function

-- ==========================================================================
-- ==========================================================================
-- END ALL
-- ==========================================================================
-- ==========================================================================

